=== modified file 'NEWS'
--- NEWS	2010-07-13 16:21:59 +0000
+++ NEWS	2010-08-15 04:52:51 +0000
@@ -5,11 +5,246 @@
 .. contents:: List of Releases
    :depth: 1
 
+bzr 2.3b1
+#########
+
+:Codename: ???
+:2.3b1: NOT RELEASED YET
+
+Compatibility Breaks
+********************
+
+* BzrError subclasses no longer support the name "message" to be used
+  as an argument for __init__ or in _fmt format specification as this
+  breaks in some Python versions. errors.LockError.__init__ argument
+  is now named "msg" instead of earlier "message".
+  (Parth Malwankar, #603461)
+
+* `FileInWrongBranch` is deprecated in favour of `PathNotChild` and no
+  longer raised.
+  (Martin Pool)
+
+* `tree_files` and `internal_tree_files` are now deprecated in favor of
+  `WorkingTree.open_containing_paths`.
+  (Martin Pool)
+
+* The old ``bzr selftest --benchmark`` option has been removed.
+  <https://launchpad.net/bzr-usertest> is an actively-maintained
+  macrobenchmark suite.
+  (Martin Pool)
+
+New Features
+************
+
+* The ``lp:`` prefix will now use your known username (from
+  ``bzr launchpad-login``) to expand ``~`` to your username.  For example:
+  ``bzr launchpad-login user && bzr push lp:~/project/branch`` will now
+  push to ``lp:~user/project/branch``.  (John Arbash Meinel)
+
+Bug Fixes
+*********
+
+* Check if both --diff-options and --using are set, and exit with error
+  in this case. (Matthäus G. Chajdas, #234708)
+
+* Decrease peak memory during ``bzr send``. The old code was caching all
+  text content and all inventory strings for all revisions before
+  computing the diffs. Now we only cache as long as there is a child that
+  will need them. Sending 2000 bzr revisions drops from 1.2GB peak to
+  256MB peak. (John Arbash Meinel, #614576)
+
+* Don't print internal object name when print an invalid revision spec
+  error.  (Neil Martinsen-Burrell, #598701)
+
+* ``HTTP/1.1` test servers now set a ``Content-Length`` header to comply
+  with pedantic ``HTTP/1.1`` clients. (Vincent Ladeuil, #568421)
+
+* `PathNotChild` should not give a traceback.
+  (Martin Pool, #98735)
+
+* Prevent ``CHKMap.apply_delta`` from generating non-canonical CHK maps,
+  which can result in "missing referenced chk root keys" errors when
+  fetching from repositories with affected revisions.
+  (Andrew Bennetts, #522637)
+
+* ``Transport.stat`` on a symlink, including a transport pointing directly
+  to a symlink, now returns information about the symlink.
+  (Martin Pool)
+
+Improvements
+************
+
+* ``bzr remove`` now just backs up changed files instead of exiting,
+  forcing you to choose to either keep or delete them. Bazaar will now delete
+  the files if they can easily be recovered using revert, otherwise they
+  will be backed up (adding an extention of the form .~#~).
+  (Marius Kruger, #400554)
+
+* Inventory entries now consume less memory (on 32-bit Ubuntu file entries
+  have dropped from 68 bytes to 40, and directory entries from 120 bytes
+  to 48).  (Andrew Bennetts)
+
+* When building new working trees, default to reading from the repository
+  rather than the source tree unless explicitly requested. (via
+  ``--files-from`` and ``--hardlink`` for ``bzr branch`` and
+  ``bzr checkout``. Generally, 2a format repositories extract
+  content faster than seeking and reading content from another tree,
+  especially in cold-cache situations. (John Arbash Meinel, #607298)
+
+Documentation
+*************
+
+* First tests defined for sphinx, including a new bzrlib.tests.features.sphinx
+  to make the tests conditional.
+  (Vincent Ladeuil)
+
+* Added a builder/writer sphinx extension that can generate texinfo files. The
+  generated files are syntactically correct but the info navigation nodes
+  needs more work. (Vincent Ladeuil, #219334)
+
+
+API Changes
+***********
+
+* InventoryEntry instances now raise AttributeError if you try to assign
+  to attributes that are irrelevant to that kind of entry.  e.g. setting
+  ``symlink_target`` on an InventoryFile will fail.  It is still okay to
+  read those attributes on any kind of InventoryEntry.  The complete list
+  of affected attributes is: ``executable``, ``text_id``, ``text_sha1``,
+  ``text_size`` (only valid for kind == file); ``symlink_target`` (only
+  valid for kind == link); and ``reference_revision`` (only valid for kind
+  == tree-reference).  (Andrew Bennetts)
+
+* InventoryEntry objects no longer have ``_put_in_tar`` or
+  ``_put_on_disk`` methods.  (Andrew Bennetts)
+
+Internals
+*********
+
+Testing
+*******
+
+* The way ``bzr selftest --parallel`` generates N partitions of tests to
+  run in parallel has changed.  Instead of splitting the list of tests at
+  N-1 points, it distributes the tests one-by-one into the partitions in a
+  round robin fashion.  This reduces the total time to run the tests in
+  parallel because a series of slow tests in the test suite will be
+  distributed evenly among the parallel test suites, rather than slowing
+  down just one suite.  (Andrew Bennetts)
+
+
+bzr 2.2
+#######
+
+:Codename: La Hulpe
+:2.2: 2010-08-06
+
+This release marks the start of another long-term-stable series. From
+here, we will only make bugfix releases on the 2.2 series (2.2.1, etc),
+while 2.3 will become our new development series. The 2.0 and 2.1 series
+will also continue to get bugfixes. (Currently 2.0 is planned to be
+supported for another 6 months.)
+
+This is primarily a bugfix and polish release over the 2.1 series, with
+a large number of bugs fixed (>120), and some performance improvements.
+
+There are some compatibility changes in this release.  For users of bzrlib
+as a library, we now request that they call ``bzrlib.initialize`` and use
+the returned context manager appropriately. For commandline users we no
+longer guess user identity for ``bzr commit``, users must specify their
+identity using ``bzr whoami`` (you don't need to specify your identity for
+readonly operations).
+
+Users are encouraged to upgrade from the other stable series.
+
+Compatibility Breaks
+********************
+
+* BzrError subclasses no longer support the name "message" to be used
+  as an argument for __init__ or in _fmt format specification as this
+  breaks in some Python versions. errors.LockError.__init__ argument
+  is now named "msg" instead of earlier "message".
+  (Parth Malwankar, #603461)
+
+* The old ``bzr selftest --benchmark`` option has been removed.
+  <https://launchpad.net/bzr-usertest> is an actively-maintained
+  macrobenchmark suite.
+  (Martin Pool)
+
+Bug Fixes
+*********
+
+* ``bzr ignore PATTERNS`` exits with error if a bad pattern is supplied.
+  ``InvalidPattern`` exception error message now shows faulting
+  regular expression.
+  (Parth Malwankar #300062)
+
+* Configuration files in ``${BZR_HOME}`` are now written in an atomic
+  way which should help avoid problems with concurrent writers.
+  (Vincent Ladeuil, #525571)
+
+* Don't traceback trying to unversion children files of an already
+  unversioned directory.  (Vincent Ladeuil, #494221)
+
+* ``HTTP/1.1` test servers now set a ``Content-Length`` header to comply
+  with pedantic ``HTTP/1.1`` clients. (Vincent Ladeuil, #568421)
+
+* Progress bars prefer to truncate the text message rather than the
+  counters.  The spinner is shown between the network transfer indicator
+  and the progress message.  Progress bars are correctly cleared off when 
+  they finish.  (Martin Pool, #611127)
+
+* Recursive binding for checkouts is now detected by bzr. A clear error
+  message is shown to the user. (Parth Malwankar, #405192)
+
+Improvements
+************
+
+* Add ``bzrlib.merge.MergeIntoMerger``, which can merge part or all of a
+  tree, and works with unrelated branches.  (Andrew Bennetts)
+
+* Add py2exe windows target ``bzrw.exe``. This allow for starting a Bazaar
+  GUI with out have a console open in the background.
+  (Gary van der Merwe, #433781)
+
+Documentation
+*************
+
+* ``bzr help patterns`` now explains case insensitive patterns and
+  points to Python regular expression documentation.
+  (Parth Malwankar, #594386)
+
+API Changes
+***********
+
+* Delete ``ProgressTask.note``, which was deprecated in 2.1.
+
+Testing
+*******
+
+* Unit test added to ensure that "message" is not uses as a format variable
+  name in BzrError subclasses as this conflicts with some Python versions.
+  (Parth Malwankar, #603461)
+
 bzr 2.2b4
 #########
 
 :Codename: Monkey Magic
-:2.2b4: NOT RELEASED YET
+:2.2b4: 2004-07-09
+
+
+This fourth and final beta in the 2.2 series now stabilizes the internal
+APIs. Plugin authors are recommended to ensure their releases are
+compatible, so that 2.2rc1 can be a true release candidate, containing
+stable and compatible plugin versions. 
+
+For users of bzrlib as a library, one of the primary changes is to request
+that they call ``bzrlib.initialize`` and use the returned context manager
+appropriately.
+
+Better interaction with ``bzr-loom`` to make sure branching from a loom
+even over a smart server still yields a local loom. Not to mention lots of
+bugfixes over 2.2b3.
 
 Compatibility Breaks
 ********************
@@ -21,11 +256,6 @@
   exiting the program, and it made sense to provide a full context
   manager at the same time. (Robert Collins)
 
-* ``bzrlib.re_compile_checked`` is now deprecated. Caller should handle
-  ``bzrlib.errors.InvalidPattern`` exception thrown by ``re.match`` in
-  case the default error message not suitable for the use case.
-  (Parth Malwankar)
-
 * The ``bzr`` front end now requires a ``bzrlib.ui.ui_factory`` which is a
   context manager in the Python 2.5 and above sense. The bzrlib base class
   is such a manager, but third party UI factories which do not derive from
@@ -145,12 +375,6 @@
   formats is needed or when the format string for the object is
   encountered. (Robert Collins, Jelmer Vernooij)
 
-* ``bzr remove`` now just backs up changed files instead of exiting,
-  forcing you to choose to either keep or delete them. Bazaar will now delete
-  the files if they can easily be recovered using revert, otherwise they
-  will be backed up (adding an extention of the form .~#~).
-  (Marius Kruger, #400554)
-
 * The encoding that bzr uses to output things other than file content can
   now be overridden via the output_encoding configuration option.
   (Martin Pool, #340394)
@@ -190,6 +414,11 @@
   2007, has been deleted.  Use ``PatienceSequenceMatcher`` from
   ``bzrlib.patiencediff`` instead. (Andrew Bennetts)
 
+* ``bzrlib.re_compile_checked`` is now deprecated. Caller should handle
+  ``bzrlib.errors.InvalidPattern`` exception thrown by ``re.match`` in
+  case the default error message not suitable for the use case.
+  (Parth Malwankar)
+
 * ``bzrlib.tests.blackbox.ExternalBase`` is deprecated.  It provided only
   one method ``check_output``, and we now recommend checking command
   output using ``run_script``. (Martin Pool)
@@ -433,9 +662,6 @@
   plugins to an all-in-one installation, ensure they are compiled and
   installed with -O1 or help may not work. (Martin [gz])
 
-Documentation
-*************
-
 API Changes
 ***********
 
@@ -491,7 +717,7 @@
 
 * No longer require zlib headers to build extensions, and remove the need
   for seperate copy of zlib library on windows.
-  (John Arbash Meinel, Martin <gzlist@googlemail.com>, #66923)
+  (John Arbash Meinel, Martin <gzlist@googlemail.com>, #566923)
 
 Testing
 *******
@@ -579,7 +805,7 @@
   (Vincent Ladeuil, #474807)
 
 * Properly handle ``param_name`` attribute for ``ListOption``.
-  (Martin von Gagern, 387117)
+  (Martin von Gagern, #387117)
 
 Improvements
 ************
@@ -699,7 +925,7 @@
 
 * Parsing of command lines, for example in ``diff --using``, no longer
   treats backslash as an escape character on Windows.   (Gordon Tyler,
-  #392248)
+  #392428)
 
 * Plugins can be disabled by defining ``BZR_DISABLE_PLUGINS`` as
   a list of plugin names separated by ':' (';' on windows).
@@ -949,24 +1175,64 @@
 Bug Fixes
 *********
 
+* ``bzr ignore PATTERNS`` exits with error if a bad pattern is supplied.
+  ``InvalidPattern`` exception error message now shows faulting
+  regular expression.
+  (Parth Malwankar #300062)
+
+* Configuration files in ``${BZR_HOME}`` are now written in an atomic
+  way which should help avoid problems with concurrent writers.
+  (Vincent Ladeuil, #525571)
+
+* Don't traceback trying to unversion children files of an already
+  unversioned directory.  (Vincent Ladeuil, #494221)
+
+* ``HTTP/1.1` test servers now set a ``Content-Length`` header to comply
+  with pedantic ``HTTP/1.1`` clients. (Vincent Ladeuil, #568421)
+
+* Prevent ``CHKMap.apply_delta`` from generating non-canonical CHK maps,
+  which can result in "missing referenced chk root keys" errors when
+  fetching from repositories with affected revisions.
+  (Andrew Bennetts, #522637)
+
+* Progress bars prefer to truncate the text message rather than the
+  counters.  The spinner is shown between the network transfer indicator
+  and the progress message.  (Martin Pool)
+
 * Raise ValueError instead of a string exception.
   (John Arbash Meinel, #586926)
 
+* Recursive binding for checkouts is now detected by bzr. A clear error
+  message is shown to the user. (Parth Malwankar, #405192)
+
 Improvements
 ************
 
+* Add ``bzrlib.merge.MergeIntoMerger``, which can merge part or all of a
+  tree, and works with unrelated branches.  (Andrew Bennetts)
+
 Documentation
 *************
 
+* ``bzr help patterns`` now explains case insensitive patterns and
+  points to Python regular expression documentation.
+  (Parth Malwankar, #594386)
+
 API Changes
 ***********
 
+* Delete ``ProgressTask.note``, which was deprecated in 2.1.
+
 Internals
 *********
 
 Testing
 *******
 
+* Unit test added to ensure that "message" is not uses as a format variable
+  name in BzrError subclasses as this conflicts with some Python versions.
+  (Parth Malwankar, #603461)
+
 bzr 2.1.2
 #########
 
@@ -1454,6 +1720,10 @@
   history no longer crash when deleted files are involved.
   (Vincent Ladeuil, John Arbash Meinel, #375898)
 
+* ``bzr commit SYMLINK`` now works, rather than trying to commit the
+  target of the symlink.
+  (Martin Pool, John Arbash Meinel, #128562)
+
 * ``bzr revert`` now only takes write lock on working tree, instead of on 
   both working tree and branch.
   (Danny van Heumen, #498409)
@@ -1462,6 +1732,14 @@
   permissions as ``.bzr`` directory on a POSIX OS.
   (Parth Malwankar, #262450)
 
+* Don't traceback trying to unversion children files of an already
+  unversioned directory.  (Vincent Ladeuil, #494221)
+
+* Prevent ``CHKMap.apply_delta`` from generating non-canonical CHK maps,
+  which can result in "missing referenced chk root keys" errors when
+  fetching from repositories with affected revisions.
+  (Andrew Bennetts, #522637)
+
 * Raise ValueError instead of a string exception.
   (John Arbash Meinel, #586926)
 
@@ -1485,6 +1763,13 @@
   (John Arbash Meinel, #583486)
 
 
+Testing
+*******
+
+* ``build_tree_contents`` can create symlinks.
+  (Martin Pool, John Arbash Meinel)
+
+
 bzr 2.0.5
 #########
 

=== modified file 'bzr'
--- bzr	2010-06-22 22:40:29 +0000
+++ bzr	2010-07-13 07:44:02 +0000
@@ -23,7 +23,7 @@
 import warnings
 
 # update this on each release
-_script_version = (2, 2, 0)
+_script_version = (2, 3, 0)
 
 try:
     version_info = sys.version_info

=== modified file 'bzrlib/__init__.py'
--- bzrlib/__init__.py	2010-07-02 22:44:00 +0000
+++ bzrlib/__init__.py	2010-08-06 19:54:45 +0000
@@ -52,7 +52,7 @@
 # Python version 2.0 is (2, 0, 0, 'final', 0)."  Additionally we use a
 # releaselevel of 'dev' for unreleased under-development code.
 
-version_info = (2, 2, 0, 'beta', 3)
+version_info = (2, 3, 0, 'dev', 1)
 
 # API compatibility version
 api_minimum_version = (2, 2, 0)

=== modified file 'bzrlib/_groupcompress_pyx.pyx'
--- bzrlib/_groupcompress_pyx.pyx	2010-02-17 17:11:16 +0000
+++ bzrlib/_groupcompress_pyx.pyx	2010-08-02 17:08:29 +0000
@@ -22,6 +22,8 @@
 
 
 cdef extern from "Python.h":
+    ctypedef struct PyObject:
+        pass
     ctypedef int Py_ssize_t # Required for older pyrex versions
     int PyString_CheckExact(object)
     char * PyString_AS_STRING(object)
@@ -53,6 +55,7 @@
              unsigned long *delta_size, unsigned long max_delta_size) nogil
     unsigned long get_delta_hdr_size(unsigned char **datap,
                                      unsigned char *top) nogil
+    unsigned long sizeof_delta_index(delta_index *index)
     Py_ssize_t DELTA_SIZE_MIN
 
 
@@ -91,8 +94,8 @@
     cdef readonly object _sources
     cdef source_info *_source_infos
     cdef delta_index *_index
+    cdef public unsigned long _source_offset
     cdef readonly unsigned int _max_num_sources
-    cdef public unsigned long _source_offset
 
     def __init__(self, source=None):
         self._sources = []
@@ -105,6 +108,22 @@
         if source is not None:
             self.add_source(source, 0)
 
+    def __sizeof__(self):
+        # We want to track the _source_infos allocations, but the referenced
+        # void* are actually tracked in _sources itself.
+        # XXX: Cython is capable of doing sizeof(class) and returning the size
+        #      of the underlying struct. Pyrex (<= 0.9.9) refuses, so we need
+        #      to do it manually. *sigh* Note that we might get it wrong
+        #      because of alignment issues.
+        cdef Py_ssize_t size
+        # PyObject start, vtable *, 3 object pointers, 2 C ints
+        size = ((sizeof(PyObject) + sizeof(void*) + 3*sizeof(PyObject*)
+                 + sizeof(unsigned long)
+                 + sizeof(unsigned int))
+                + (sizeof(source_info) * self._max_num_sources)
+                + sizeof_delta_index(self._index))
+        return size
+
     def __repr__(self):
         return '%s(%d, %d)' % (self.__class__.__name__,
             len(self._sources), self._source_offset)

=== modified file 'bzrlib/_simple_set_pyx.pyx'
--- bzrlib/_simple_set_pyx.pyx	2010-02-17 17:11:16 +0000
+++ bzrlib/_simple_set_pyx.pyx	2010-08-02 17:16:12 +0000
@@ -115,6 +115,20 @@
             raise MemoryError()
         memset(self._table, 0, n_bytes)
 
+    def __sizeof__(self):
+        # Note: Pyrex doesn't allow sizeof(class) so we re-implement it here.
+        # Bits are:
+        #   1: PyObject
+        #   2: vtable *
+        #   3: 3 Py_ssize_t
+        #   4: PyObject**
+        # Note that we might get alignment, etc, wrong, but at least this is
+        # better than no estimate at all
+        # return sizeof(SimpleSet) + (self._mask + 1) * (sizeof(PyObject*))
+        return (sizeof(PyObject) + sizeof(void*)
+                + 3*sizeof(Py_ssize_t) + sizeof(PyObject**)
+                + (self._mask + 1) * sizeof(PyObject*))
+
     def __dealloc__(self):
         if self._table != NULL:
             PyMem_Free(self._table)

=== removed directory 'bzrlib/benchmarks'
=== removed file 'bzrlib/benchmarks/__init__.py'
--- bzrlib/benchmarks/__init__.py	2009-06-10 03:56:49 +0000
+++ bzrlib/benchmarks/__init__.py	1970-01-01 00:00:00 +0000
@@ -1,206 +0,0 @@
-# Copyright (C) 2006 Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
-
-"""Benchmark test suite for bzr."""
-
-from bzrlib import (
-    bzrdir,
-    )
-from bzrlib import plugin as _mod_plugin
-import bzrlib.branch
-from bzrlib.tests.TestUtil import TestLoader
-from bzrlib.tests.blackbox import ExternalBase
-
-
-class Benchmark(ExternalBase):
-    """A Test class which provides helpers for writing benchmark tests."""
-
-    def make_kernel_like_tree(self, url=None, root='.',
-                              link_working=False):
-        """Setup a temporary tree roughly like a kernel tree.
-
-        :param url: Creat the kernel like tree as a lightweight checkout
-            of a new branch created at url.
-        :param root: Path where the tree will be created.
-        :param link_working: instead of creating a new copy of all files
-            just hardlink the working tree. Tests must request this, because
-            they must break links if they want to change the files
-        :return: A newly created tree.
-        """
-        from bzrlib.benchmarks.tree_creator.kernel_like import (
-            KernelLikeTreeCreator,
-            )
-        creator = KernelLikeTreeCreator(self, link_working=link_working,
-                                        url=url)
-        return creator.create(root=root)
-
-    def make_kernel_like_added_tree(self, root='.',
-                                    link_working=True,
-                                    hot_cache=True):
-        """Make a kernel like tree, with all files added
-
-        :param root: Where to create the files
-        :param link_working: Instead of copying all of the working tree
-            files, just hardlink them to the cached files. Tests can unlink
-            files that they will change.
-        :param hot_cache: Run through the newly created tree and make sure
-            the stat-cache is correct. The old way of creating a freshly
-            added tree always had a hot cache.
-        """
-        from bzrlib.benchmarks.tree_creator.kernel_like import (
-            KernelLikeAddedTreeCreator,
-            )
-        creator = KernelLikeAddedTreeCreator(self, link_working=link_working,
-                                             hot_cache=hot_cache)
-        return creator.create(root=root)
-
-    def make_kernel_like_committed_tree(self, root='.',
-                                    link_working=True,
-                                    link_bzr=False,
-                                    hot_cache=True):
-        """Make a kernel like tree, with all files added and committed
-
-        :param root: Where to create the files
-        :param link_working: Instead of copying all of the working tree
-            files, just hardlink them to the cached files. Tests can unlink
-            files that they will change.
-        :param link_bzr: Hardlink the .bzr directory. For readonly
-            operations this is safe, and shaves off a lot of setup time
-        """
-        from bzrlib.benchmarks.tree_creator.kernel_like import (
-            KernelLikeCommittedTreeCreator,
-            )
-        creator = KernelLikeCommittedTreeCreator(self,
-                                                 link_working=link_working,
-                                                 link_bzr=link_bzr,
-                                                 hot_cache=hot_cache)
-        return creator.create(root=root)
-
-    def make_kernel_like_inventory(self):
-        """Create an inventory with the properties of a kernel-like tree
-
-        This should be equivalent to a committed kernel like tree, not
-        just a working tree.
-        """
-        from bzrlib.benchmarks.tree_creator.kernel_like import (
-            KernelLikeInventoryCreator,
-            )
-        creator = KernelLikeInventoryCreator(self)
-        return creator.create()
-
-    def make_many_commit_tree(self, directory_name='.',
-                              hardlink=False):
-        """Create a tree with many commits.
-
-        No file changes are included. Not hardlinking the working tree,
-        because there are no working tree files.
-        """
-        from bzrlib.benchmarks.tree_creator.simple_many_commit import (
-            SimpleManyCommitTreeCreator,
-            )
-        creator = SimpleManyCommitTreeCreator(self, link_bzr=hardlink)
-        return creator.create(root=directory_name)
-
-    def make_heavily_merged_tree(self, directory_name='.',
-                                 hardlink=False):
-        """Create a tree in which almost every commit is a merge.
-
-        No file changes are included.  This produces two trees,
-        one of which is returned.  Except for the first commit, every
-        commit in its revision-history is a merge another commit in the other
-        tree.  Not hardlinking the working tree, because there are no working
-        tree files.
-        """
-        from bzrlib.benchmarks.tree_creator.heavily_merged import (
-            HeavilyMergedTreeCreator,
-            )
-        creator = HeavilyMergedTreeCreator(self, link_bzr=hardlink)
-        return creator.create(root=directory_name)
-
-    def create_with_commits(self, num_files, num_commits, directory_name='.',
-                            hardlink=False):
-        """Create a tree with many files and many commits. Every commit changes
-        exactly one file.
-
-        :param num_files: number of files to be created
-        :param num_commits: number of commits in the newly created tree
-        """
-        from bzrlib.benchmarks.tree_creator.many_commit import (
-            ManyCommitTreeCreator,
-            )
-        creator = ManyCommitTreeCreator(self, link_bzr=hardlink,
-                                        num_files=num_files,
-                                        num_commits=num_commits)
-        tree = creator.create(root=directory_name)
-        files = ["%s/%s" % (directory_name, fn) for fn in creator.files]
-        return tree, files
-
-    def commit_some_revisions(self, tree, files, num_commits,
-                              changes_per_commit):
-        """Commit a specified number of revisions to some files in a tree,
-        makeing a specified number of changes per commit.
-
-        :param tree: The tree in which the changes happen.
-        :param files: The list of files where changes should occur.
-        :param num_commits: The number of commits
-        :param changes_per_commit: The number of files that are touched in
-            each commit.
-        """
-        for j in range(num_commits):
-            for i in range(changes_per_commit):
-                fn = files[(i + j) % changes_per_commit]
-                content = range(i) + [i, i, i, '']
-                f = open(fn, "w")
-                try:
-                    f.write("\n".join([str(k) for k in content]))
-                finally:
-                    f.close()
-            tree.commit("new revision")
-
-
-def test_suite():
-    """Build and return a TestSuite which contains benchmark tests only."""
-    testmod_names = [ \
-                   'bzrlib.benchmarks.bench_add',
-                   'bzrlib.benchmarks.bench_bench',
-                   'bzrlib.benchmarks.bench_bundle',
-                   'bzrlib.benchmarks.bench_cache_utf8',
-                   'bzrlib.benchmarks.bench_checkout',
-                   'bzrlib.benchmarks.bench_commit',
-                   'bzrlib.benchmarks.bench_dirstate',
-                   'bzrlib.benchmarks.bench_info',
-                   'bzrlib.benchmarks.bench_inventory',
-                   'bzrlib.benchmarks.bench_knit',
-                   'bzrlib.benchmarks.bench_log',
-                   'bzrlib.benchmarks.bench_pack',
-                   'bzrlib.benchmarks.bench_osutils',
-                   'bzrlib.benchmarks.bench_rocks',
-                   'bzrlib.benchmarks.bench_startup',
-                   'bzrlib.benchmarks.bench_status',
-                   'bzrlib.benchmarks.bench_tags',
-                   'bzrlib.benchmarks.bench_transform',
-                   'bzrlib.benchmarks.bench_workingtree',
-                   'bzrlib.benchmarks.bench_sftp',
-                   'bzrlib.benchmarks.bench_xml',
-                   ]
-    suite = TestLoader().loadTestsFromModuleNames(testmod_names)
-
-    # Load any benchmarks from plugins
-    for name, plugin in _mod_plugin.plugins().items():
-        if getattr(plugin.module, 'bench_suite', None) is not None:
-            suite.addTest(plugin.module.bench_suite())
-
-    return suite

=== removed file 'bzrlib/benchmarks/bench_add.py'
--- bzrlib/benchmarks/bench_add.py	2009-03-23 14:59:43 +0000
+++ bzrlib/benchmarks/bench_add.py	1970-01-01 00:00:00 +0000
@@ -1,32 +0,0 @@
-# Copyright (C) 2006 Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
-
-"""Tests for bzr add performance."""
-
-
-from bzrlib.benchmarks import Benchmark
-
-
-class AddBenchmark(Benchmark):
-    """Benchmarks for 'bzr add'"""
-
-    def test_one_add_kernel_like_tree(self):
-        """Adding a kernel sized tree should be bearable (<5secs) fast."""
-        self.make_kernel_like_tree(link_working=True)
-        # on roberts machine: this originally took:  25936ms/32244ms
-        # after making smart_add use the parent_ie:   5033ms/ 9368ms
-        # plain os.walk takes 213ms on this tree
-        self.time(self.run_bzr, 'add')

=== removed file 'bzrlib/benchmarks/bench_bench.py'
--- bzrlib/benchmarks/bench_bench.py	2009-03-23 14:59:43 +0000
+++ bzrlib/benchmarks/bench_bench.py	1970-01-01 00:00:00 +0000
@@ -1,101 +0,0 @@
-# Copyright (C) 2006 Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
-
-"""Tests for bzr benchmark utilities performance."""
-
-from bzrlib import (
-    osutils,
-    )
-from bzrlib.benchmarks import Benchmark
-from bzrlib.benchmarks.tree_creator.kernel_like import (
-    KernelLikeTreeCreator,
-    KernelLikeAddedTreeCreator,
-    KernelLikeCommittedTreeCreator,
-    )
-from bzrlib.tests import TestSkipped
-
-
-class MakeKernelLikeTreeBenchmark(Benchmark):
-    """Benchmark creating benchmark trees."""
-
-    def test_make_kernel_like_tree(self):
-        """Making a kernel sized tree should be ~ 5seconds on modern disk."""
-        # on roberts machine: this originally took:  7372ms/ 7479ms
-        # with the LocalTransport._abspath call:     3730ms/ 3778ms
-        # with AtomicFile tuning:                    2888ms/ 2926ms
-        # switching to transport.append_bytes:       1468ms/ 2849ms
-        self.time(self.make_kernel_like_tree)
-
-    def test_02_make_kernel_like_tree(self):
-        """Hardlinking a kernel-like working tree should be ~1s"""
-        # make sure kernel_like_tree is cached
-        creator = KernelLikeTreeCreator(self, link_working=True)
-        if not creator.is_caching_enabled():
-            raise TestSkipped('caching is disabled')
-        creator.ensure_cached()
-        self.time(creator.create, root='bar')
-
-    def test_03_make_kernel_like_added_tree(self):
-        """Time the first creation of a kernel like added tree"""
-        creator = KernelLikeAddedTreeCreator(self)
-        creator.disable_cache()
-        self.time(creator.create, root='foo')
-
-    def test_04_make_kernel_like_added_tree(self):
-        """Time the second creation of a kernel like added tree
-        (this should be a clone)
-        """
-        # make sure kernel_like_added_tree is cached
-        creator = KernelLikeAddedTreeCreator(self, link_working=True)
-        if not creator.is_caching_enabled():
-            # Caching is disabled, this test is meaningless
-            raise TestSkipped('caching is disabled')
-        creator.ensure_cached()
-        self.time(creator.create, root='bar')
-
-    def test_05_make_kernel_like_committed_tree(self):
-        """Time the first creation of a committed kernel like tree"""
-        creator = KernelLikeCommittedTreeCreator(self)
-        creator.disable_cache()
-        self.time(creator.create, root='foo')
-
-    def test_06_make_kernel_like_committed_tree(self):
-        """Time the second creation of a committed kernel like tree
-        (this should be a clone)
-        """
-        creator = KernelLikeCommittedTreeCreator(self,
-                                                 link_working=True,
-                                                 link_bzr=False)
-        if not creator.is_caching_enabled():
-            # Caching is disabled, this test is meaningless
-            raise TestSkipped('caching is disabled')
-        creator.ensure_cached()
-        self.time(creator.create, root='bar')
-
-    def test_07_make_kernel_like_committed_tree_hardlink(self):
-        """Time the creation of a committed kernel like tree
-        (this should also hardlink the .bzr/ directory)
-        """
-        creator = KernelLikeCommittedTreeCreator(self,
-                                                 link_working=True,
-                                                 link_bzr=True)
-        if not creator.is_caching_enabled():
-            # Caching is disabled, this test is meaningless
-            raise TestSkipped('caching is disabled')
-        creator.ensure_cached()
-        self.time(creator.create, root='bar')
-
-

=== removed file 'bzrlib/benchmarks/bench_bundle.py'
--- bzrlib/benchmarks/bench_bundle.py	2009-03-23 14:59:43 +0000
+++ bzrlib/benchmarks/bench_bundle.py	1970-01-01 00:00:00 +0000
@@ -1,207 +0,0 @@
-# Copyright (C) 2006 Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
-
-"""Tests for bzr bundle performance."""
-
-from cStringIO import StringIO
-import os
-import shutil
-
-from bzrlib import bzrdir
-from bzrlib.benchmarks import Benchmark
-from bzrlib.branch import Branch
-from bzrlib.bundle.apply_bundle import install_bundle
-from bzrlib.bundle.serializer import read_bundle, write_bundle
-from bzrlib.revision import NULL_REVISION
-from bzrlib.revisionspec import RevisionSpec
-from bzrlib.workingtree import WorkingTree
-
-
-class BundleBenchmark(Benchmark):
-    """Benchmarks for bzr bundle performance and bzr merge with a bundle."""
-
-    def test_create_bundle_known_kernel_like_tree(self):
-        """Create a bundle for a kernel sized tree with no ignored, unknowns,
-        or added and one commit.
-        """
-        self.make_kernel_like_committed_tree()
-        self.time(self.run_bzr, ['bundle', '--revision', '..-1'])
-
-    def test_create_bundle_many_commit_tree (self):
-        """Create a bundle for a tree with many commits but no changes."""
-        self.make_many_commit_tree()
-        self.time(self.run_bzr, ['bundle', '--revision', '..-1'])
-
-    def test_create_bundle_heavily_merged_tree(self):
-        """Create a bundle for a heavily merged tree."""
-        self.make_heavily_merged_tree()
-        self.time(self.run_bzr, ['bundle', '--revision', '..-1'])
-
-    def test_apply_bundle_known_kernel_like_tree(self):
-        """Create a bundle for a kernel sized tree with no ignored, unknowns,
-        or added and one commit.
-        """
-        tree = self.make_kernel_like_committed_tree('tree')
-
-        f = open('bundle', 'wb')
-        try:
-            write_bundle(tree.branch.repository, tree.last_revision(),
-                         NULL_REVISION, f)
-        finally:
-            f.close()
-
-        tree2 = self.make_branch_and_tree('branch_a')
-        os.chdir('branch_a')
-        self.time(self.run_bzr, ['merge', '../bundle'])
-
-
-class BundleLibraryLevelWriteBenchmark(Benchmark):
-    """ Benchmarks for the write_bundle library function. """
-
-    def _time_read_write(self):
-        branch, relpath = Branch.open_containing("a")
-        revision_history = branch.revision_history()
-        bundle_text = StringIO()
-        self.time(write_bundle, branch.repository, revision_history[-1],
-                  NULL_REVISION, bundle_text)
-        bundle_text.seek(0)
-        target_tree = self.make_branch_and_tree('b')
-        bundle = self.time(read_bundle, bundle_text)
-        self.time(install_bundle, target_tree.branch.repository, bundle)
-
-    def test_few_files_small_tree_1_revision(self):
-        os.mkdir("a")
-        tree, files = self.create_with_commits(5, 1, directory_name="a")
-        self.commit_some_revisions(tree, files[:5], 1, 1)
-        self._time_read_write()
-
-    def test_few_files_small_tree_100_revision(self):
-        os.mkdir("a")
-        tree, files = self.create_with_commits(5, 1, directory_name="a")
-        self.commit_some_revisions(tree, files[:5], 100, 1)
-        self._time_read_write()
-
-    def test_few_files_moderate_tree_1_revision(self):
-        os.mkdir("a")
-        tree, files = self.create_with_commits(100, 1, directory_name="a")
-        self.commit_some_revisions(tree, files[:5], 1, 1)
-        self._time_read_write()
-
-    def test_few_files_moderate_tree_100_revision(self):
-        os.mkdir("a")
-        tree, files = self.create_with_commits(100, 1, directory_name="a")
-        self.commit_some_revisions(tree, files[:5], 100, 1)
-        self._time_read_write()
-
-    def test_some_files_moderate_tree_1_revision(self):
-        os.mkdir("a")
-        tree, files = self.create_with_commits(100, 1, directory_name="a")
-        self.commit_some_revisions(tree, files[:100], 1, 1)
-        self._time_read_write()
-
-    def test_few_files_big_tree_1_revision(self):
-        os.mkdir("a")
-        tree, files = self.create_with_commits(1000, 1, directory_name="a")
-        self.commit_some_revisions(tree, files[:5], 1, 1)
-        self._time_read_write()
-
-    def test_some_files_big_tree_1_revision(self):
-        os.mkdir("a")
-        tree, files = self.create_with_commits(1000, 1, directory_name="a")
-        self.commit_some_revisions(tree, files[:100], 1, 1)
-        self._time_read_write()
-
-
-class BundleLibraryLevelInstallBenchmark(Benchmark):
-    """ Benchmarks for the install_bundle library function. """
-
-    def _time_read_write(self):
-        branch, relpath = Branch.open_containing("a")
-        revision_history = branch.revision_history()
-        bundle_text = StringIO()
-        write_bundle(branch.repository, revision_history[-1],
-                     NULL_REVISION, bundle_text)
-        bundle_text.seek(0)
-        target_tree = self.make_branch_and_tree('b')
-        bundle = self.time(read_bundle, bundle_text)
-        self.time(install_bundle, target_tree.branch.repository, bundle)
-
-    def test_few_files_small_tree_1_revision(self):
-        os.mkdir("a")
-        tree, files = self.create_with_commits(5, 1, directory_name="a")
-        self.commit_some_revisions(tree, files[:5], 1, 1)
-        self._time_read_write()
-
-    def test_few_files_small_tree_100_revision(self):
-        os.mkdir("a")
-        tree, files = self.create_with_commits(5, 1, directory_name="a")
-        self.commit_some_revisions(tree, files[:5], 100, 1)
-        self._time_read_write()
-
-    def test_few_files_moderate_tree_1_revision(self):
-        os.mkdir("a")
-        tree, files = self.create_with_commits(100, 1, directory_name="a")
-        self.commit_some_revisions(tree, files[:5], 1, 1)
-        self._time_read_write()
-
-    def test_few_files_moderate_tree_100_revision(self):
-        os.mkdir("a")
-        tree, files = self.create_with_commits(100, 1, directory_name="a")
-        self.commit_some_revisions(tree, files[:5], 100, 1)
-        self._time_read_write()
-
-    def test_some_files_moderate_tree_1_revision(self):
-        os.mkdir("a")
-        tree, files = self.create_with_commits(100, 1, directory_name="a")
-        self.commit_some_revisions(tree, files[:100], 1, 1)
-        self._time_read_write()
-
-    def test_few_files_big_tree_1_revision(self):
-        os.mkdir("a")
-        tree, files = self.create_with_commits(1000, 1, directory_name="a")
-        self.commit_some_revisions(tree, files[:5], 1, 1)
-        self._time_read_write()
-
-    def test_some_files_big_tree_1_revision(self):
-        os.mkdir("a")
-        tree, files = self.create_with_commits(1000, 1, directory_name="a")
-        self.commit_some_revisions(tree, files[:100], 1, 1)
-        self._time_read_write()
-
-
-if __name__ == '__main__':
-    # USE the following if you want to regenerate the above test functions
-    for treesize, treesize_h in [(5, "small"), (100, "moderate"),
-                                 (1000, "big")]:
-        for bundlefiles, bundlefiles_h in [(5, "few"), (100, "some")]:
-            if bundlefiles > treesize:
-                continue
-            for num_revisions in [1, 100]:
-                if (num_revisions >= 100 and
-                        (bundlefiles >= 100 or treesize >= 1000)):
-                    # Skip the 100x100x? tests.
-                    # And the 100x?x1000
-                    continue
-                code = """\
-    def test_%s_files_%s_tree_%s_revision(self):
-        os.mkdir("a")
-        tree, files = self.create_with_commits(%s, 1, directory_name="a")
-        self.commit_some_revisions(tree, files[:%s], %s, 1)
-        self._time_read_write()
-""" % (bundlefiles_h, treesize_h, num_revisions,
-       treesize, bundlefiles, num_revisions)
-                print code
-

=== removed file 'bzrlib/benchmarks/bench_cache_utf8.py'
--- bzrlib/benchmarks/bench_cache_utf8.py	2009-03-23 14:59:43 +0000
+++ bzrlib/benchmarks/bench_cache_utf8.py	1970-01-01 00:00:00 +0000
@@ -1,226 +0,0 @@
-# Copyright (C) 2006 Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
-
-
-"""Tests for encoding performance."""
-
-from bzrlib import (
-    cache_utf8,
-    osutils,
-    )
-
-from bzrlib.benchmarks import Benchmark
-
-
-_normal_revision_id = (u'john@arbash-meinel.com-20060801200018'
-                       u'-cafa6272d9b8cac4')
-_unicode_revision_id = (u'\u062c\u0648\u062c\u0648@\xe5rbash-meinel.com-'
-                        u'\xb5\xb5\xb5-20060801200018-cafa6272d9b8cac4')
-
-_normal_revision_id_utf8 = _normal_revision_id.encode('utf-8')
-_unicode_revision_id_utf8 = _unicode_revision_id.encode('utf-8')
-
-
-class EncodingBenchmark(Benchmark):
-    """Benchmark the time to encode strings."""
-
-    def setUp(self):
-        super(EncodingBenchmark, self).setUp()
-        # Make sure we start and end with a clean cache
-        cache_utf8.clear_encoding_cache()
-        self.addCleanup(cache_utf8.clear_encoding_cache)
-
-    def encode_1M(self, revision_id):
-        """Encode the given revision id 1 million times"""
-        # In a real kernel tree there are 7.7M lines of code
-        # so the initial import actually has to encode a revision
-        # id to store annotated lines one time for every line.
-        for i in xrange(1000000):
-            revision_id.encode('utf8')
-
-    def encode_cached_1M(self, revision_id):
-        """Encode the given revision id 1 million times using the cache"""
-        encode = cache_utf8.encode
-        for i in xrange(1000000):
-            encode(revision_id)
-
-    def encode_multi(self, revision_list, count):
-        """Encode each entry in the list count times"""
-        for i in xrange(count):
-            for revision_id in revision_list:
-                revision_id.encode('utf-8')
-
-    def encode_cached_multi(self, revision_list, count):
-        """Encode each entry in the list count times"""
-        encode = cache_utf8.encode
-        for i in xrange(count):
-            for revision_id in revision_list:
-                encode(revision_id)
-
-    def test_encode_1_by_1M_ascii(self):
-        """Test encoding a single revision id 1 million times."""
-        self.time(self.encode_1M, _normal_revision_id)
-
-    def test_encode_1_by_1M_ascii_cached(self):
-        """Test encoding a single revision id 1 million times."""
-        self.time(self.encode_cached_1M, _normal_revision_id)
-
-    def test_encode_1_by_1M_ascii_str(self):
-        # We have places that think they have a unicode revision id
-        # but actually, they have a plain string. So .encode(utf8)
-        # actually has to decode from ascii, and then encode into utf8
-        self.time(self.encode_1M, str(_normal_revision_id))
-
-    def test_encode_1_by_1M_ascii_str_cached(self):
-        self.time(self.encode_cached_1M, str(_normal_revision_id))
-
-    def test_encode_1_by_1M_unicode(self):
-        """Test encoding a single revision id 1 million times."""
-        self.time(self.encode_1M, _unicode_revision_id)
-
-    def test_encode_1_by_1M_unicode_cached(self):
-        """Test encoding a single revision id 1 million times."""
-        self.time(self.encode_cached_1M, _unicode_revision_id)
-
-    def test_encode_1k_by_1k_ascii(self):
-        """Test encoding 5 revisions 100k times"""
-        revisions = [unicode(osutils.rand_chars(60)) for x in xrange(1000)]
-        self.time(self.encode_multi, revisions, 1000)
-
-    def test_encode_1k_by_1k_ascii_cached(self):
-        """Test encoding 5 revisions 100k times"""
-        revisions = [unicode(osutils.rand_chars(60)) for x in xrange(1000)]
-        self.time(self.encode_cached_multi, revisions, 1000)
-
-    def test_encode_1k_by_1k_unicode(self):
-        """Test encoding 5 revisions 100k times"""
-        revisions = [u'\u062c\u0648\u062c\u0648' +
-                     unicode(osutils.rand_chars(60)) for x in xrange(1000)]
-        self.time(self.encode_multi, revisions, 1000)
-
-    def test_encode_1k_by_1k_unicode_cached(self):
-        """Test encoding 5 revisions 100k times"""
-        revisions = [u'\u062c\u0648\u062c\u0648' +
-                     unicode(osutils.rand_chars(60)) for x in xrange(1000)]
-        self.time(self.encode_cached_multi, revisions, 1000)
-
-    def test_encode_500K_by_1_ascii(self):
-        revisions = [unicode("test%07d" % x) for x in xrange(500000)]
-        self.time(self.encode_multi, revisions, 1)
-
-    def test_encode_500K_by_1_ascii_cached(self):
-        revisions = [unicode("test%07d" % x) for x in xrange(500000)]
-        self.time(self.encode_cached_multi, revisions, 1)
-
-    def test_encode_500K_by_1_unicode(self):
-        revisions = [u'\u062c\u0648\u062c\u0648' +
-                     unicode("%07d" % x) for x in xrange(500000)]
-        self.time(self.encode_multi, revisions, 1)
-
-    def test_encode_500K_by_1_unicode_cached(self):
-        revisions = [u'\u062c\u0648\u062c\u0648' +
-                     unicode("%07d" % x) for x in xrange(500000)]
-        self.time(self.encode_cached_multi, revisions, 1)
-
-
-class DecodingBenchmarks(Benchmark):
-    """Benchmark the time to decode strings."""
-
-    def setUp(self):
-        super(DecodingBenchmarks, self).setUp()
-        # Make sure we start and end with a clean cache
-        cache_utf8.clear_encoding_cache()
-        self.addCleanup(cache_utf8.clear_encoding_cache)
-
-    def decode_1M(self, revision_id):
-        for i in xrange(1000000):
-            revision_id.decode('utf8')
-
-    def decode_cached_1M(self, revision_id):
-        decode = cache_utf8.decode
-        for i in xrange(1000000):
-            decode(revision_id)
-
-    def decode_multi(self, revision_list, count):
-        for i in xrange(count):
-            for revision_id in revision_list:
-                revision_id.decode('utf-8')
-
-    def decode_cached_multi(self, revision_list, count):
-        decode = cache_utf8.decode
-        for i in xrange(count):
-            for revision_id in revision_list:
-                decode(revision_id)
-
-    def test_decode_1_by_1M_ascii(self):
-        """Test decoding a single revision id 1 million times."""
-        self.time(self.decode_1M, _normal_revision_id_utf8)
-
-    def test_decode_1_by_1M_ascii_cached(self):
-        """Test decoding a single revision id 1 million times."""
-        self.time(self.decode_cached_1M, _normal_revision_id_utf8)
-
-    def test_decode_1_by_1M_unicode(self):
-        """Test decoding a single revision id 1 million times."""
-        self.time(self.decode_1M, _unicode_revision_id_utf8)
-
-    def test_decode_1_by_1M_unicode_cached(self):
-        """Test decoding a single revision id 1 million times."""
-        self.time(self.decode_cached_1M, _unicode_revision_id_utf8)
-
-    def test_decode_1k_by_1k_ascii(self):
-        """Test decoding 5 revisions 100k times"""
-        revisions = [osutils.rand_chars(60) for x in xrange(1000)]
-        self.time(self.decode_multi, revisions, 1000)
-
-    def test_decode_1k_by_1k_ascii_cached(self):
-        """Test decoding 5 revisions 100k times"""
-        revisions = [osutils.rand_chars(60) for x in xrange(1000)]
-        self.time(self.decode_cached_multi, revisions, 1000)
-
-    def test_decode_1k_by_1k_unicode(self):
-        """Test decoding 5 revisions 100k times"""
-        revisions = [(u'\u062c\u0648\u062c\u0648' +
-                      unicode(osutils.rand_chars(60))).encode('utf8')
-                     for x in xrange(1000)]
-        self.time(self.decode_multi, revisions, 1000)
-
-    def test_decode_1k_by_1k_unicode_cached(self):
-        """Test decoding 5 revisions 100k times"""
-        revisions = [(u'\u062c\u0648\u062c\u0648' +
-                      unicode(osutils.rand_chars(60))).encode('utf8')
-                     for x in xrange(1000)]
-        self.time(self.decode_cached_multi, revisions, 1000)
-
-    def test_decode_500K_by_1_ascii(self):
-        revisions = [("test%07d" % x) for x in xrange(500000)]
-        self.time(self.decode_multi, revisions, 1)
-
-    def test_decode_500K_by_1_ascii_cached(self):
-        revisions = [("test%07d" % x) for x in xrange(500000)]
-        self.time(self.decode_cached_multi, revisions, 1)
-
-    def test_decode_500K_by_1_unicode(self):
-        revisions = [(u'\u062c\u0648\u062c\u0648' +
-                      unicode("%07d" % x)).encode('utf-8')
-                     for x in xrange(500000)]
-        self.time(self.decode_multi, revisions, 1)
-
-    def test_decode_500K_by_1_unicode_cached(self):
-        revisions = [(u'\u062c\u0648\u062c\u0648' +
-                      unicode("%07d" % x)).encode('utf-8')
-                     for x in xrange(500000)]
-        self.time(self.decode_cached_multi, revisions, 1)

=== removed file 'bzrlib/benchmarks/bench_checkout.py'
--- bzrlib/benchmarks/bench_checkout.py	2009-03-23 14:59:43 +0000
+++ bzrlib/benchmarks/bench_checkout.py	1970-01-01 00:00:00 +0000
@@ -1,29 +0,0 @@
-# Copyright (C) 2006 Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
-
-"""Tests for bzr tree building (checkout) performance."""
-
-
-from bzrlib.benchmarks import Benchmark
-
-
-class CheckoutBenchmark(Benchmark):
-    """Benchmarks for ``'bzr checkout'`` performance."""
-
-    def test_build_kernel_like_tree(self):
-        """Checkout of a clean kernel sized tree should be (<10secs)."""
-        self.make_kernel_like_committed_tree(link_bzr=True)
-        self.time(self.run_bzr, ['checkout', '--lightweight', '.', 'acheckout'])

=== removed file 'bzrlib/benchmarks/bench_commit.py'
--- bzrlib/benchmarks/bench_commit.py	2010-06-20 11:18:38 +0000
+++ bzrlib/benchmarks/bench_commit.py	1970-01-01 00:00:00 +0000
@@ -1,80 +0,0 @@
-# Copyright (C) 2006, 2007, 2009, 2010 Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
-
-"""Benchmarks of bzr commit."""
-
-import os
-
-from bzrlib.benchmarks import Benchmark
-from bzrlib.transport.memory import MemoryServer
-
-
-class CommitBenchmark(Benchmark):
-    """Benchmarks for ``bzr commit``"""
-
-    def test_commit_kernel_like_tree(self):
-        """Commit of a fresh import of a clean kernel sized tree."""
-        # uncomment this to run the benchmark with the repository in memory
-        # not disk
-        # self.transport_server = MemoryServer
-        # self.make_kernel_like_tree(self.get_url())
-        tree = self.make_kernel_like_added_tree()
-        self.time(self.run_bzr, ['commit', '-m', 'first post'])
-
-    def test_partial_commit_kernel_like_tree(self):
-        """Commit of 1/8th of a fresh import of a clean kernel sized tree."""
-        tree = self.make_kernel_like_added_tree()
-        self.time(self.run_bzr, ['commit', '-m', 'first post', '1'])
-
-    def test_no_op_commit_in_kernel_like_tree(self):
-        """Run commit --unchanged in a kernel sized tree"""
-        tree = self.make_kernel_like_committed_tree()
-        self.time(self.run_bzr, ['commit', '-m', 'no changes', '--unchanged'])
-
-    def test_commit_one_in_kernel_like_tree(self):
-        """Time committing a single change, when not directly specified"""
-        tree = self.make_kernel_like_committed_tree()
-
-        # working-tree is hardlinked, so replace a file and commit the change
-        os.remove('4/4/4/4')
-        open('4/4/4/4', 'wb').write('new contents\n')
-        self.time(self.run_bzr, ['commit', '-m', 'second'])
-
-    def test_partial_commit_one_in_kernel_like_tree(self):
-        """Time committing a single change when it is directly specified"""
-        tree = self.make_kernel_like_committed_tree()
-
-        # working-tree is hardlinked, so replace a file and commit the change
-        os.remove('4/4/4/4')
-        open('4/4/4/4', 'wb').write('new contents\n')
-        self.time(self.run_bzr, ['commit', '-m', 'second', '4/4/4/4'])
-
-    def make_simple_tree(self):
-        """A small, simple tree. No caching needed"""
-        tree = self.make_branch_and_tree('.')
-        self.build_tree(['a', 'b/', 'b/c'])
-        tree.add(['a', 'b', 'b/c'])
-        return tree
-
-    def test_cmd_commit(self):
-        """Test execution of simple commit"""
-        tree = self.make_simple_tree()
-        self.time(self.run_bzr, ['commit', '-m', 'init simple tree'])
-
-    def test_cmd_commit_subprocess(self):
-        """Text startup and execution of a simple commit."""
-        tree = self.make_simple_tree()
-        self.time(self.run_bzr_subprocess, 'commit', '-m', 'init simple tree')

=== removed file 'bzrlib/benchmarks/bench_dirstate.py'
--- bzrlib/benchmarks/bench_dirstate.py	2010-02-17 17:11:16 +0000
+++ bzrlib/benchmarks/bench_dirstate.py	1970-01-01 00:00:00 +0000
@@ -1,426 +0,0 @@
-# Copyright (C) 2007, 2009, 2010 Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
-
-"""Benchmarks for bzr DirState performance."""
-
-import os
-
-from bzrlib import (
-    benchmarks,
-    dirstate,
-    generate_ids,
-    osutils,
-    tests,
-    )
-from bzrlib.tests.test__dirstate_helpers import (
-    compiled_dirstate_helpers_feature,
-    )
-
-
-class BenchmarkDirState(benchmarks.Benchmark):
-    """Benchmarks for DirState functions."""
-
-    def build_helper(self, layout):
-        """This is a helper with the common build_??_dirstate funcs.
-
-        :param layout: [(num_dirs, files_per_dir)]
-            The number of directories per level, and the number of files to put
-            in it.
-        :return: A DirState object with the given layout. The blocks will be
-            modified in memory, and the object will be write locked. (Callers
-            must save and unlock the object).
-        """
-        self.build_tree(['dir/'])
-        contents = 'x'*10000
-        self.build_tree_contents([('file', contents)])
-        file_stat = os.lstat('file')
-        dir_stat = os.lstat('dir')
-        file_sha1 = osutils.sha_string(contents)
-
-        state = dirstate.DirState.initialize('state')
-        def create_entries(base, layout):
-            if not layout:
-                return
-            num_dirs, num_files = layout[0]
-            for dnum in xrange(num_dirs):
-                if base:
-                    path = '%s/%02d_directory' % (base, dnum)
-                else:
-                    path = '%02d_directory' % (dnum,)
-                dir_id = generate_ids.gen_file_id(path)
-                state.add(path, dir_id, 'directory', dir_stat, '')
-                for fnum in xrange(num_files):
-                    fname = '%s/%02d_filename' % (path, fnum)
-                    file_id = generate_ids.gen_file_id(fname)
-                    state.add(fname, file_id, 'file', file_stat, file_sha1)
-                create_entries(path, layout[1:])
-        create_entries(None, layout)
-        return state
-
-    def build_10k_dirstate_dirs(self):
-        """Build a DirState file with 10k directories"""
-        state = self.build_helper([(10, 0), (10, 0), (10, 0), (10, 1)])
-        state.save()
-        state.unlock()
-        return state
-
-    def build_20k_dirstate(self):
-        """Build a DirState file with 20k records.
-
-        This approximates a kernel tree, based on the number of directories
-        (1000), and number of files per directory (20) and depth (3).
-        Because DirState doesn't have to have actual disk records, we just add
-        random files.
-        We try to have reasonable filename lengths, as well as a reasonable
-        stat value, etc.
-        """
-        state = self.build_helper([(10, 0), (10, 0), (10, 20)])
-        state.save()
-        state.unlock()
-        return state
-
-    def build_20k_dirstate_with_parents(self, num_parents):
-        """Build a DirState file with 20k records and N parents.
-
-        With 1 parent, this is equivalent to after a simple commit. With 2 it
-        is equivalent to after a merge.
-        """
-        # All files are marked as changed in the same revision, and this occurs
-        # supposedly in the history of the current trees.
-        last_changed_id = generate_ids.gen_revision_id('joe@foo.com')
-        parent_revision_ids = [generate_ids.gen_revision_id('joe@foo.com')
-                               for i in xrange(num_parents)]
-        # Start with a dirstate file with 0 parents
-        state = self.build_helper([(10, 0), (10, 0), (10, 20)])
-        try:
-            # This invasively updates the internals of DirState to be fast,
-            # since we don't have an api other than passing in Revision Tree
-            # objects, but that requires having a real inventory, etc.
-            if num_parents > 0:
-                for entry in state._iter_entries():
-                    minikind, fingerprint, size, is_exec, packed_stat = entry[1][0]
-                    for parent_id in parent_revision_ids:
-                        # Add a parent record for this record
-                        entry[1].append((minikind, fingerprint, size, is_exec,
-                                         last_changed_id))
-            state._parents = parent_revision_ids
-            state._ghosts = []
-            state.save()
-        finally:
-            state.unlock()
-        return state
-
-    def test_add_20k_entries(self):
-        """Time how long it takes to add lots of entries."""
-        state = self.time(self.build_helper, [(10, 0), (10, 0), (10, 20)])
-        state.unlock()
-
-    def test_build_20k_dirstate(self):
-        state = self.time(self.build_20k_dirstate)
-        state.lock_read()
-        try:
-            entries = list(state._iter_entries())
-            self.assertEqual(21111, len(entries))
-        finally:
-            state.unlock()
-
-    def test_build_20k_dirstate_1_parent(self):
-        state = self.time(self.build_20k_dirstate_with_parents, 1)
-        state.lock_read()
-        try:
-            state._validate()
-            entries = list(state._iter_entries())
-            self.assertEqual(21111, len(entries))
-        finally:
-            state.unlock()
-
-    def test_build_20k_dirstate_2_parents(self):
-        state = self.time(self.build_20k_dirstate_with_parents, 2)
-        state.lock_read()
-        try:
-            state._validate()
-            entries = list(state._iter_entries())
-            self.assertEqual(21111, len(entries))
-        finally:
-            state.unlock()
-
-    def test_save_20k_tree_0_parents(self):
-        state = self.build_20k_dirstate()
-        state.lock_read()
-        try:
-            self.assertEqual(dirstate.DirState.NOT_IN_MEMORY,
-                             state._dirblock_state)
-            state._read_dirblocks_if_needed()
-            state._dirblock_state = dirstate.DirState.IN_MEMORY_MODIFIED
-            self.time(state.save)
-        finally:
-            state.unlock()
-
-    def test_save_20k_tree_1_parent(self):
-        state = self.build_20k_dirstate_with_parents(1)
-        state.lock_read()
-        try:
-            self.assertEqual(dirstate.DirState.NOT_IN_MEMORY,
-                             state._dirblock_state)
-            state._read_dirblocks_if_needed()
-            state._dirblock_state = dirstate.DirState.IN_MEMORY_MODIFIED
-            self.time(state.save)
-        finally:
-            state.unlock()
-
-    def test_save_20k_tree_2_parents(self):
-        state = self.build_20k_dirstate_with_parents(2)
-        state.lock_read()
-        try:
-            self.assertEqual(dirstate.DirState.NOT_IN_MEMORY,
-                             state._dirblock_state)
-            state._read_dirblocks_if_needed()
-            state._dirblock_state = dirstate.DirState.IN_MEMORY_MODIFIED
-            self.time(state.save)
-        finally:
-            state.unlock()
-
-    def test__read_dirblocks_20k_tree_0_parents_py(self):
-        from bzrlib._dirstate_helpers_py import _read_dirblocks
-        state = self.build_20k_dirstate()
-        state.lock_read()
-        try:
-            self.assertEqual(dirstate.DirState.NOT_IN_MEMORY,
-                             state._dirblock_state)
-            state._read_header_if_needed()
-            self.time(_read_dirblocks, state)
-        finally:
-            state.unlock()
-
-    def test__read_dirblocks_20k_tree_0_parents_pyx(self):
-        self.requireFeature(compiled_dirstate_helpers_feature)
-        from bzrlib._dirstate_helpers_pyx import _read_dirblocks
-        state = self.build_20k_dirstate()
-        state.lock_read()
-        try:
-            self.assertEqual(dirstate.DirState.NOT_IN_MEMORY,
-                             state._dirblock_state)
-            state._read_header_if_needed()
-            self.time(_read_dirblocks, state)
-        finally:
-            state.unlock()
-
-    def test__read_dirblocks_20k_tree_1_parent_py(self):
-        from bzrlib._dirstate_helpers_py import _read_dirblocks
-        state = self.build_20k_dirstate_with_parents(1)
-        state.lock_read()
-        try:
-            self.assertEqual(dirstate.DirState.NOT_IN_MEMORY,
-                             state._dirblock_state)
-            state._read_header_if_needed()
-            self.time(_read_dirblocks, state)
-        finally:
-            state.unlock()
-
-    def test__read_dirblocks_20k_tree_1_parent_pyx(self):
-        self.requireFeature(compiled_dirstate_helpers_feature)
-        from bzrlib._dirstate_helpers_pyx import _read_dirblocks
-        state = self.build_20k_dirstate_with_parents(1)
-        state.lock_read()
-        try:
-            self.assertEqual(dirstate.DirState.NOT_IN_MEMORY,
-                             state._dirblock_state)
-            state._read_header_if_needed()
-            self.time(_read_dirblocks, state)
-        finally:
-            state.unlock()
-
-    def test__read_dirblocks_20k_tree_2_parents_py(self):
-        from bzrlib._dirstate_helpers_py import _read_dirblocks
-        state = self.build_20k_dirstate_with_parents(2)
-        state.lock_read()
-        try:
-            self.assertEqual(dirstate.DirState.NOT_IN_MEMORY,
-                             state._dirblock_state)
-            state._read_header_if_needed()
-            self.time(_read_dirblocks, state)
-        finally:
-            state.unlock()
-
-    def test__read_dirblocks_20k_tree_2_parents_pyx(self):
-        self.requireFeature(compiled_dirstate_helpers_feature)
-        from bzrlib._dirstate_helpers_pyx import _read_dirblocks
-        state = self.build_20k_dirstate_with_parents(2)
-        state.lock_read()
-        try:
-            self.assertEqual(dirstate.DirState.NOT_IN_MEMORY,
-                             state._dirblock_state)
-            state._read_header_if_needed()
-            self.time(_read_dirblocks, state)
-        finally:
-            state.unlock()
-
-    def do_bisect_list(self, bisect_func):
-        """Call bisect_dirblock for each path."""
-        # We use self._paths and self._blocks because we expect it to be a very
-        # long list. And the interface for 'self.time()' causes the parameters
-        # to be printed when run with --lsprof-timed. Which is *really* ugly
-        # when the list is thousands of entries.
-        blocks = self._blocks
-        return [bisect_func(blocks, path) for path in self._paths]
-
-    def do_bisect_list_cached(self, bisect_func):
-        """Same as do_bisect_list, but cache the split paths"""
-        cache = {}
-        blocks = self._blocks
-        return [bisect_func(blocks, path, cache=cache) for path in self._paths]
-
-    def setup_paths_and_offsets(self, state):
-        """Get a list of paths and expected offsets.
-
-        This will be used to check do_bisect_list*
-        """
-        state._read_dirblocks_if_needed()
-        paths = ['']
-        expected_offsets = [0]
-        for offset, info in enumerate(state._dirblocks):
-            dirname = info[0]
-            # We already handled the empty path
-            if dirname == '':
-                continue
-            # all paths are of the form ##_directory
-            # so search for ##_director, ##_directory
-            paths.extend([dirname[:-1], dirname])
-            expected_offsets.extend([offset, offset])
-        self._paths = paths
-        self._expected_offsets = expected_offsets
-        self._blocks = state._dirblocks
-
-    def checkOffsets(self, offsets):
-        """Make sure offsets matches self._expected_offsets"""
-        # These are really long lists, so it is easier to compare them with
-        # assertEqualDiff. So turn them into strings.
-        expected_str = '\n'.join(str(x) for x in self._expected_offsets)
-        offset_str = '\n'.join(str(x) for x in offsets)
-        self.assertEqualDiff(expected_str, offset_str)
-
-    def test_bisect_dirblock_py(self):
-        from bzrlib._dirstate_helpers_py import bisect_dirblock
-        state = self.build_10k_dirstate_dirs()
-        state.lock_read()
-        try:
-            self.setup_paths_and_offsets(state)
-            offsets = self.time(self.do_bisect_list,
-                                bisect_dirblock)
-            self.checkOffsets(offsets)
-        finally:
-            state.unlock()
-
-    def test_bisect_dirblock_cached_py(self):
-        from bzrlib._dirstate_helpers_py import bisect_dirblock
-        state = self.build_10k_dirstate_dirs()
-        state.lock_read()
-        try:
-            self.setup_paths_and_offsets(state)
-            offsets = self.time(self.do_bisect_list_cached,
-                                bisect_dirblock)
-            self.checkOffsets(offsets)
-        finally:
-            state.unlock()
-
-    def test_bisect_dirblock_pyx(self):
-        self.requireFeature(compiled_dirstate_helpers_feature)
-        from bzrlib._dirstate_helpers_pyx import bisect_dirblock
-        state = self.build_10k_dirstate_dirs()
-        state.lock_read()
-        try:
-            self.setup_paths_and_offsets(state)
-            offsets = self.time(self.do_bisect_list, bisect_dirblock)
-            self.checkOffsets(offsets)
-        finally:
-            state.unlock()
-
-    def create_path_names(self, layout, base=''):
-        """Create a list of paths with auto-generated names.
-
-        :param layout: A list of [(num_dirs, num_files)] tuples. For each
-            level, the given number of directories will be created, each
-            containing that many files.
-            So [(2, 5), (3, 4)] will create 2 top level directories, containing
-            5 files, and each top level directory will contain 3 subdirs with 4
-            files.
-        :param base: The base path to prepend to all entries, most callers will
-            pass ''
-        :return: A list of path names.
-        """
-        if not layout:
-            return []
-
-        paths = []
-        num_dirs, num_files = layout[0]
-        for dnum in xrange(num_dirs):
-            if base:
-                path = '%s/%02d_directory' % (base, dnum)
-            else:
-                path = '%02d_directory' % (dnum,)
-            paths.append(path)
-            for fnum in xrange(num_files):
-                fname = '%s/%02d_filename' % (path, fnum)
-                paths.append(fname)
-            paths.extend(self.create_path_names(layout[1:], base=path))
-        return paths
-
-    def test_create_path_names(self):
-        names = self.create_path_names([(2, 3), (1, 2)])
-        self.assertEqual(['00_directory',
-                          '00_directory/00_filename',
-                          '00_directory/01_filename',
-                          '00_directory/02_filename',
-                          '00_directory/00_directory',
-                          '00_directory/00_directory/00_filename',
-                          '00_directory/00_directory/01_filename',
-                          '01_directory',
-                          '01_directory/00_filename',
-                          '01_directory/01_filename',
-                          '01_directory/02_filename',
-                          '01_directory/00_directory',
-                          '01_directory/00_directory/00_filename',
-                          '01_directory/00_directory/01_filename',
-                         ], names)
-        names = self.time(self.create_path_names, [(10, 2), (10, 2), (10, 20)])
-        # 20 files + 1 directory name, 10 times, plus 2 filenames and 1 dir, 10
-        # times, and another 2 files + 1 dir, 10 times
-        self.assertEqual(21330, 10*(3 + 10*(3 + 10*(1 + 20))))
-        self.assertEqual(21330, len(names))
-
-    def compareAllPaths(self, cmp_func, layout):
-        """Compare N^2 paths.
-
-        Basically, compare every path in the list against every other path.
-        """
-        paths = self.create_path_names(layout)
-        def compare_all():
-            for path1 in paths:
-                for path2 in paths:
-                    cmp_func(path1, path2)
-        self.time(compare_all)
-
-    def test_cmp_by_dirs_py(self):
-        """Benchmark 103041 comparisons."""
-        from bzrlib._dirstate_helpers_py import cmp_by_dirs
-        self.compareAllPaths(cmp_by_dirs,
-                             [(3, 1), (3, 1), (3, 1), (3, 2)])
-
-    def test_cmp_by_dirs_pyrex(self):
-        self.requireFeature(compiled_dirstate_helpers_feature)
-        from bzrlib._dirstate_helpers_pyx import cmp_by_dirs
-        self.compareAllPaths(cmp_by_dirs,
-                             [(3, 1), (3, 1), (3, 1), (3, 2)])

=== removed file 'bzrlib/benchmarks/bench_info.py'
--- bzrlib/benchmarks/bench_info.py	2009-03-23 14:59:43 +0000
+++ bzrlib/benchmarks/bench_info.py	1970-01-01 00:00:00 +0000
@@ -1,37 +0,0 @@
-# Copyright (C) 2006 Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
-
-"""Tests for bzr info performance."""
-
-
-from bzrlib.benchmarks import Benchmark
-
-
-class InfoBenchmark(Benchmark):
-    """This is a stub. Use this benchmark with a network transport.
-    Currently "bzr info sftp://..." takes > 4 min"""
-
-    def test_no_ignored_unknown_kernel_like_tree(self):
-        """Info in a kernel sized tree with no ignored or unknowns. """
-        self.make_kernel_like_added_tree()
-        self.time(self.run_bzr, 'info')
-
-    def test_no_changes_known_kernel_like_tree(self):
-        """Info in a kernel sized tree with no ignored, unknowns, or added."""
-        self.make_kernel_like_committed_tree()
-        self.time(self.run_bzr, 'info')
-
-

=== removed file 'bzrlib/benchmarks/bench_inventory.py'
--- bzrlib/benchmarks/bench_inventory.py	2009-03-23 14:59:43 +0000
+++ bzrlib/benchmarks/bench_inventory.py	1970-01-01 00:00:00 +0000
@@ -1,39 +0,0 @@
-# Copyright (C) 2006 Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
-
-"""Tests for `bzrlib.inventory.Inventory` performance."""
-
-
-import bzrlib.inventory
-from bzrlib.benchmarks import Benchmark
-
-
-class InvBenchmark(Benchmark):
-    """Benchmarks for building large inventories."""
-
-    def test_make_10824_inv_entries(self):
-        """Making 10824 inv entries should be quick."""
-        entries = []
-        def make_10824_entries():
-            for counter in xrange(10000):
-                bzrlib.inventory.make_entry('file', 'foo',
-                    "a_parent_id")
-            for counter in xrange(824):
-                bzrlib.inventory.make_entry('directory', 'foo',
-                    "a_parent_id")
-        # on roberts machine: this originally took:  533ms/  600ms
-        # fixing slots to be vaguely accurate :      365ms/  419ms
-        self.time(make_10824_entries)

=== removed file 'bzrlib/benchmarks/bench_knit.py'
--- bzrlib/benchmarks/bench_knit.py	2010-01-25 17:48:22 +0000
+++ bzrlib/benchmarks/bench_knit.py	1970-01-01 00:00:00 +0000
@@ -1,93 +0,0 @@
-# Copyright (C) 2007 Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
-
-"""Benchmarks for Knit performance"""
-
-import os
-
-from bzrlib import (
-    generate_ids,
-    knit,
-    tests,
-    )
-from bzrlib.benchmarks import Benchmark
-from bzrlib.tests.test_knit import CompiledKnitFeature
-
-
-class BenchKnitIndex(Benchmark):
-    """Benchmark Knit index performance."""
-
-    def create_50k_index(self):
-        """Create an knit index file with 50,000 entries.
-
-        This isn't super realistic, but it *is* big :)
-
-        The file 'test.kndx' will be created.
-        """
-        rev_id = generate_ids.gen_revision_id('long.name@this.example.com')
-        versions = [(rev_id, ('fulltext',), 0, 200, [])]
-        pos = 200
-        alt_parent = None
-        for i in xrange(49999):
-            if alt_parent is not None:
-                parent_ids = [rev_id, alt_parent]
-            else:
-                parent_ids = [rev_id]
-            if i % 8 == 0:
-                # The *next* entry will be a merge
-                alt_parent = rev_id
-            else:
-                alt_parent = None
-            rev_id = generate_ids.gen_revision_id('long.name@this.example.com')
-            versions.append((rev_id, ('line-delta',), pos, 200, parent_ids))
-            pos += 200
-        t = self.get_transport()
-        kndx = knit._KnitIndex(t, 'test.kndx', 'w', create=True,
-                               delay_create=True)
-        kndx.add_versions(versions)
-
-    def setup_load_data_c(self):
-        self.requireFeature(CompiledKnitFeature)
-        from bzrlib._knit_load_data_pyx import _load_data_c
-        self.overrideAttr(knit, '_load_data', _load_data_c)
-
-    def setup_load_data_py(self):
-        from bzrlib._knit_load_data_py import _load_data_py
-        self.overrideAttr(knit, '_load_data', _load_data_py)
-
-    def test_read_50k_index_c(self):
-        self.setup_load_data_c()
-        self.create_50k_index()
-        t = self.get_transport()
-        kndx = self.time(knit._KnitIndex, t, 'test.kndx', 'r')
-
-    def test_read_50k_index_c_again(self):
-        self.setup_load_data_c()
-        self.create_50k_index()
-        t = self.get_transport()
-        kndx = self.time(knit._KnitIndex, t, 'test.kndx', 'r')
-
-    def test_read_50k_index_py(self):
-        self.create_50k_index()
-        self.setup_load_data_py()
-        t = self.get_transport()
-        kndx = self.time(knit._KnitIndex, t, 'test.kndx', 'r')
-
-    def test_read_50k_index_py_again(self):
-        self.create_50k_index()
-        self.setup_load_data_py()
-        t = self.get_transport()
-        kndx = self.time(knit._KnitIndex, t, 'test.kndx', 'r')

=== removed file 'bzrlib/benchmarks/bench_log.py'
--- bzrlib/benchmarks/bench_log.py	2009-03-23 14:59:43 +0000
+++ bzrlib/benchmarks/bench_log.py	1970-01-01 00:00:00 +0000
@@ -1,117 +0,0 @@
-# Copyright (C) 2006 Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
-
-"""Tests for tree transform performance"""
-
-import os
-import sys
-
-from bzrlib.benchmarks import Benchmark
-from bzrlib.log import log_formatter, show_log
-from bzrlib.osutils import pathjoin
-from cStringIO import StringIO
-from bzrlib.transform import TreeTransform
-from bzrlib.workingtree import WorkingTree
-
-
-class LinesDone(Exception):
-    """Raised when `LineConsumer` reaches the required number of lines."""
-    pass
-
-
-class LineConsumer(object):
-    """Count lines that are produced.
-
-    When the required number of lines have been reached, raise `LinesDone`.
-    """
-
-    def __init__(self, required_lines):
-        """Create a new consumer.
-
-        :param required_lines: How many lines must be produced.
-        :type required_lines: integer
-        """
-        self.required_lines = required_lines
-
-    def write(self, text):
-        """Write some text to the black hole.
-
-        But count how many lines have been written.
-
-        :param text: A string that would be written.
-        :raise LinesDone: when the required number of lines has been reached.
-        :return: None
-        """
-        self.required_lines -= text.count('\n')
-        if self.required_lines < 0:
-            raise LinesDone()
-
-
-class LogBenchmark(Benchmark):
-    """Benchmarks for ``'bzr log'`` performance."""
-
-    def test_log(self):
-        """Run log in a many-commit tree."""
-        tree = self.make_many_commit_tree(hardlink=True)
-        lf = log_formatter('long', to_file=StringIO())
-        self.time(show_log, tree.branch, lf, direction='reverse')
-
-    def test_merge_log(self):
-        """Run log in a tree with many merges"""
-        tree = self.make_heavily_merged_tree(hardlink=True)
-        lf = log_formatter('short', to_file=StringIO())
-        self.time(show_log, tree.branch, lf, direction='reverse')
-
-    def test_log_screenful(self):
-        """Simulate log --long|less"""
-        self.screenful_tester('long')
-
-    def test_log_screenful_line(self):
-        """Simulate log --line|less"""
-        self.screenful_tester('line')
-
-    def test_log_screenful_short(self):
-        """Simulate log --short|less"""
-        self.screenful_tester('short')
-
-    def screenful_tester(self, formatter):
-        """Run show_log, but stop after 25 lines are generated"""
-        tree = self.make_many_commit_tree(hardlink=True)
-        def log_screenful():
-            lf = log_formatter(formatter, to_file=LineConsumer(25))
-            try:
-                show_log(tree.branch, lf, direction='reverse')
-            except LinesDone:
-                pass
-            else:
-                raise Exception, "LinesDone not raised"
-        self.time(log_screenful)
-
-    def test_cmd_log(self):
-        """Test execution of the log command."""
-        tree = self.make_many_commit_tree(hardlink=True)
-        self.time(self.run_bzr, ['log', '-r', '-4..'])
-
-    def test_cmd_log_subprocess(self):
-        """Text startup and execution of the log command."""
-        tree = self.make_many_commit_tree(hardlink=True)
-        self.time(self.run_bzr_subprocess, 'log', '-r', '-4..')
-
-    def test_log_verbose(self):
-        """'verbose' log -- shows file changes"""
-        tree = self.make_many_commit_tree(hardlink=True)
-        lf = log_formatter('long', to_file=StringIO())
-        self.time(show_log, tree.branch, lf, direction='reverse', verbose=True)

=== removed file 'bzrlib/benchmarks/bench_osutils.py'
--- bzrlib/benchmarks/bench_osutils.py	2009-03-23 14:59:43 +0000
+++ bzrlib/benchmarks/bench_osutils.py	1970-01-01 00:00:00 +0000
@@ -1,37 +0,0 @@
-# Copyright (C) 2006 Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
-
-"""Tests for bzr osutils functions performance."""
-
-
-from bzrlib.benchmarks import Benchmark
-import bzrlib.osutils as osutils
-
-
-class WalkDirsBenchmark(Benchmark):
-    """Benchmarks for `bzrlib.osutils.walkdirs`"""
-
-    def test_walkdirs_kernel_like_tree(self):
-        """Walking a kernel sized tree is fast!(150ms)."""
-        self.make_kernel_like_tree(link_working=True)
-        # on roberts machine: this originally took:  157ms/4177ms
-        # plain os.walk takes 213ms on this tree
-        # with the pyrex readdir module:              77ms/5423ms
-        def dowalk():
-            for dirblock in osutils.walkdirs('.'):
-                if dirblock[0][1] == '.bzr':
-                    del dirblock[0]
-        self.time(dowalk)

=== removed file 'bzrlib/benchmarks/bench_pack.py'
--- bzrlib/benchmarks/bench_pack.py	2009-03-23 14:59:43 +0000
+++ bzrlib/benchmarks/bench_pack.py	1970-01-01 00:00:00 +0000
@@ -1,54 +0,0 @@
-# Copyright (C) 2007 Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
-
-"""Benchmarks for pack performance"""
-
-import os
-
-from bzrlib import (
-    pack,
-    )
-from bzrlib.benchmarks import Benchmark
-
-
-class BenchPack(Benchmark):
-    """Benchmark pack performance."""
-
-    def test_insert_one_gig_1k_chunks_no_names_disk(self):
-        # test real disk writing of many small chunks.
-        # useful for testing whether buffer sizes are right
-        transport = self.get_transport()
-        stream = transport.open_write_stream('pack.pack')
-        writer = pack.ContainerWriter(stream.write)
-        self.write_1_gig(writer)
-        stream.close()
-
-    def test_insert_one_gig_1k_chunks_no_names_null(self):
-        # write to dev/null so we test the pack processing.
-        transport = self.get_transport()
-        dev_null = open('/dev/null', 'wb')
-        writer = pack.ContainerWriter(dev_null.write)
-        self.write_1_gig(writer)
-        dev_null.close()
-
-    def write_1_gig(self, writer):
-        one_k = "A" * 1024
-        writer.begin()
-        def write_1g():
-            for hunk in xrange(1024 * 1024):
-                writer.add_bytes_record(one_k, [])
-        self.time(write_1g)
-        writer.end()

=== removed file 'bzrlib/benchmarks/bench_rocks.py'
--- bzrlib/benchmarks/bench_rocks.py	2009-03-23 14:59:43 +0000
+++ bzrlib/benchmarks/bench_rocks.py	1970-01-01 00:00:00 +0000
@@ -1,28 +0,0 @@
-# Copyright (C) 2006 Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
-
-"""Benchmarks of bzr rocks."""
-
-
-from bzrlib.benchmarks import Benchmark
-
-
-class RocksBenchmark(Benchmark):
-    """Benchmarks for ``'bzr rocks'``"""
-
-    def test_rocks(self):
-        """Test the startup overhead by running a do-nothing command"""
-        self.time(self.run_bzr_subprocess, 'rocks')

=== removed file 'bzrlib/benchmarks/bench_sftp.py'
--- bzrlib/benchmarks/bench_sftp.py	2009-03-23 14:59:43 +0000
+++ bzrlib/benchmarks/bench_sftp.py	1970-01-01 00:00:00 +0000
@@ -1,101 +0,0 @@
-# Copyright (C) 2006 Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
-
-"""Tests for bzr performance over SFTP"""
-
-import os
-
-from bzrlib import (
-    bzrdir,
-    )
-from bzrlib.benchmarks import Benchmark
-from bzrlib.tests import test_sftp_transport, TestSkipped
-
-try:
-    import paramiko
-    paramiko_loaded = True
-except ImportError:
-    paramiko_loaded = False
-
-
-class SFTPBenchmark(Benchmark):
-    """Benchmark branch, push and pull across a local sftp connection."""
-
-    def setUp(self):
-        super(SFTPBenchmark, self).setUp()
-        if not paramiko_loaded:
-            raise TestSkipped('you must have paramiko to run this test')
-        test_sftp_transport.set_test_transport_to_sftp(self)
-
-    def test_branch(self):
-        os.mkdir("a")
-        tree, files = self.create_with_commits(100, 100, "a")
-        self.time(bzrdir.BzrDir.open(self.get_url('a')).sprout, "b")
-
-    def create_commit_and_pull(self, num_pull_revisions):
-        os.mkdir("a")
-        tree, files = self.create_with_commits(100, 100, "a")
-        rbzrdir = bzrdir.BzrDir.open(self.get_url('a'))
-        b2 = tree.bzrdir.sprout("b") # branch
-        # change a few files and commit
-        self.commit_some_revisions(tree, files, num_pull_revisions, 20)
-        self.time(b2.open_branch().pull, rbzrdir.open_branch())
-
-    def test_pull_1(self):
-        self.create_commit_and_pull(1)
-
-    def test_pull_10(self):
-        self.create_commit_and_pull(10)
-
-    def test_pull_100(self):
-        self.create_commit_and_pull(100)
-
-    def create_commit_and_push(self, num_push_revisions):
-        os.mkdir("a")
-        tree, files = self.create_with_commits(100, 100, "a")
-        rbzrdir = bzrdir.BzrDir.open(self.get_url('a'))
-        b2 = tree.bzrdir.sprout("b") # branch
-        wtree = b2.open_workingtree()
-        # change a few files and commit
-        self.commit_some_revisions(
-            wtree, ["b/%i" for i in range(100)],
-            num_commits=num_push_revisions,
-            changes_per_commit=20)
-        self.time(rbzrdir.open_branch().pull, wtree.branch)
-
-    def test_initial_push(self):
-        os.mkdir('a')
-        tree, files = self.create_with_commits(100, 100, "a")
-        self.time(tree.bzrdir.clone, self.get_url('b'),
-                  revision_id=tree.last_revision())
-
-    def test_push_1(self):
-        self.create_commit_and_push(1)
-
-    def test_push_10(self):
-        self.create_commit_and_push(10)
-
-    def test_push_100(self):
-        self.create_commit_and_push(100)
-
-
-class SFTPSlowSocketBenchmark(SFTPBenchmark):
-    """Benchmarks of SFTP performance with a 30ms delay per roundtrip."""
-
-    def setUp(self):
-        super(SFTPSlowSocketBenchmark, self).setUp()
-        self.get_server().add_latency = 0.03
-

=== removed file 'bzrlib/benchmarks/bench_startup.py'
--- bzrlib/benchmarks/bench_startup.py	2009-03-23 14:59:43 +0000
+++ bzrlib/benchmarks/bench_startup.py	1970-01-01 00:00:00 +0000
@@ -1,91 +0,0 @@
-# Copyright (C) 2006 Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
-
-"""Benchmarks of bzr startup time, for some simple operations."""
-
-
-from bzrlib.benchmarks import Benchmark
-
-
-class StartupBenchmark(Benchmark):
-    """Benchmark startup costs for certain bzr commands."""
-
-    def make_simple_tree(self):
-        """A small, simple tree. No caching needed"""
-        tree = self.make_branch_and_tree('.')
-        self.build_tree(['a', 'b/', 'b/c'])
-        tree.add(['a', 'b', 'b/c'])
-        return tree
-
-    def make_simple_committed_tree(self):
-        tree = self.make_simple_tree()
-        tree.commit('simple commit')
-        return tree
-
-    def test___version(self):
-        """Test the startup overhead of plain bzr --version"""
-        self.time(self.run_bzr_subprocess, '--version')
-
-    def test_branch(self):
-        """Test the time to branch this into other"""
-        tree = self.make_simple_committed_tree()
-        self.time(self.run_bzr_subprocess, 'branch', '.', 'other')
-
-    def test_commit(self):
-        """Test execution of simple commit"""
-        tree = self.make_simple_tree()
-        self.time(self.run_bzr_subprocess, 'commit', '-m', 'init simple tree')
-
-    def test_diff(self):
-        """Test simple diff time"""
-        tree = self.make_simple_committed_tree()
-        self.time(self.run_bzr_subprocess, 'diff')
-
-    def test_help(self):
-        """Test the startup overhead of plain bzr help"""
-        self.time(self.run_bzr_subprocess, 'help')
-
-    def test_help_commands(self):
-        """startup time for bzr help commands, which has to load more"""
-        self.time(self.run_bzr_subprocess, 'help', 'commands')
-
-    def test_log(self):
-        """Test simple log time"""
-        tree = self.make_simple_committed_tree()
-        self.time(self.run_bzr_subprocess, 'log')
-
-    def test_missing(self):
-        """Test simple missing time"""
-        tree = self.make_simple_committed_tree()
-        other = tree.bzrdir.sprout('other')
-        self.time(self.run_bzr_subprocess, 'missing', working_dir='other')
-
-    def test_pull(self):
-        """Test simple pull time"""
-        tree = self.make_simple_committed_tree()
-        other = tree.bzrdir.sprout('other')
-        # There should be nothing to pull, and this should be determined
-        # quickly
-        self.time(self.run_bzr_subprocess, 'pull', working_dir='other')
-
-    def test_rocks(self):
-        """Test the startup overhead by running a do-nothing command"""
-        self.time(self.run_bzr_subprocess, 'rocks')
-
-    def test_status(self):
-        """Test simple status time"""
-        tree = self.make_simple_committed_tree()
-        self.time(self.run_bzr_subprocess, 'status')

=== removed file 'bzrlib/benchmarks/bench_status.py'
--- bzrlib/benchmarks/bench_status.py	2009-03-23 14:59:43 +0000
+++ bzrlib/benchmarks/bench_status.py	1970-01-01 00:00:00 +0000
@@ -1,52 +0,0 @@
-# Copyright (C) 2006, 2007 Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
-
-"""Tests for bzr status performance."""
-
-
-from bzrlib.benchmarks import Benchmark
-
-
-class StatusBenchmark(Benchmark):
-    """Benchmarks for ``'bzr status'``."""
-
-    def test_no_ignored_unknown_kernel_like_tree(self):
-        """Status in a kernel sized tree with no ignored or unknowns.
-
-        This should be bearable (<2secs) fast.
-        """
-        self.make_kernel_like_added_tree()
-        # on robertc's machine the first sample of this took 1687ms/15994ms
-        self.time(self.run_bzr, 'status')
-
-    def test_no_changes_known_kernel_like_tree(self):
-        """Status in a kernel sized tree with no ignored, unknowns, or added."""
-        self.make_kernel_like_committed_tree(link_bzr=True)
-        self.time(self.run_bzr, 'status')
-
-    def test_single_file_no_changes_known_kernel_like_tree(self):
-        """Status in a kernel sized tree with no ignored, unknowns, or added
-        of a single file."""
-        self.make_kernel_like_committed_tree()
-        #XXX depends on the filenames generated by make_kernel_like_tree
-        self.time(self.run_bzr, ['status', '7/4/0/16'])
-
-    def test_status_one_added_file_kernel_like_tree(self):
-        """Status of a single added file in our stock large tree."""
-        self.make_kernel_like_tree()
-        self.run_bzr('add')
-        self.run_bzr(['commit', '-m', 'initial import'])
-        self.time(self.run_bzr, ['status', '3/3/3/10'])

=== removed file 'bzrlib/benchmarks/bench_tags.py'
--- bzrlib/benchmarks/bench_tags.py	2009-05-27 08:33:37 +0000
+++ bzrlib/benchmarks/bench_tags.py	1970-01-01 00:00:00 +0000
@@ -1,58 +0,0 @@
-# Copyright (C) 2007 Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
-
-"""Test for tags serialization (indirect testing for bencode)"""
-
-
-import time
-
-from bzrlib.benchmarks import Benchmark
-import bzrlib.bencode
-import bzrlib.tag
-
-
-class TagsBencodeBenchmark(Benchmark):
-    """Benchmark for serialization/deserialization of tags"""
-
-    def setUp(self):
-        super(TagsBencodeBenchmark, self).setUp()
-        self.tobj = bzrlib.tag.BasicTags(None)
-        tags = {}
-        revid = 'j.random@example.com-20070812132500-%016d'
-        for i in xrange(100):
-            tags[str(i)] = revid % i
-        self.tags = tags
-        self.bencoded_tags = bzrlib.bencode.bencode(tags)
-
-    def time_N(self, N, kallable, *args, **kwargs):
-        def _func(N, kallable, *args, **kwargs):
-            for i in xrange(N):
-                kallable(*args, **kwargs)
-        self.time(_func, N, kallable, *args, **kwargs)
-
-    def test_serialize_empty_tags(self):
-        # Measure overhead of operation
-        self.time_N(10000, self.tobj._serialize_tag_dict, {})
-
-    def test_deserialize_empty_tags(self):
-        # Measure overhead of operation
-        self.time_N(10000, self.tobj._deserialize_tag_dict, 'de')
-
-    def test_serialize_tags(self):
-        self.time_N(1000, self.tobj._serialize_tag_dict, self.tags)
-
-    def test_deserialize_tags(self):
-        self.time_N(1000, self.tobj._deserialize_tag_dict, self.bencoded_tags)

=== removed file 'bzrlib/benchmarks/bench_transform.py'
--- bzrlib/benchmarks/bench_transform.py	2009-03-23 14:59:43 +0000
+++ bzrlib/benchmarks/bench_transform.py	1970-01-01 00:00:00 +0000
@@ -1,43 +0,0 @@
-# Copyright (C) 2006 Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
-
-"""Tests for tree transform performance"""
-
-import os
-
-from bzrlib.benchmarks import Benchmark
-from bzrlib.osutils import pathjoin
-from bzrlib.transform import TreeTransform
-from bzrlib.workingtree import WorkingTree
-
-
-class TransformBenchmark(Benchmark):
-    """Benchmarks for `bzrlib.transform`"""
-
-    def test_canonicalize_path(self):
-        """Canonicalizing paths should be fast."""
-        wt = self.make_kernel_like_tree(link_working=True)
-        paths = []
-        for dirpath, dirnames, filenames in os.walk('.'):
-            paths.extend(pathjoin(dirpath, d) for d in dirnames)
-            paths.extend(pathjoin(dirpath, f) for f in filenames)
-        tt = TreeTransform(wt)
-        self.time(self.canonicalize_paths, tt, paths)
-        tt.finalize()
-
-    def canonicalize_paths(self, tt, paths):
-        for path in paths:
-            tt.canonical_path(path)

=== removed file 'bzrlib/benchmarks/bench_workingtree.py'
--- bzrlib/benchmarks/bench_workingtree.py	2009-03-23 14:59:43 +0000
+++ bzrlib/benchmarks/bench_workingtree.py	1970-01-01 00:00:00 +0000
@@ -1,111 +0,0 @@
-# Copyright (C) 2006 Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
-
-"""Tests for bzr working tree performance."""
-
-import os
-
-from bzrlib import ignores
-from bzrlib.benchmarks import Benchmark
-from bzrlib.workingtree import WorkingTree
-
-
-class WorkingTreeBenchmark(Benchmark):
-    """Benchmarks for `bzrlib.workingtree` performance."""
-
-    def test_list_files_kernel_like_tree(self):
-        tree = self.make_kernel_like_added_tree()
-        tree.lock_read()
-        try:
-            self.time(list, tree.list_files())
-        finally:
-            tree.unlock()
-
-    def test_list_files_unknown_kernel_like_tree(self):
-        tree = self.make_kernel_like_tree(link_working=True)
-        tree = WorkingTree.open('.')
-        # Bzr only traverses directories if they are versioned
-        # So add all the directories, but not the files, yielding
-        # lots of unknown files.
-        for root, dirs, files in os.walk('.'):
-            if '.bzr' in dirs:
-                dirs.remove('.bzr')
-            if root == '.':
-                continue
-            tree.add(root)
-        tree.lock_read()
-        try:
-            self.time(list, tree.list_files())
-        finally:
-            tree.unlock()
-
-    def test_is_ignored_single_call(self):
-        """How long does is_ignored take to initialise and check one file."""
-        t = self.make_branch_and_tree('.')
-        self.time(t.is_ignored, "CVS")
-
-    def test_is_ignored_10824_calls(self):
-        """How long does is_ignored take to initialise and check one file."""
-        t = self.make_branch_and_tree('.')
-        def call_is_ignored_10824_not_ignored():
-            for x in xrange(10824):
-                t.is_ignored(str(x))
-        self.time(call_is_ignored_10824_not_ignored)
-
-    def test_is_ignored_10_patterns(self):
-        t = self.make_branch_and_tree('.')
-        ignores.add_runtime_ignores([u'*.%i' % i for i in range(1, 9)])
-        ignores.add_runtime_ignores(['./foo', 'foo/bar'])
-        self.time(t.is_ignored,'bar')
-        ignores._runtime_ignores = set()
-
-    def test_is_ignored_50_patterns(self):
-        t = self.make_branch_and_tree('.')
-        ignores.add_runtime_ignores([u'*.%i' % i for i in range(1, 49)])
-        ignores.add_runtime_ignores(['./foo', 'foo/bar'])
-        self.time(t.is_ignored,'bar')
-        ignores._runtime_ignores = set()
-
-    def test_is_ignored_100_patterns(self):
-        t = self.make_branch_and_tree('.')
-        ignores.add_runtime_ignores([u'*.%i' % i for i in range(1, 99)])
-        ignores.add_runtime_ignores(['./foo', 'foo/bar'])
-        self.time(t.is_ignored,'bar')
-        ignores._runtime_ignores = set()
-
-    def test_is_ignored_1000_patterns(self):
-        t = self.make_branch_and_tree('.')
-        ignores.add_runtime_ignores([u'*.%i' % i for i in range(1, 999)])
-        ignores.add_runtime_ignores(['./foo', 'foo/bar'])
-        self.time(t.is_ignored,'bar')
-        ignores._runtime_ignores = set()
-
-    def test_walkdirs_kernel_like_tree(self):
-        """Walking a kernel sized tree is fast!(150ms)."""
-        self.make_kernel_like_tree()
-        self.run_bzr('add')
-        tree = WorkingTree.open('.')
-        # on roberts machine: this originally took:  157ms/4177ms
-        # plain os.walk takes 213ms on this tree
-        self.time(list, tree.walkdirs())
-
-    def test_walkdirs_kernel_like_tree_unknown(self):
-        """Walking a kernel sized tree is fast!(150ms)."""
-        self.make_kernel_like_tree()
-        tree = WorkingTree.open('.')
-        # on roberts machine: this originally took:  157ms/4177ms
-        # plain os.walk takes 213ms on this tree
-        self.time(list, tree.walkdirs())

=== removed file 'bzrlib/benchmarks/bench_xml.py'
--- bzrlib/benchmarks/bench_xml.py	2009-03-23 14:59:43 +0000
+++ bzrlib/benchmarks/bench_xml.py	1970-01-01 00:00:00 +0000
@@ -1,87 +0,0 @@
-# Copyright (C) 2006 Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
-
-"""Tests for bzr xml serialization performance."""
-
-from bzrlib import (
-    cache_utf8,
-    xml5,
-    )
-from bzrlib.benchmarks import Benchmark
-
-
-class BenchXMLSerializer(Benchmark):
-    """Benchmarks for serializing to/from XML."""
-
-    def test_write_to_string_kernel_like_inventory(self):
-        # On jam's machine, ElementTree serializer took: 2161ms/13487ms
-        #                      with Robert's serializer:  631ms/10770ms
-        #                      with Entity escaper:       487ms/11636ms
-        #           caching Entity escaper, empty cache:  448ms/ 9489ms
-        #           caching Entity escaper, full cache:   375ms/ 9489ms
-        #                      passing around function:   406ms/ 8942ms
-        #              cached, passing around function:   328ms/11248ms
-        #                      removing extra function:   354ms/ 8942ms
-        #              cached, removing extra function:   275ms/11248ms
-        #                          no cache, real utf8:   363ms/11697ms
-        #                            cached, real utf8:   272ms/12827ms
-        # Really all we want is a real inventory
-        inv = self.make_kernel_like_inventory()
-
-        xml5._clear_cache()
-        # We want a real tree with lots of file ids and sha strings, etc.
-        self.time(xml5.serializer_v5.write_inventory_to_string, inv)
-
-    def test_write_kernel_like_inventory(self):
-        # Really all we want is a real inventory
-        inv = self.make_kernel_like_inventory()
-
-        xml5._clear_cache()
-        f = open('kernel-like-inventory', 'wb')
-        try:
-            # We want a real tree with lots of file ids and sha strings, etc.
-            self.time(xml5.serializer_v5.write_inventory, inv, f)
-        finally:
-            f.close()
-
-    def test_write_to_string_cached_kernel_like_inventory(self):
-        inv = self.make_kernel_like_inventory()
-
-        xml5._clear_cache()
-        # We want a real tree with lots of file ids and sha strings, etc.
-        xml5.serializer_v5.write_inventory_to_string(inv)
-
-        self.time(xml5.serializer_v5.write_inventory_to_string, inv)
-
-    def test_read_from_string_kernel_like_inventory(self):
-        inv = self.make_kernel_like_inventory()
-        as_str = xml5.serializer_v5.write_inventory_to_string(inv)
-
-        cache_utf8.clear_encoding_cache()
-        read_inv = self.time(xml5.serializer_v5.read_inventory_from_string,
-                             as_str)
-        # TODO: make sure the final inventory is equal as a sanity check
-
-    def test_read_from_string_cached_kernel_like_inventory(self):
-        cache_utf8.clear_encoding_cache()
-        inv = self.make_kernel_like_inventory()
-        as_str = xml5.serializer_v5.write_inventory_to_string(inv)
-
-        xml5.serializer_v5.read_inventory_from_string(as_str)
-
-        read_inv = self.time(xml5.serializer_v5.read_inventory_from_string,
-                             as_str)
-        # TODO: make sure the final inventory is equal as a sanity check

=== removed directory 'bzrlib/benchmarks/tree_creator'
=== removed file 'bzrlib/benchmarks/tree_creator/__init__.py'
--- bzrlib/benchmarks/tree_creator/__init__.py	2009-03-23 14:59:43 +0000
+++ bzrlib/benchmarks/tree_creator/__init__.py	1970-01-01 00:00:00 +0000
@@ -1,175 +0,0 @@
-# Copyright (C) 2006 Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
-
-"""Base implementation of TreeCreator classes
-
-These are classes that are used to easily create test trees.
-"""
-
-import os
-import shutil
-
-from bzrlib import (
-    osutils,
-    workingtree,
-    )
-
-
-class TreeCreator(object):
-    """Just a basic class which is used to create various test trees"""
-
-    CACHE_ROOT = None
-
-    def __init__(self, test, tree_name,
-                 link_bzr=False,
-                 link_working=False,
-                 hot_cache=True):
-        """Instantiate a new creator object, supply the id of the tree
-
-        :param test: A TestCaseWithTransport object (most creators need
-            we need the build_tree functionality)
-        """
-
-        self._cache_root = TreeCreator.CACHE_ROOT
-        self._test = test
-        self._tree_name = tree_name
-        self._link_bzr = link_bzr
-        self._link_working = link_working
-        self._hot_cache = hot_cache
-        if not osutils.hardlinks_good():
-            self._link_working = self._link_bzr = False
-
-    def is_caching_enabled(self):
-        """Will we try to cache the tree we create?"""
-        return self._cache_root is not None
-
-    def is_cached(self):
-        """Is this tree already cached?"""
-        cache_dir = self._get_cache_dir()
-        if cache_dir is None:
-            return False
-        return os.path.exists(cache_dir)
-
-    def disable_cache(self):
-        """Do not use the cache"""
-        self._cache_root = None
-
-    def ensure_cached(self):
-        """If caching, make sure the cached copy exists"""
-        cache_dir = self._get_cache_dir()
-        if cache_dir is None:
-            return
-
-        if not self.is_cached():
-            self._create_tree(root=cache_dir, in_cache=True)
-
-    def create(self, root):
-        """Create a new tree at 'root'.
-
-        :return: A WorkingTree object.
-        """
-        cache_dir = self._get_cache_dir()
-        if cache_dir is None:
-            # Not caching
-            return self._create_tree(root, in_cache=False)
-
-        self.ensure_cached()
-
-        return self._clone_cached_tree(root)
-
-    def _get_cache_dir(self):
-        """Get the directory to use for caching this tree
-
-        :return: The path to use for caching. If None, caching is disabled
-        """
-        if self._cache_root is None:
-            return None
-        return osutils.pathjoin(self._cache_root, self._tree_name)
-
-    def _create_tree(self, root, in_cache=False):
-        """Create the desired tree in the given location.
-
-        Children should override this function to provide the actual creation
-        of the desired tree. This will be called by 'create()'. If it is
-        building a tree in the cache, before copying it to the real target,
-        it will pass in_cache=True
-        """
-        raise NotImplemented(self._create_tree)
-
-    def _clone_cached_tree(self, dest):
-        """Copy the contents of the cached dir into the destination
-        Optionally hardlink certain pieces of the tree.
-
-        This is just meant as a helper function for child classes
-
-        :param dest: The destination to copy things to
-        """
-        # We use shutil.copyfile so that we don't copy permissions
-        # because most of our source trees are marked readonly to
-        # prevent modifying in the case of hardlinks
-        handlers = {'file':shutil.copyfile}
-        if osutils.hardlinks_good():
-            if self._link_working:
-                if self._link_bzr:
-                    handlers = {'file':os.link}
-                else:
-                    # Don't hardlink files inside bzr
-                    def file_handler(source, dest):
-                        if '.bzr/' in source:
-                            shutil.copyfile(source, dest)
-                        else:
-                            os.link(source, dest)
-                    handlers = {'file':file_handler}
-            elif self._link_bzr:
-                # Only link files inside .bzr/
-                def file_handler(source, dest):
-                    if '.bzr/' in source:
-                        os.link(source, dest)
-                    else:
-                        shutil.copyfile(source, dest)
-                handlers = {'file':file_handler}
-
-        source = self._get_cache_dir()
-        osutils.copy_tree(source, dest, handlers=handlers)
-        tree = workingtree.WorkingTree.open(dest)
-        if self._hot_cache:
-            tree.lock_write()
-            try:
-                # tree._hashcache.scan() just checks and removes
-                # entries that are out of date
-                # we need to actually store new ones
-                for path, ie in tree.inventory.iter_entries_by_dir():
-                    tree.get_file_sha1(ie.file_id, path)
-            finally:
-                tree.unlock()
-        # If we didn't iterate the tree, the hash cache is technically
-        # invalid, and it would be better to remove it, but there is
-        # no public api for that.
-        return tree
-
-    def _protect_files(self, root):
-        """Chmod all files underneath 'root' to prevent writing
-
-        This is a helper function for child classes.
-
-        :param root: The base directory to modify
-        """
-        for dirinfo, entries in osutils.walkdirs(root):
-            for relpath, name, kind, st, abspath in entries:
-                if kind == 'file':
-                    os.chmod(abspath, 0440)
-
-

=== removed file 'bzrlib/benchmarks/tree_creator/heavily_merged.py'
--- bzrlib/benchmarks/tree_creator/heavily_merged.py	2009-03-23 14:59:43 +0000
+++ bzrlib/benchmarks/tree_creator/heavily_merged.py	1970-01-01 00:00:00 +0000
@@ -1,75 +0,0 @@
-# Copyright (C) 2006 Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
-
-"""Tree creator for many commits, but no changes"""
-
-import errno
-import os
-
-from bzrlib import (
-    bzrdir,
-    )
-
-from bzrlib.benchmarks.tree_creator import TreeCreator
-
-
-class HeavilyMergedTreeCreator(TreeCreator):
-    """Create a tree in which almost every commit is a merge.
-
-    No file changes are included.  This produces two trees,
-    one of which is returned.  Except for the first commit, every
-    commit in its revision-history is a merge of another commit in the other
-    tree.
-    Not hardlinking the working tree, because there are no working tree files.
-    """
-
-    def __init__(self, test, link_bzr=True):
-        super(HeavilyMergedTreeCreator, self).__init__(test,
-            tree_name='heavily_merged_tree',
-            link_bzr=link_bzr,
-            link_working=False,
-            hot_cache=True)
-
-    def _create_tree(self, root, in_cache=False):
-        try:
-            os.mkdir(root)
-        except (IOError, OSError), e:
-            if e.errno not in (errno.EEXIST,):
-                raise
-
-        tree = bzrdir.BzrDir.create_standalone_workingtree(root)
-        tree.lock_write()
-        try:
-            tree2 = tree.bzrdir.sprout(root + '/tree2').open_workingtree()
-            tree2.lock_write()
-            try:
-                for i in xrange(250):
-                    revision_id = tree.commit('no-changes commit %d-a' % i)
-                    tree2.branch.fetch(tree.branch, revision_id)
-                    tree2.add_parent_tree_id(revision_id)
-                    revision_id = tree2.commit('no-changes commit %d-b' % i)
-                    tree.branch.fetch(tree2.branch, revision_id)
-                    tree.add_parent_tree_id(revision_id)
-                tree.set_parent_ids(tree.get_parent_ids()[:1])
-            finally:
-                tree2.unlock()
-        finally:
-            tree.unlock()
-        if in_cache:
-            self._protect_files(root+'/.bzr')
-        return tree
-
-

=== removed file 'bzrlib/benchmarks/tree_creator/kernel_like.py'
--- bzrlib/benchmarks/tree_creator/kernel_like.py	2010-03-25 09:39:03 +0000
+++ bzrlib/benchmarks/tree_creator/kernel_like.py	1970-01-01 00:00:00 +0000
@@ -1,225 +0,0 @@
-# Copyright (C) 2006-2010 Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
-
-"""Tree creators for kernel-like trees"""
-
-import errno
-import os
-
-from bzrlib import (
-    bzrdir,
-    osutils,
-    workingtree,
-    xml5,
-    )
-
-from bzrlib.benchmarks.tree_creator import TreeCreator
-
-
-class KernelLikeTreeCreator(TreeCreator):
-    """Create a basic tree with ~10k unversioned files"""
-
-    def __init__(self, test, link_working=False, url=None):
-        super(KernelLikeTreeCreator, self).__init__(test,
-            tree_name='kernel_like_tree',
-            link_working=link_working,
-            link_bzr=False)
-
-        self._url = url
-
-    def create(self, root):
-        """Create all the kernel files in the given location.
-
-        This is overloaded for compatibility reasons.
-        """
-        if self._url is not None:
-            b = bzrdir.BzrDir.create_branch_convenience(self._url)
-            d = bzrdir.BzrDir.create(root)
-            bzrlib.branch.BranchReferenceFormat().initialize(d,
-                target_branch=b)
-            tree = d.create_workingtree()
-        else:
-            tree = bzrdir.BzrDir.create_standalone_workingtree(root)
-
-        if not self._link_working or not self.is_caching_enabled():
-            # Turns out that 'shutil.copytree()' is no faster than
-            # just creating them. Probably the python overhead.
-            # Plain _make_kernel_files takes 3-5s
-            # cp -a takes 3s
-            # using hardlinks takes < 1s.
-            self._create_tree(root=root, in_cache=False)
-            return tree
-
-        self.ensure_cached()
-        cache_dir = self._get_cache_dir()
-        osutils.copy_tree(cache_dir, root,
-                          handlers={'file':os.link})
-        return tree
-
-    def _create_tree(self, root, in_cache=False):
-        # a kernel tree has ~10000 and 500 directory, with most files around
-        # 3-4 levels deep.
-        # we simulate this by three levels of dirs named 0-7, givin 512 dirs,
-        # and 20 files each.
-        files = []
-        for outer in range(8):
-            files.append("%s/" % outer)
-            for middle in range(8):
-                files.append("%s/%s/" % (outer, middle))
-                for inner in range(8):
-                    prefix = "%s/%s/%s/" % (outer, middle, inner)
-                    files.append(prefix)
-                    files.extend([prefix + str(foo) for foo in range(20)])
-        cwd = osutils.getcwd()
-        try:
-            os.mkdir(root)
-        except OSError, e:
-            if e.errno not in (errno.EEXIST,):
-                raise
-        os.chdir(root)
-        self._test.build_tree(files)
-        os.chdir(cwd)
-        if in_cache:
-            self._protect_files(root)
-
-
-class KernelLikeAddedTreeCreator(TreeCreator):
-    """Create a tree with ~10k versioned but not committed files"""
-
-    def __init__(self, test, link_working=False, hot_cache=True):
-        super(KernelLikeAddedTreeCreator, self).__init__(test,
-            tree_name='kernel_like_added_tree',
-            link_working=link_working,
-            link_bzr=False,
-            hot_cache=hot_cache)
-
-    def _create_tree(self, root, in_cache=False):
-        """Create a kernel-like tree with the all files added
-
-        :param root: The root directory to create the files
-        :param in_cache: Is this being created in the cache dir?
-        """
-        kernel_creator = KernelLikeTreeCreator(self._test,
-                                               link_working=in_cache)
-        tree = kernel_creator.create(root=root)
-
-        # Add everything to it
-        tree.lock_write()
-        try:
-            tree.smart_add([root], recurse=True, save=True)
-            if in_cache:
-                self._protect_files(root+'/.bzr')
-        finally:
-            tree.unlock()
-        return tree
-
-
-class KernelLikeCommittedTreeCreator(TreeCreator):
-    """Create a tree with ~10K files, and a single commit adding all of them"""
-
-    def __init__(self, test, link_working=False, link_bzr=False,
-                 hot_cache=True):
-        super(KernelLikeCommittedTreeCreator, self).__init__(test,
-            tree_name='kernel_like_committed_tree',
-            link_working=link_working,
-            link_bzr=link_bzr,
-            hot_cache=hot_cache)
-
-    def _create_tree(self, root, in_cache=False):
-        """Create a kernel-like tree with all files committed
-
-        :param root: The root directory to create the files
-        :param in_cache: Is this being created in the cache dir?
-        """
-        kernel_creator = KernelLikeAddedTreeCreator(self._test,
-                                                    link_working=in_cache,
-                                                    hot_cache=(not in_cache))
-        tree = kernel_creator.create(root=root)
-        tree.commit('first post', rev_id='r1')
-
-        if in_cache:
-            self._protect_files(root+'/.bzr')
-        return tree
-
-
-class KernelLikeInventoryCreator(TreeCreator):
-    """Return just the memory representation of a committed kernel-like tree"""
-
-    def __init__(self, test):
-        super(KernelLikeInventoryCreator, self).__init__(test,
-            tree_name='kernel_like_inventory',
-            link_working=True,
-            link_bzr=True,
-            hot_cache=True)
-
-    def ensure_cached(self):
-        """Make sure we have a cached version of the kernel-like inventory"""
-        cache_dir = self._get_cache_dir()
-        if cache_dir is None:
-            return
-
-        if self.is_cached():
-            return
-
-        committed_creator = KernelLikeCommittedTreeCreator(self._test,
-                                                           link_working=True,
-                                                           link_bzr=True,
-                                                           hot_cache=False)
-        committed_creator.ensure_cached()
-        committed_cache_dir = committed_creator._get_cache_dir()
-        committed_tree = workingtree.WorkingTree.open(committed_cache_dir)
-        rev_tree = committed_tree.basis_tree()
-        os.mkdir(cache_dir)
-        f = open(cache_dir+'/inventory', 'wb')
-        try:
-            xml5.serializer_v5.write_inventory(rev_tree.inventory, f)
-        finally:
-            f.close()
-
-    def create(self, root=None):
-        """Create a kernel like inventory
-
-        :param root: Exists to mimic the base class, but this class
-            returns only an in-memory Inventory, so it should always be None.
-        :return: An Inventory object.
-        """
-        cache_dir = self._get_cache_dir()
-        if cache_dir is None:
-            return self._create_and_return()
-
-        self.ensure_cached()
-        return self._open_cached(cache_dir)
-
-    def _create_and_return(self):
-        """Create a kernel-like tree, and return its inventory"""
-        creator = KernelLikeCommittedTreeCreator(self._test,
-                                                 link_working=True,
-                                                 link_bzr=True,
-                                                 hot_cache=False)
-        tree = creator.create('.')
-        basis = tree.basis_tree()
-        basis.lock_read()
-        try:
-            return basis.inventory
-        finally:
-            basis.unlock()
-
-    def _open_cached(self, cache_dir):
-        f = open(cache_dir + '/inventory', 'rb')
-        try:
-            return xml5.serializer_v5.read_inventory(f)
-        finally:
-            f.close()

=== removed file 'bzrlib/benchmarks/tree_creator/many_commit.py'
--- bzrlib/benchmarks/tree_creator/many_commit.py	2009-03-23 14:59:43 +0000
+++ bzrlib/benchmarks/tree_creator/many_commit.py	1970-01-01 00:00:00 +0000
@@ -1,68 +0,0 @@
-# Copyright (C) 2006 Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
-
-"""Tree creator for many commits, including file changes."""
-
-from bzrlib import (
-    bzrdir,
-    )
-
-from bzrlib.benchmarks.tree_creator import TreeCreator
-
-
-class ManyCommitTreeCreator(TreeCreator):
-    """Create an tree many files and many commits."""
-
-    def __init__(self, test, link_bzr=False, num_files=10, num_commits=10):
-        tree_name = 'many_files_many_commit_tree_%d_%d' % (
-            num_files, num_commits)
-        super(ManyCommitTreeCreator, self).__init__(test,
-            tree_name=tree_name,
-            link_bzr=link_bzr,
-            link_working=False,
-            hot_cache=True)
-        self.files = ["%s" % (i, ) for i in range(num_files)]
-        self.num_files = num_files
-        self.num_commits = num_commits
-
-    def _create_tree(self, root, in_cache=False):
-        num_files = self.num_files
-        num_commits = self.num_commits
-        files = ["%s/%s" % (root, fn) for fn in self.files]
-        for fn in files:
-            f = open(fn, "wb")
-            try:
-                f.write("some content\n")
-            finally:
-                f.close()
-        tree = bzrdir.BzrDir.create_standalone_workingtree(root)
-        tree.add(self.files)
-        tree.lock_write()
-        try:
-            tree.commit('initial commit')
-            for i in range(num_commits):
-                fn = files[i % len(files)]
-                content = range(i) + [i, i, i, ""]
-                f = open(fn, "wb")
-                try:
-                    f.write("\n".join([str(i) for i in content]))
-                finally:
-                    f.close()
-                tree.commit("changing file %s" % fn)
-        finally:
-            tree.unlock()
-        return tree
-

=== removed file 'bzrlib/benchmarks/tree_creator/simple_many_commit.py'
--- bzrlib/benchmarks/tree_creator/simple_many_commit.py	2009-03-23 14:59:43 +0000
+++ bzrlib/benchmarks/tree_creator/simple_many_commit.py	1970-01-01 00:00:00 +0000
@@ -1,47 +0,0 @@
-# Copyright (C) 2006 Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
-
-"""Tree creator for many commits, but no changes"""
-
-from bzrlib import (
-    bzrdir,
-    )
-
-from bzrlib.benchmarks.tree_creator import TreeCreator
-
-
-class SimpleManyCommitTreeCreator(TreeCreator):
-    """Create an empty tree with lots of commits"""
-
-    def __init__(self, test, link_bzr=False):
-        super(SimpleManyCommitTreeCreator, self).__init__(test,
-            tree_name='many_commit_tree',
-            link_bzr=link_bzr,
-            link_working=False,
-            hot_cache=True)
-
-    def _create_tree(self, root, in_cache=False):
-        tree = bzrdir.BzrDir.create_standalone_workingtree(root)
-        tree.lock_write()
-        try:
-            for i in xrange(1000):
-                tree.commit('no-changes commit %d' % i)
-        finally:
-            tree.unlock()
-        if in_cache:
-            self._protect_files(root+'/.bzr')
-
-        return tree

=== modified file 'bzrlib/branch.py'
--- bzrlib/branch.py	2010-06-30 08:34:11 +0000
+++ bzrlib/branch.py	2010-07-29 11:17:57 +0000
@@ -246,9 +246,13 @@
         if not local and not config.has_explicit_nickname():
             try:
                 master = self.get_master_branch(possible_transports)
+                if master and self.user_url == master.user_url:
+                    raise errors.RecursiveBind(self.user_url)
                 if master is not None:
                     # return the master branch value
                     return master.nick
+            except errors.RecursiveBind, e:
+                raise e
             except errors.BzrError, e:
                 # Silently fall back to local implicit nick if the master is
                 # unavailable
@@ -3309,6 +3313,15 @@
         """
         raise NotImplementedError(self.push)
 
+    @needs_write_lock
+    def copy_content_into(self, revision_id=None):
+        """Copy the content of source into target
+
+        revision_id: if not None, the revision history in the new branch will
+                     be truncated to end with revision_id.
+        """
+        raise NotImplementedError(self.copy_content_into)
+
 
 class GenericInterBranch(InterBranch):
     """InterBranch implementation that uses public Branch functions."""

=== modified file 'bzrlib/builtins.py'
--- bzrlib/builtins.py	2010-07-10 21:28:56 +0000
+++ bzrlib/builtins.py	2010-08-15 04:52:51 +0000
@@ -20,7 +20,6 @@
 
 from bzrlib.lazy_import import lazy_import
 lazy_import(globals(), """
-import codecs
 import cStringIO
 import sys
 import time
@@ -75,14 +74,11 @@
 from bzrlib.trace import mutter, note, warning, is_quiet, get_verbosity_level
 
 
+@symbol_versioning.deprecated_function(symbol_versioning.deprecated_in((2, 3, 0)))
 def tree_files(file_list, default_branch=u'.', canonicalize=True,
     apply_view=True):
-    try:
-        return internal_tree_files(file_list, default_branch, canonicalize,
-            apply_view)
-    except errors.FileInWrongBranch, e:
-        raise errors.BzrCommandError("%s is not in the same branch as %s" %
-                                     (e.path, file_list[0]))
+    return internal_tree_files(file_list, default_branch, canonicalize,
+        apply_view)
 
 
 def tree_files_for_add(file_list):
@@ -152,10 +148,13 @@
 
 # XXX: Bad function name; should possibly also be a class method of
 # WorkingTree rather than a function.
+@symbol_versioning.deprecated_function(symbol_versioning.deprecated_in((2, 3, 0)))
 def internal_tree_files(file_list, default_branch=u'.', canonicalize=True,
     apply_view=True):
     """Convert command-line paths to a WorkingTree and relative paths.
 
+    Deprecated: use WorkingTree.open_containing_paths instead.
+
     This is typically used for command-line processors that take one or
     more filenames, and infer the workingtree that contains them.
 
@@ -171,53 +170,10 @@
 
     :return: workingtree, [relative_paths]
     """
-    if file_list is None or len(file_list) == 0:
-        tree = WorkingTree.open_containing(default_branch)[0]
-        if tree.supports_views() and apply_view:
-            view_files = tree.views.lookup_view()
-            if view_files:
-                file_list = view_files
-                view_str = views.view_display_str(view_files)
-                note("Ignoring files outside view. View is %s" % view_str)
-        return tree, file_list
-    tree = WorkingTree.open_containing(osutils.realpath(file_list[0]))[0]
-    return tree, safe_relpath_files(tree, file_list, canonicalize,
-        apply_view=apply_view)
-
-
-def safe_relpath_files(tree, file_list, canonicalize=True, apply_view=True):
-    """Convert file_list into a list of relpaths in tree.
-
-    :param tree: A tree to operate on.
-    :param file_list: A list of user provided paths or None.
-    :param apply_view: if True and a view is set, apply it or check that
-        specified files are within it
-    :return: A list of relative paths.
-    :raises errors.PathNotChild: When a provided path is in a different tree
-        than tree.
-    """
-    if file_list is None:
-        return None
-    if tree.supports_views() and apply_view:
-        view_files = tree.views.lookup_view()
-    else:
-        view_files = []
-    new_list = []
-    # tree.relpath exists as a "thunk" to osutils, but canonical_relpath
-    # doesn't - fix that up here before we enter the loop.
-    if canonicalize:
-        fixer = lambda p: osutils.canonical_relpath(tree.basedir, p)
-    else:
-        fixer = tree.relpath
-    for filename in file_list:
-        try:
-            relpath = fixer(osutils.dereference_path(filename))
-            if  view_files and not osutils.is_inside_any(view_files, relpath):
-                raise errors.FileOutsideView(filename, view_files)
-            new_list.append(relpath)
-        except errors.PathNotChild:
-            raise errors.FileInWrongBranch(tree.branch, filename)
-    return new_list
+    return WorkingTree.open_containing_paths(
+        file_list, default_directory='.',
+        canonicalize=True,
+        apply_view=True)
 
 
 def _get_view_info_for_change_reporter(tree):
@@ -323,7 +279,7 @@
             raise errors.BzrCommandError('bzr status --revision takes exactly'
                                          ' one or two revision specifiers')
 
-        tree, relfile_list = tree_files(file_list)
+        tree, relfile_list = WorkingTree.open_containing_paths(file_list)
         # Avoid asking for specific files when that is not needed.
         if relfile_list == ['']:
             relfile_list = None
@@ -761,7 +717,7 @@
             raise errors.BzrCommandError('invalid kind %r specified' % (kind,))
 
         revision = _get_one_revision('inventory', revision)
-        work_tree, file_list = tree_files(file_list)
+        work_tree, file_list = WorkingTree.open_containing_paths(file_list)
         self.add_cleanup(work_tree.lock_read().unlock)
         if revision is not None:
             tree = revision.as_tree(work_tree.branch)
@@ -832,7 +788,7 @@
             names_list = []
         if len(names_list) < 2:
             raise errors.BzrCommandError("missing file argument")
-        tree, rel_names = tree_files(names_list, canonicalize=False)
+        tree, rel_names = WorkingTree.open_containing_paths(names_list, canonicalize=False)
         self.add_cleanup(tree.lock_tree_write().unlock)
         self._run(tree, names_list, rel_names, after)
 
@@ -843,7 +799,8 @@
         if after:
             raise errors.BzrCommandError('--after cannot be specified with'
                                          ' --auto.')
-        work_tree, file_list = tree_files(names_list, default_branch='.')
+        work_tree, file_list = WorkingTree.open_containing_paths(
+            names_list, default_directory='.')
         self.add_cleanup(work_tree.lock_tree_write().unlock)
         rename_map.RenameMap.guess_renames(work_tree, dry_run)
 
@@ -1177,8 +1134,10 @@
 
     _see_also = ['checkout']
     takes_args = ['from_location', 'to_location?']
-    takes_options = ['revision', Option('hardlink',
-        help='Hard-link working tree files where possible.'),
+    takes_options = ['revision',
+        Option('hardlink', help='Hard-link working tree files where possible.'),
+        Option('files-from', type=str,
+               help="Get file contents from this tree."),
         Option('no-tree',
             help="Create a branch without a working-tree."),
         Option('switch',
@@ -1202,11 +1161,19 @@
 
     def run(self, from_location, to_location=None, revision=None,
             hardlink=False, stacked=False, standalone=False, no_tree=False,
-            use_existing_dir=False, switch=False, bind=False):
+            use_existing_dir=False, switch=False, bind=False,
+            files_from=None):
         from bzrlib import switch as _mod_switch
         from bzrlib.tag import _merge_tags_if_possible
         accelerator_tree, br_from = bzrdir.BzrDir.open_tree_or_branch(
             from_location)
+        if not (hardlink or files_from):
+            # accelerator_tree is usually slower because you have to read N
+            # files (no readahead, lots of seeks, etc), but allow the user to
+            # explicitly request it
+            accelerator_tree = None
+        if files_from is not None and files_from != from_location:
+            accelerator_tree = WorkingTree.open(files_from)
         revision = _get_one_revision('branch', revision)
         self.add_cleanup(br_from.lock_read().unlock)
         if revision is not None:
@@ -1319,8 +1286,13 @@
             to_location = branch_location
         accelerator_tree, source = bzrdir.BzrDir.open_tree_or_branch(
             branch_location)
+        if not (hardlink or files_from):
+            # accelerator_tree is usually slower because you have to read N
+            # files (no readahead, lots of seeks, etc), but allow the user to
+            # explicitly request it
+            accelerator_tree = None
         revision = _get_one_revision('checkout', revision)
-        if files_from is not None:
+        if files_from is not None and files_from != branch_location:
             accelerator_tree = WorkingTree.open(files_from)
         if revision is not None:
             revision_id = revision.as_revision_id(source)
@@ -1526,7 +1498,7 @@
 
     def run(self, file_list, verbose=False, new=False,
         file_deletion_strategy='safe'):
-        tree, file_list = tree_files(file_list)
+        tree, file_list = WorkingTree.open_containing_paths(file_list)
 
         if file_list is not None:
             file_list = [f for f in file_list]
@@ -1911,7 +1883,7 @@
     takes_args = ['file*']
     takes_options = [
         Option('diff-options', type=str,
-               help='Pass these options to the external diff program.'),
+               help='Pass these options to the diff program.'),
         Option('prefix', type=str,
                short_name='p',
                help='Set prefixes added to old and new filenames, as '
@@ -1958,6 +1930,10 @@
                 '--prefix expects two values separated by a colon'
                 ' (eg "old/:new/")')
 
+        if using is not None and diff_options is not None:
+            raise errors.BzrCommandError(
+            '--diff-options and --using are mutually exclusive.')
+
         if revision and len(revision) > 2:
             raise errors.BzrCommandError('bzr diff --revision takes exactly'
                                          ' one or two revision specifiers')
@@ -2712,6 +2688,14 @@
                 "NAME_PATTERN or --default-rules.")
         name_pattern_list = [globbing.normalize_pattern(p)
                              for p in name_pattern_list]
+        bad_patterns = ''
+        for p in name_pattern_list:
+            if not globbing.Globster.is_pattern_valid(p):
+                bad_patterns += ('\n  %s' % p)
+        if bad_patterns:
+            msg = ('Invalid ignore pattern(s) found. %s' % bad_patterns)
+            ui.ui_factory.show_error(msg)
+            raise errors.InvalidPattern('')
         for name_pattern in name_pattern_list:
             if (name_pattern[0] == '/' or
                 (len(name_pattern) > 1 and name_pattern[1] == ':')):
@@ -3109,7 +3093,7 @@
 
         properties = {}
 
-        tree, selected_list = tree_files(selected_list)
+        tree, selected_list = WorkingTree.open_containing_paths(selected_list)
         if selected_list == ['']:
             # workaround - commit of root of tree should be exactly the same
             # as just default commit in that tree, and succeed even though
@@ -3150,9 +3134,9 @@
         def get_message(commit_obj):
             """Callback to get commit message"""
             if file:
-                f = codecs.open(file, 'rt', osutils.get_user_encoding())
+                f = open(file)
                 try:
-                    my_message = f.read()
+                    my_message = f.read().decode(osutils.get_user_encoding())
                 finally:
                     f.close()
             elif message is not None:
@@ -3189,7 +3173,7 @@
                         reporter=None, verbose=verbose, revprops=properties,
                         authors=author, timestamp=commit_stamp,
                         timezone=offset,
-                        exclude=safe_relpath_files(tree, exclude))
+                        exclude=tree.safe_relpath_files(exclude))
         except PointlessCommit:
             raise errors.BzrCommandError("No changes to commit."
                               " Use --unchanged to commit anyhow.")
@@ -3529,15 +3513,13 @@
                                  'throughout the test suite.',
                             type=get_transport_type),
                      Option('benchmark',
-                            help='Run the benchmarks rather than selftests.'),
+                            help='Run the benchmarks rather than selftests.',
+                            hidden=True),
                      Option('lsprof-timed',
                             help='Generate lsprof output for benchmarked'
                                  ' sections of code.'),
                      Option('lsprof-tests',
                             help='Generate lsprof output for each test.'),
-                     Option('cache-dir', type=str,
-                            help='Cache intermediate benchmark output in this '
-                                 'directory.'),
                      Option('first',
                             help='Run all tests, but run specified tests first.',
                             short_name='f',
@@ -3577,20 +3559,16 @@
 
     def run(self, testspecs_list=None, verbose=False, one=False,
             transport=None, benchmark=None,
-            lsprof_timed=None, cache_dir=None,
+            lsprof_timed=None,
             first=False, list_only=False,
             randomize=None, exclude=None, strict=False,
             load_list=None, debugflag=None, starting_with=None, subunit=False,
             parallel=None, lsprof_tests=False):
         from bzrlib.tests import selftest
-        import bzrlib.benchmarks as benchmarks
-        from bzrlib.benchmarks import tree_creator
 
         # Make deprecation warnings visible, unless -Werror is set
         symbol_versioning.activate_deprecation_warnings(override=False)
 
-        if cache_dir is not None:
-            tree_creator.TreeCreator.CACHE_ROOT = osutils.abspath(cache_dir)
         if testspecs_list is not None:
             pattern = '|'.join(testspecs_list)
         else:
@@ -3615,15 +3593,10 @@
             self.additional_selftest_args.setdefault(
                 'suite_decorators', []).append(parallel)
         if benchmark:
-            test_suite_factory = benchmarks.test_suite
-            # Unless user explicitly asks for quiet, be verbose in benchmarks
-            verbose = not is_quiet()
-            # TODO: should possibly lock the history file...
-            benchfile = open(".perf_history", "at", buffering=1)
-            self.add_cleanup(benchfile.close)
-        else:
-            test_suite_factory = None
-            benchfile = None
+            raise errors.BzrCommandError(
+                "--benchmark is no longer supported from bzr 2.2; "
+                "use bzr-usertest instead")
+        test_suite_factory = None
         selftest_kwargs = {"verbose": verbose,
                           "pattern": pattern,
                           "stop_on_failure": one,
@@ -3631,7 +3604,6 @@
                           "test_suite_factory": test_suite_factory,
                           "lsprof_timed": lsprof_timed,
                           "lsprof_tests": lsprof_tests,
-                          "bench_history": benchfile,
                           "matching_tests_first": first,
                           "list_only": list_only,
                           "random_seed": randomize,
@@ -4091,7 +4063,7 @@
         from bzrlib.conflicts import restore
         if merge_type is None:
             merge_type = _mod_merge.Merge3Merger
-        tree, file_list = tree_files(file_list)
+        tree, file_list = WorkingTree.open_containing_paths(file_list)
         self.add_cleanup(tree.lock_write().unlock)
         parents = tree.get_parent_ids()
         if len(parents) != 2:
@@ -4207,7 +4179,7 @@
 
     def run(self, revision=None, no_backup=False, file_list=None,
             forget_merges=None):
-        tree, file_list = tree_files(file_list)
+        tree, file_list = WorkingTree.open_containing_paths(file_list)
         self.add_cleanup(tree.lock_tree_write().unlock)
         if forget_merges:
             tree.set_parent_ids(tree.get_parent_ids()[:1])
@@ -5709,7 +5681,8 @@
             name=None,
             switch=None,
             ):
-        tree, file_list = tree_files(file_list, apply_view=False)
+        tree, file_list = WorkingTree.open_containing_paths(file_list,
+            apply_view=False)
         current_view, view_dict = tree.views.get_view_info()
         if name is None:
             name = current_view

=== modified file 'bzrlib/bundle/__init__.py'
--- bzrlib/bundle/__init__.py	2010-02-17 17:11:16 +0000
+++ bzrlib/bundle/__init__.py	2010-07-15 12:53:44 +0000
@@ -16,7 +16,6 @@
 
 from cStringIO import StringIO
 
-from bzrlib.symbol_versioning import deprecated_function, deprecated_in
 from bzrlib.lazy_import import lazy_import
 lazy_import(globals(), """
 from bzrlib import (
@@ -33,11 +32,6 @@
 from bzrlib.trace import note
 
 
-@deprecated_function(deprecated_in((1, 12, 0)))
-def read_bundle_from_url(url):
-    return read_mergeable_from_url(url, _do_directive=False)
-
-
 def read_mergeable_from_url(url, _do_directive=True, possible_transports=None):
     """Read mergable object from a given URL.
 

=== modified file 'bzrlib/bundle/bundle_data.py'
--- bzrlib/bundle/bundle_data.py	2010-06-16 12:47:51 +0000
+++ bzrlib/bundle/bundle_data.py	2010-08-05 04:21:03 +0000
@@ -715,12 +715,11 @@
                 ie.symlink_target = self.get_symlink_target(file_id)
             ie.revision = revision_id
 
-            if kind in ('directory', 'symlink'):
-                ie.text_size, ie.text_sha1 = None, None
-            else:
+            if kind == 'file':
                 ie.text_size, ie.text_sha1 = self.get_size_and_sha1(file_id)
-            if (ie.text_size is None) and (kind == 'file'):
-                raise BzrError('Got a text_size of None for file_id %r' % file_id)
+                if ie.text_size is None:
+                    raise BzrError(
+                        'Got a text_size of None for file_id %r' % file_id)
             inv.add(ie)
 
         sorted_entries = self.sorted_path_id()

=== modified file 'bzrlib/bundle/serializer/__init__.py'
--- bzrlib/bundle/serializer/__init__.py	2009-03-23 14:59:43 +0000
+++ bzrlib/bundle/serializer/__init__.py	2010-07-15 12:53:00 +0000
@@ -151,17 +151,6 @@
         """
         raise NotImplementedError
 
-    def write(self, source, revision_ids, forced_bases, f):
-        """Write the bundle to the supplied file.
-
-        DEPRECATED: see write_bundle
-        :param source: A source for revision information
-        :param revision_ids: The list of revision ids to serialize
-        :param forced_bases: A dict of revision -> base that overrides default
-        :param f: The file to output to
-        """
-        raise NotImplementedError
-
     def _write_bundle(self, repository, revision_id, base_revision_id, out):
         """Helper function for translating write_bundle to write"""
         forced_bases = {revision_id:base_revision_id}

=== modified file 'bzrlib/bundle/serializer/v4.py'
--- bzrlib/bundle/serializer/v4.py	2009-08-04 14:08:32 +0000
+++ bzrlib/bundle/serializer/v4.py	2010-08-10 20:03:44 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2007 Canonical Ltd
+# Copyright (C) 2007-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -30,11 +30,49 @@
     serializer,
     trace,
     ui,
+    versionedfile as _mod_versionedfile,
     )
 from bzrlib.bundle import bundle_data, serializer as bundle_serializer
 from bzrlib import bencode
 
 
+class _MPDiffInventoryGenerator(_mod_versionedfile._MPDiffGenerator):
+    """Generate Inventory diffs serialized inventories."""
+
+    def __init__(self, repo, inventory_keys):
+        super(_MPDiffInventoryGenerator, self).__init__(repo.inventories,
+            inventory_keys)
+        self.repo = repo
+        self.sha1s = {}
+
+    def iter_diffs(self):
+        """Compute the diffs one at a time."""
+        # This is instead of compute_diffs() since we guarantee our ordering of
+        # inventories, we don't have to do any buffering
+        self._find_needed_keys()
+        # We actually use a slightly different ordering. We grab all of the
+        # parents first, and then grab the ordered requests.
+        needed_ids = [k[-1] for k in self.present_parents]
+        needed_ids.extend([k[-1] for k in self.ordered_keys])
+        inv_to_str = self.repo._serializer.write_inventory_to_string
+        for inv in self.repo.iter_inventories(needed_ids):
+            revision_id = inv.revision_id
+            key = (revision_id,)
+            if key in self.present_parents:
+                # Not a key we will transmit, which is a shame, since because
+                # of that bundles don't work with stacked branches
+                parent_ids = None
+            else:
+                parent_ids = [k[-1] for k in self.parent_map[key]]
+            as_bytes = inv_to_str(inv)
+            self._process_one_record(key, (as_bytes,))
+            if parent_ids is None:
+                continue
+            diff = self.diffs.pop(key)
+            sha1 = osutils.sha_string(as_bytes)
+            yield revision_id, parent_ids, sha1, diff
+
+
 class BundleWriter(object):
     """Writer for bundle-format files.
 
@@ -348,48 +386,10 @@
         the other side.
         """
         inventory_key_order = [(r,) for r in revision_order]
-        parent_map = self.repository.inventories.get_parent_map(
-                            inventory_key_order)
-        missing_keys = set(inventory_key_order).difference(parent_map)
-        if missing_keys:
-            raise errors.RevisionNotPresent(list(missing_keys)[0],
-                                            self.repository.inventories)
-        inv_to_str = self.repository._serializer.write_inventory_to_string
-        # Make sure that we grab the parent texts first
-        just_parents = set()
-        map(just_parents.update, parent_map.itervalues())
-        just_parents.difference_update(parent_map)
-        # Ignore ghost parents
-        present_parents = self.repository.inventories.get_parent_map(
-                            just_parents)
-        ghost_keys = just_parents.difference(present_parents)
-        needed_inventories = list(present_parents) + inventory_key_order
-        needed_inventories = [k[-1] for k in needed_inventories]
-        all_lines = {}
-        for inv in self.repository.iter_inventories(needed_inventories):
-            revision_id = inv.revision_id
-            key = (revision_id,)
-            as_bytes = inv_to_str(inv)
-            # The sha1 is validated as the xml/textual form, not as the
-            # form-in-the-repository
-            sha1 = osutils.sha_string(as_bytes)
-            as_lines = osutils.split_lines(as_bytes)
-            del as_bytes
-            all_lines[key] = as_lines
-            if key in just_parents:
-                # We don't transmit those entries
-                continue
-            # Create an mpdiff for this text, and add it to the output
-            parent_keys = parent_map[key]
-            # See the comment in VF.make_mpdiffs about how this effects
-            # ordering when there are ghosts present. I think we have a latent
-            # bug
-            parent_lines = [all_lines[p_key] for p_key in parent_keys
-                            if p_key not in ghost_keys]
-            diff = multiparent.MultiParent.from_lines(
-                as_lines, parent_lines)
+        generator = _MPDiffInventoryGenerator(self.repository,
+                                              inventory_key_order)
+        for revision_id, parent_ids, sha1, diff in generator.iter_diffs():
             text = ''.join(diff.to_patch())
-            parent_ids = [k[-1] for k in parent_keys]
             self.bundle.add_multiparent_record(text, sha1, parent_ids,
                                                'inventory', revision_id, None)
 

=== modified file 'bzrlib/bzrdir.py'
--- bzrlib/bzrdir.py	2010-07-10 20:46:48 +0000
+++ bzrlib/bzrdir.py	2010-08-15 04:52:51 +0000
@@ -2941,7 +2941,6 @@
         previous_entries = dict((head, parent_candiate_entries[head]) for head
             in heads)
         self.snapshot_ie(previous_entries, ie, w, rev_id)
-        del ie.text_id
 
     def get_parent_map(self, revision_ids):
         """See graph.StackedParentsProvider.get_parent_map"""

=== modified file 'bzrlib/chk_map.py'
--- bzrlib/chk_map.py	2010-05-11 10:45:26 +0000
+++ bzrlib/chk_map.py	2010-07-21 09:58:42 +0000
@@ -90,8 +90,6 @@
 _INTERESTING_NEW_SIZE = 50
 # If a ChildNode shrinks by more than this amount, we check for a remap
 _INTERESTING_SHRINKAGE_LIMIT = 20
-# If we delete more than this many nodes applying a delta, we check for a remap
-_INTERESTING_DELETES_LIMIT = 5
 
 
 def _search_key_plain(key):
@@ -135,7 +133,7 @@
             into the map; if old_key is not None, then the old mapping
             of old_key is removed.
         """
-        delete_count = 0
+        has_deletes = False
         # Check preconditions first.
         as_st = StaticTuple.from_sequence
         new_items = set([as_st(key) for (old, key, value) in delta
@@ -148,12 +146,11 @@
         for old, new, value in delta:
             if old is not None and old != new:
                 self.unmap(old, check_remap=False)
-                delete_count += 1
+                has_deletes = True
         for old, new, value in delta:
             if new is not None:
                 self.map(new, value)
-        if delete_count > _INTERESTING_DELETES_LIMIT:
-            trace.mutter("checking remap as %d deletions", delete_count)
+        if has_deletes:
             self._check_remap()
         return self._save()
 
@@ -573,7 +570,7 @@
         """Check if nodes can be collapsed."""
         self._ensure_root()
         if type(self._root_node) is InternalNode:
-            self._root_node._check_remap(self._store)
+            self._root_node = self._root_node._check_remap(self._store)
 
     def _save(self):
         """Save the map completely.

=== modified file 'bzrlib/config.py'
--- bzrlib/config.py	2010-06-02 04:50:35 +0000
+++ bzrlib/config.py	2010-07-21 03:14:56 +0000
@@ -74,6 +74,7 @@
 
 import bzrlib
 from bzrlib import (
+    atomicfile,
     debug,
     errors,
     mail_client,
@@ -478,12 +479,12 @@
         return self.get_user_option('nickname')
 
     def _write_config_file(self):
-        f = file(self._get_filename(), "wb")
-        try:
-            osutils.copy_ownership_from_path(f.name)
-            self._get_parser().write(f)
-        finally:
-            f.close()
+        filename = self._get_filename()
+        atomic_file = atomicfile.AtomicFile(filename)
+        self._get_parser().write(atomic_file)
+        atomic_file.commit()
+        atomic_file.close()
+        osutils.copy_ownership_from_path(filename)
 
 
 class GlobalConfig(IniBasedConfig):

=== modified file 'bzrlib/conflicts.py'
--- bzrlib/conflicts.py	2010-05-28 14:15:28 +0000
+++ bzrlib/conflicts.py	2010-07-16 15:35:43 +0000
@@ -24,7 +24,6 @@
 import errno
 
 from bzrlib import (
-    builtins,
     cleanup,
     commands,
     errors,
@@ -127,7 +126,8 @@
             if action is None:
                 action = 'done'
         else:
-            tree, file_list = builtins.tree_files(file_list)
+            tree, file_list = workingtree.WorkingTree.open_containing_paths(
+                file_list)
             if file_list is None:
                 if action is None:
                     # FIXME: There is a special case here related to the option

=== modified file 'bzrlib/diff-delta.c'
--- bzrlib/diff-delta.c	2009-12-14 15:54:42 +0000
+++ bzrlib/diff-delta.c	2010-08-02 16:35:11 +0000
@@ -853,7 +853,8 @@
     free(index);
 }
 
-unsigned long sizeof_delta_index(struct delta_index *index)
+unsigned long
+sizeof_delta_index(struct delta_index *index)
 {
     if (index)
         return index->memsize;
@@ -872,7 +873,8 @@
              const void *trg_buf, unsigned long trg_size,
              unsigned long *delta_size, unsigned long max_size)
 {
-    unsigned int i, outpos, outsize, moff, msize, val;
+    unsigned int i, outpos, outsize, moff, val;
+    int msize;
     const struct source_info *msource;
     int inscnt;
     const unsigned char *ref_data, *ref_top, *data, *top;
@@ -943,7 +945,7 @@
                  entry++) {
                 const unsigned char *ref;
                 const unsigned char *src;
-                unsigned int ref_size;
+                int ref_size;
                 if (entry->val != val)
                     continue;
                 ref = entry->ptr;
@@ -956,14 +958,14 @@
                  * match more bytes with this location that we have already
                  * matched.
                  */
-                if (ref_size > top - src)
+                if (ref_size > (top - src))
                     ref_size = top - src;
                 if (ref_size <= msize)
                     break;
                 /* See how many bytes actually match at this location. */
                 while (ref_size-- && *src++ == *ref)
                     ref++;
-                if (msize < ref - entry->ptr) {
+                if (msize < (ref - entry->ptr)) {
                     /* this is our best match so far */
                     msize = ref - entry->ptr;
                     msource = entry->src;

=== modified file 'bzrlib/diff.py'
--- bzrlib/diff.py	2010-05-26 15:58:08 +0000
+++ bzrlib/diff.py	2010-07-16 15:20:17 +0000
@@ -420,12 +420,9 @@
 
     # Get the specific files (all files is None, no files is [])
     if make_paths_wt_relative and working_tree is not None:
-        try:
-            from bzrlib.builtins import safe_relpath_files
-            other_paths = safe_relpath_files(working_tree, other_paths,
+        other_paths = working_tree.safe_relpath_files(
+            other_paths,
             apply_view=apply_view)
-        except errors.FileInWrongBranch:
-            raise errors.BzrCommandError("Files are in different branches")
     specific_files.extend(other_paths)
     if len(specific_files) == 0:
         specific_files = None

=== added directory 'bzrlib/doc_generate/builders'
=== added file 'bzrlib/doc_generate/builders/__init__.py'
--- bzrlib/doc_generate/builders/__init__.py	1970-01-01 00:00:00 +0000
+++ bzrlib/doc_generate/builders/__init__.py	2010-07-05 16:01:33 +0000
@@ -0,0 +1,18 @@
+# Copyright (C) 2010 Canonical Ltd
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
+
+"""Placeholder to allow sphinx builders imports."""
+

=== added file 'bzrlib/doc_generate/builders/texinfo.py'
--- bzrlib/doc_generate/builders/texinfo.py	1970-01-01 00:00:00 +0000
+++ bzrlib/doc_generate/builders/texinfo.py	2010-05-06 20:05:01 +0000
@@ -0,0 +1,42 @@
+# Copyright (C) 2010 Canonical Ltd
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
+
+"""A sphinx builder producing texinfo output."""
+
+from sphinx import builders
+from sphinx.builders import text as _text_builder
+
+from bzrlib.doc_generate.writers import texinfo as texinfo_writer
+
+class TexinfoBuilder(_text_builder.TextBuilder):
+
+    name = 'texinfo'
+    format = 'texinfo'
+    out_suffix = '.texi'
+
+    def prepare_writing(self, docnames):
+        self.writer = texinfo_writer.TexinfoWriter(self)
+
+    def get_target_uri(self, docname, typ=None):
+        # FIXME: Revisit when info file generation is defined (the suffix is
+        # left here for clarity but the final version may just get rid of
+        # it). And we probalby will join several files into bigger info files
+        # anyway. -- vila 20100506
+        return docname + '.info'
+
+
+def setup(app):
+    app.add_builder(TexinfoBuilder)

=== renamed file 'bzrlib/doc_generate/sphinx_conf.py' => 'bzrlib/doc_generate/conf.py'
--- bzrlib/doc_generate/sphinx_conf.py	2009-09-08 16:37:05 +0000
+++ bzrlib/doc_generate/conf.py	2010-07-07 11:32:03 +0000
@@ -8,6 +8,9 @@
 
 import sys, os
 
+# FIXME: better move the content of doc/en/conf.py here and cleanup the result
+# -- vila 20100428
+
 # If extensions (or modules to document with autodoc) are in another directory,
 # add these directories to sys.path here. If the directory is relative to the
 # documentation root, use os.path.abspath to make it absolute, like shown here.
@@ -18,7 +21,8 @@
 
 # Add any Sphinx extension module names here, as strings. They can be extensions
 # coming with Sphinx (named 'sphinx.ext.*') or your custom ones.
-extensions = ['sphinx.ext.ifconfig']
+extensions = ['sphinx.ext.ifconfig',
+              'bzrlib.doc_generate.builders.texinfo']
 
 # Add any paths that contain templates here, relative to this directory.
 templates_path = ['_templates']
@@ -34,7 +38,7 @@
 
 # General information about the project.
 project = u'Bazaar'
-copyright = u'2009, Canonical Ltd'
+copyright = u'2009, 2010 Canonical Ltd'
 
 # The version info for the project you're documenting, acts as replacement for
 # |version| and |release|, also used in various other places throughout the

=== added directory 'bzrlib/doc_generate/writers'
=== added file 'bzrlib/doc_generate/writers/__init__.py'
--- bzrlib/doc_generate/writers/__init__.py	1970-01-01 00:00:00 +0000
+++ bzrlib/doc_generate/writers/__init__.py	2010-07-05 16:01:33 +0000
@@ -0,0 +1,18 @@
+# Copyright (C) 2010 Canonical Ltd
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
+
+"""Placeholder to allow sphinx writer imports."""
+

=== added file 'bzrlib/doc_generate/writers/texinfo.py'
--- bzrlib/doc_generate/writers/texinfo.py	1970-01-01 00:00:00 +0000
+++ bzrlib/doc_generate/writers/texinfo.py	2010-07-21 08:07:14 +0000
@@ -0,0 +1,520 @@
+# Copyright (C) 2010 Canonical Ltd
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
+
+"""A sphinx/docutil writer producing texinfo output."""
+
+from docutils import (
+    nodes,
+    writers,
+    )
+
+DEBUG = 0
+
+class TexinfoWriter(writers.Writer):
+
+    supported = ('texinfo',)
+    settings_spec = ('No options here.', '', ())
+    settings_defaults = {}
+
+    output = None
+
+    def __init__(self, builder):
+        writers.Writer.__init__(self)
+        self.builder = builder
+
+    def translate(self):
+        visitor = TexinfoTranslator(self.document, self.builder)
+        self.document.walkabout(visitor)
+        self.output = visitor.body
+
+
+class TexinfoTranslator(nodes.NodeVisitor):
+
+    section_names = ['chapter', 'section', 'subsection', 'subsubsection']
+    """texinfo section names differ from the sphinx ones.
+
+    Since this can be confusing, the correspondences are shown below
+    (shpinx -> texinfo):
+    part       -> chapter
+    chapter    -> section
+    section    -> subsection
+    subsection -> subsubsection
+
+    Additionally, sphinx defines subsubsections and paragraphs which are
+    handled as @heading (unnumbered).
+    """
+
+    def __init__(self, document, builder):
+        nodes.NodeVisitor.__init__(self, document)
+        self.builder = builder
+        # toctree uses some nodes for different purposes (namely:
+        # compact_paragraph, bullet_list) that needs to know when they are
+        # processing a toctree.
+        self.in_toctree = False
+        # sections can be embedded and produce different directives depending
+        # on the depth.
+        self.section_level = -1
+        # By default paragraghs are separated by newlines, but there are some
+        # exceptions that set it to '' for some subtrees instead
+        self.paragraph_sep = '\n'
+
+    # The whole document
+
+    def visit_document(self, node):
+        if DEBUG:
+            import sys
+            sys.stdout.write(node.pformat().encode('utf8'))
+        set_item_list_collector(node, 'text')
+
+    def depart_document(self, node):
+        # FIXME: info requires a Top node for each info file, but unless we
+        # chose a global layout to divide the overall documentation into a set
+        # of info files, there is no criteria to decide for a title.
+        top_cmd = '''\
+This file has been converted using a beta rst->texinfo converter. 
+Most of the info links are currently bogus, don't report bugs about them,
+this is currently worked on.
+@node Top
+@top Placeholder
+'''
+        self.body = top_cmd + ''.join(node['text'])
+
+    # Layout
+
+    def visit_section(self, node):
+        self.section_level += 1
+        set_item_list_collector(node, 'text')
+
+    def depart_section(self, node):
+        title = node['title']
+        ids = node.get('ids', [])
+        try:
+            section_name = self.section_names[self.section_level]
+        except IndexError:
+            # Just use @heading, it's not numbered anyway
+            section_name = 'heading'
+        if ids:
+            # There shouldn't be different ids for a section, so until we
+            # encounter bugs, just take the first one.
+            node_cmd = '@node %s\n' % (ids[0],)
+        else:
+            node_cmd = ''
+        section_cmd = '@%s %s\n' % (section_name, title)
+        text = ''.join(node['text'])
+        node.parent.collect_text(node_cmd + section_cmd + text)
+        self.section_level -= 1
+
+    def visit_topic(self, node):
+        pass
+
+    def depart_topic(self, node):
+        pass
+
+    def visit_paragraph(self, node):
+        set_item_list_collector(node, 'text')
+
+    def depart_paragraph(self, node):
+        # End the paragraph with a new line (or '' depending on the parent) and
+        # leave a blank line after it.
+        text = ''.join(node['text']) + self.paragraph_sep * 2
+        node.parent.collect_text(text)
+
+    def visit_compact_paragraph(self, node):
+        set_item_list_collector(node, 'text')
+        if node.has_key('toctree'):
+            self.in_toctree = True
+        elif self.in_toctree:
+            set_item_collector(node, 'reference')
+
+    def depart_compact_paragraph(self, node):
+        # FIXME: Using a different visitor specific to toctree may be a better
+        # design and makes code clearer. -- vila 20100708
+        if node.has_key('toctree'):
+            node.parent.collect_text('@menu\n')
+            node.parent.collect_text(''.join(node['text']))
+            node.parent.collect_text('@end menu\n')
+            self.in_toctree = False
+        elif self.in_toctree:
+            # * FIRST-ENTRY-NAME:(FILENAME)NODENAME.     DESCRIPTION
+            # XXX: the file name should probably be adjusted to the targeted
+            # info file name
+            node_name, file_name, entry_name = node['reference']
+            if not node_name:
+                node_name = entry_name
+            description = '' # We can't specify a description in rest AFAICS
+            # XXX: What if :maxdepth: is not 1 ?
+            text = '* %s: (%s)%s. %s\n' % (entry_name, file_name,
+                                           node_name, description)
+            node.parent.collect_text(text)
+        else:
+            # End the paragraph with a new line (or '' depending on the parent)
+            # and leave a blank line after it.
+            text = ''.join(node['text']) + self.paragraph_sep * 2
+            node.parent.collect_text(text)
+
+    def visit_literal_block(self, node):
+        set_item_collector(node, 'text')
+
+    def depart_literal_block(self, node):
+        text = '@samp{%s}' % ''.join(node['text']) + self.paragraph_sep * 2
+        node.parent.collect_text(text)
+
+    def visit_block_quote(self, node):
+        set_item_list_collector(node, 'text')
+
+    def depart_block_quote(self, node):
+        node.parent.collect_text('@example\n')
+        node.parent.collect_text(''.join(node['text']))
+        node.parent.collect_text('@end example\n\n')
+
+    def depart_warning(self, node):
+        pass
+
+    def visit_warning(self, node):
+        raise nodes.SkipNode # Not implemented yet
+
+    def visit_note(self, node):
+        raise nodes.SkipNode # Not implemented yet
+
+    def depart_note(self, node):
+        pass
+
+    def visit_footnote(self, node):
+        raise nodes.SkipNode # Not implemented yet
+
+    def depart_footnote(self, node):
+        pass
+
+    def visit_comment(self, node):
+        raise nodes.SkipNode # Not implemented yet
+
+    # Attributes
+
+    def visit_title(self, node):
+        set_item_collector(node, 'text')
+
+    def depart_title(self, node):
+        node.parent['title'] = node['text']
+
+    def visit_label(self, node):
+        raise nodes.SkipNode # Not implemented yet
+
+    def visit_substitution_definition(self, node):
+        raise nodes.SkipNode # Not implemented yet
+
+    # Plain text
+
+    def visit_Text(self, node):
+        pass
+
+    def depart_Text(self, node):
+        text = node.astext()
+        if '@' in text:
+            text = text.replace('@', '@@')
+        if '{' in text:
+            text = text.replace('{', '@{')
+        if '}' in text:
+            text = text.replace('}', '@}')
+        node.parent.collect_text(text)
+
+
+    # Styled text
+
+    def visit_emphasis(self, node):
+        set_item_collector(node, 'text')
+
+    def depart_emphasis(self, node):
+        text = '@emph{%s}' % node['text']
+        node.parent.collect_text(text)
+
+    def visit_strong(self, node):
+        set_item_collector(node, 'text')
+
+    def depart_strong(self, node):
+        text = '@strong{%s}' % node['text']
+        node.parent.collect_text(text)
+
+    def visit_literal(self, node):
+        set_item_collector(node, 'text')
+
+    def depart_literal(self, node):
+        text = '@code{%s}' % node['text']
+        node.parent.collect_text(text)
+
+    # Lists
+
+    def _decorate_list(self, item_list, collect, item_fmt='%s',
+                       head=None, foot=None):
+        if head is not None:
+            collect(head)
+        for item in item_list:
+            collect(item_fmt % item)
+        if foot is not None:
+            collect(foot)
+
+    def visit_bullet_list(self, node):
+        set_item_list_collector(node, 'list_item')
+
+    def depart_bullet_list(self, node):
+        l = node['list_item']
+        if self.in_toctree:
+            self._decorate_list(node['list_item'], node.parent.collect_text)
+        else:
+            self._decorate_list(node['list_item'], node.parent.collect_text,
+                                '@item\n%s',
+                                # FIXME: Should respect the 'bullet' attribute
+                                '@itemize @bullet\n', '@end itemize\n')
+
+    def visit_enumerated_list(self, node):
+        set_item_list_collector(node, 'list_item')
+
+    def depart_enumerated_list(self, node):
+        self._decorate_list(node['list_item'], node.parent.collect_text,
+                            '@item\n%s',
+                            '@enumerate\n', '@end enumerate\n')
+
+    def visit_definition_list(self, node):
+        raise nodes.SkipNode # Not implemented yet
+
+    def depart_definition_list(self, node):
+        raise nodes.SkipNode # Not implemented yet
+
+    def visit_definition_list_item(self, node):
+        raise nodes.SkipNode # Not implemented yet
+
+    def depart_definition_list_item(self, node):
+        pass
+
+    def visit_term(self, node):
+        raise nodes.SkipNode # Not implemented yet
+
+    def depart_term(self, node):
+        pass
+
+    def visit_definition(self, node):
+        raise nodes.SkipNode # Not implemented yet
+
+    def depart_definition(self, node):
+        pass
+
+    def visit_field_list(self, node):
+        raise nodes.SkipNode # Not implemented yet
+
+    def depart_field_list(self, node):
+        pass
+
+    def visit_field(self, node):
+        raise nodes.SkipNode # Not implemented yet
+
+    def depart_field(self, node):
+        pass
+
+    def visit_field_name(self, node):
+        raise nodes.SkipNode # Not implemented yet
+
+    def depart_field_name(self, node):
+        pass
+
+    def visit_field_body(self, node):
+        raise nodes.SkipNode # Not implemented yet
+
+    def depart_field_body(self, node):
+        pass
+
+    def visit_list_item(self, node):
+        set_item_list_collector(node, 'text')
+
+    def depart_list_item(self, node):
+        text = ''.join(node['text'])
+        node.parent.collect_list_item(text)
+
+    def visit_option_list(self, node):
+        raise nodes.SkipNode # Not implemented yet
+
+    def depart_option_list(self, node):
+        pass
+
+    def visit_option_list_item(self, node):
+        pass
+
+    def depart_option_list_item(self, node):
+        pass
+
+    def visit_option_group(self, node):
+        pass
+
+    def depart_option_group(self, node):
+        pass
+
+    def visit_option(self, node):
+        pass
+
+    def depart_option(self, node):
+        pass
+
+    def visit_option_string(self, node):
+        pass
+    def depart_option_string(self, node):
+        pass
+
+    def visit_option_argument(self, node):
+        pass
+
+    def depart_option_argument(self, node):
+        pass
+
+    def visit_description(self, node):
+        pass
+    def depart_description(self, node):
+        pass
+
+    # Tables
+    def visit_table(self, node):
+        set_item_collector(node, 'table')
+
+    def depart_table(self, node):
+        node.parent.collect_text(node['table'])
+
+    def visit_tgroup(self, node):
+        set_item_list_collector(node, 'colspec')
+        set_item_collector(node, 'head_entries')
+        set_item_collector(node, 'body_rows')
+
+    def depart_tgroup(self, node):
+        header = []
+        # The '@multitable {xxx}{xxx}' line
+        self._decorate_list(node['colspec'], header.append,
+                            '{%s}', '@multitable ', '\n')
+        # The '@headitem xxx @tab yyy...' line
+        head_entries = node['head_entries']
+        if head_entries is not None:
+            # Not all tables define titles for the columns... rest parser bug ?
+            # FIXME: need a test
+            self._decorate_list(head_entries[1:], header.append,
+                                ' @tab %s',
+                                '@headitem %s' % head_entries[0], '\n')
+        header = ''.join(header)
+        # The '@item xxx\n @tab yyy\n ...' lines
+        body_rows = node['body_rows']
+        rows = []
+        for r in body_rows:
+            self._decorate_list(r[1:], rows.append,
+                                '@tab %s\n', '@item %s\n' % r[0])
+        footer = '@end multitable\n'
+        node.parent.collect_table(header + ''.join(rows) + footer)
+
+    def visit_colspec(self, node):
+        pass
+
+    def depart_colspec(self, node):
+        node.parent.collect_colspec('x' * node['colwidth'])
+
+    def visit_thead(self, node):
+        set_item_collector(node, 'row')
+
+    def depart_thead(self, node):
+        node.parent.collect_head_entries(node['row'])
+
+    def visit_tbody(self, node):
+        set_item_list_collector(node, 'row')
+
+    def depart_tbody(self, node):
+        node.parent.collect_body_rows(node['row'])
+
+    def visit_row(self, node):
+        set_item_list_collector(node, 'entry')
+
+    def depart_row(self, node):
+        node.parent.collect_row(node['entry'])
+
+    def visit_entry(self, node):
+        set_item_list_collector(node, 'text')
+        node['par_sep_orig'] = self.paragraph_sep
+        self.paragraph_sep = ''
+
+    def depart_entry(self, node):
+        node.parent.collect_entry(''.join(node['text']))
+        self.paragraph_sep = node['par_sep_orig']
+
+    # References
+
+    def visit_reference(self, node):
+        for c in node.children:
+            if getattr(c, 'parent', None) is None:
+                # Bug sphinx
+                node.setup_child(c)
+        set_item_collector(node, 'text')
+
+    def depart_reference(self, node):
+        anchorname = node.get('anchorname', None)
+        refuri = node.get('refuri', None)
+        refid = node.get('refid', None)
+        text = ''.join(node['text'])
+        collect = getattr(node.parent, 'collect_reference', None)
+        if collect is not None:
+            if not self.in_toctree:
+                raise AssertionError('collect_reference is specific to toctree')
+            if anchorname is None:
+                anchorname = ''
+            if refuri is None:
+                refuri = ''
+            collect((anchorname, refuri, text))
+        elif refuri is not None:
+            node.parent.collect_text('@uref{%s,%s}' % (refuri, text))
+        elif refid is not None:
+            # Info format requires that a reference is followed by some
+            # punctuation char ('.', ','. ')', etc). Rest is more liberal. To
+            # accommodate, we use pxref inside parenthesis.
+            node.parent.collect_text('%s (@pxref{%s})' % (text, refid))
+
+    def visit_footnote_reference(self, node):
+        raise nodes.SkipNode # Not implemented yet
+
+    def visit_citation_reference(self, node):
+        raise nodes.SkipNode # Not implemented yet
+
+    def visit_title_reference(self, node):
+        raise nodes.SkipNode # Not implemented yet
+
+    def depart_title_reference(self, node):
+        pass
+
+    def visit_target(self, node):
+        raise nodes.SkipNode # Not implemented yet
+
+    def depart_target(self, node):
+        pass
+
+    def visit_image(self, node):
+        raise nodes.SkipNode # Not implemented yet
+
+# Helpers to collect data in parent node
+
+def set_item_collector(node, name):
+    node[name] = None
+    def set_item(item):
+        node[name] = item
+    setattr(node, 'collect_' + name, set_item)
+
+
+def set_item_list_collector(node, name, sep=''):
+    node[name] = []
+    node[name + '_sep'] = sep
+    def append_item(item):
+        node[name].append(item)
+    setattr(node, 'collect_' + name, append_item)
+
+

=== modified file 'bzrlib/errors.py'
--- bzrlib/errors.py	2010-07-09 22:45:25 +0000
+++ bzrlib/errors.py	2010-08-15 04:52:51 +0000
@@ -680,7 +680,7 @@
 
     _fmt = 'Path "%(path)s" is not a child of path "%(base)s"%(extra)s'
 
-    internal_error = True
+    internal_error = False
 
     def __init__(self, path, base, extra=None):
         BzrError.__init__(self)
@@ -782,6 +782,8 @@
 
     _fmt = 'File "%(path)s" is not in branch %(branch_base)s.'
 
+    # use PathNotChild instead
+    @symbol_versioning.deprecated_method(symbol_versioning.deprecated_in((2, 3, 0)))
     def __init__(self, branch, path):
         BzrError.__init__(self)
         self.branch = branch
@@ -947,11 +949,8 @@
     # original exception is available as e.original_error
     #
     # New code should prefer to raise specific subclasses
-    def __init__(self, message):
-        # Python 2.5 uses a slot for StandardError.message,
-        # so use a different variable name.  We now work around this in
-        # BzrError.__str__, but this member name is kept for compatability.
-        self.msg = message
+    def __init__(self, msg):
+        self.msg = msg
 
 
 class LockActive(LockError):
@@ -1178,10 +1177,11 @@
 class InvalidRevisionSpec(BzrError):
 
     _fmt = ("Requested revision: '%(spec)s' does not exist in branch:"
-            " %(branch)s%(extra)s")
+            " %(branch_url)s%(extra)s")
 
     def __init__(self, spec, branch, extra=None):
         BzrError.__init__(self, branch=branch, spec=spec)
+        self.branch_url = getattr(branch, 'user_url', str(branch))
         if extra:
             self.extra = '\n' + str(extra)
         else:
@@ -1378,12 +1378,12 @@
 
 class WeaveParentMismatch(WeaveError):
 
-    _fmt = "Parents are mismatched between two revisions. %(message)s"
+    _fmt = "Parents are mismatched between two revisions. %(msg)s"
 
 
 class WeaveInvalidChecksum(WeaveError):
 
-    _fmt = "Text did not match it's checksum: %(message)s"
+    _fmt = "Text did not match it's checksum: %(msg)s"
 
 
 class WeaveTextDiffers(WeaveError):
@@ -1437,7 +1437,7 @@
 
 class VersionedFileInvalidChecksum(VersionedFileError):
 
-    _fmt = "Text did not match its checksum: %(message)s"
+    _fmt = "Text did not match its checksum: %(msg)s"
 
 
 class KnitError(InternalBzrError):
@@ -2845,8 +2845,11 @@
         else:
             more = ' ' + more
         import bzrlib.urlutils as urlutils
-        display_url = urlutils.unescape_for_display(
-            tree.user_url, 'ascii')
+        user_url = getattr(tree, "user_url", None)
+        if user_url is None:
+            display_url = str(tree)
+        else:
+            display_url = urlutils.unescape_for_display(user_url, 'ascii')
         BzrError.__init__(self, tree=tree, display_url=display_url, more=more)
 
 
@@ -3151,12 +3154,14 @@
     def __init__(self, bzrdir):
         self.bzrdir = bzrdir
 
+
 class NoWhoami(BzrError):
 
     _fmt = ('Unable to determine your name.\n'
         "Please, set your name with the 'whoami' command.\n"
         'E.g. bzr whoami "Your Name <name@example.com>"')
 
+
 class InvalidPattern(BzrError):
 
     _fmt = ('Invalid pattern(s) found. %(msg)s')
@@ -3164,3 +3169,12 @@
     def __init__(self, msg):
         self.msg = msg
 
+
+class RecursiveBind(BzrError):
+
+    _fmt = ('Branch "%(branch_url)s" appears to be bound to itself. '
+        'Please use `bzr unbind` to fix.')
+
+    def __init__(self, branch_url):
+        self.branch_url = branch_url
+

=== modified file 'bzrlib/globbing.py'
--- bzrlib/globbing.py	2010-07-09 16:16:11 +0000
+++ bzrlib/globbing.py	2010-07-21 10:17:11 +0000
@@ -179,24 +179,41 @@
     so are matched first, then the basename patterns, then the fullpath
     patterns.
     """
+    # We want to _add_patterns in a specific order (as per type_list below)
+    # starting with the shortest and going to the longest.
+    # As some Python version don't support ordered dicts the list below is
+    # used to select inputs for _add_pattern in a specific order.
+    pattern_types = [ "extension", "basename", "fullpath" ]
+
+    pattern_info = {
+        "extension" : {
+            "translator" : _sub_extension,
+            "prefix" : r'(?:.*/)?(?!.*/)(?:.*\.)'
+        },
+        "basename" : {
+            "translator" : _sub_basename,
+            "prefix" : r'(?:.*/)?(?!.*/)'
+        },
+        "fullpath" : {
+            "translator" : _sub_fullpath,
+            "prefix" : r''
+        },
+    }
+
     def __init__(self, patterns):
         self._regex_patterns = []
-        path_patterns = []
-        base_patterns = []
-        ext_patterns = []
+        pattern_lists = {
+            "extension" : [],
+            "basename" : [],
+            "fullpath" : [],
+        }
         for pat in patterns:
             pat = normalize_pattern(pat)
-            if pat.startswith(u'RE:') or u'/' in pat:
-                path_patterns.append(pat)
-            elif pat.startswith(u'*.'):
-                ext_patterns.append(pat)
-            else:
-                base_patterns.append(pat)
-        self._add_patterns(ext_patterns,_sub_extension,
-            prefix=r'(?:.*/)?(?!.*/)(?:.*\.)')
-        self._add_patterns(base_patterns,_sub_basename,
-            prefix=r'(?:.*/)?(?!.*/)')
-        self._add_patterns(path_patterns,_sub_fullpath)
+            pattern_lists[Globster.identify(pat)].append(pat)
+        pi = Globster.pattern_info
+        for t in Globster.pattern_types:
+            self._add_patterns(pattern_lists[t], pi[t]["translator"],
+                pi[t]["prefix"])
 
     def _add_patterns(self, patterns, translator, prefix=''):
         while patterns:
@@ -221,10 +238,50 @@
             # the combined pattern we sent to regex. Instead we indicate to
             # the user that an ignore file needs fixing.
             mutter('Invalid pattern found in regex: %s.', e.msg)
-            e.msg = "File ~/.bazaar/ignore or .bzrignore contains errors."
+            e.msg = "File ~/.bazaar/ignore or .bzrignore contains error(s)."
+            bad_patterns = ''
+            for _, patterns in self._regex_patterns:
+                for p in patterns:
+                    if not Globster.is_pattern_valid(p):
+                        bad_patterns += ('\n  %s' % p)
+            e.msg += bad_patterns
             raise e
         return None
 
+    @staticmethod
+    def identify(pattern):
+        """Returns pattern category.
+
+        :param pattern: normalized pattern.
+        Identify if a pattern is fullpath, basename or extension
+        and returns the appropriate type.
+        """
+        if pattern.startswith(u'RE:') or u'/' in pattern:
+            return "fullpath"
+        elif pattern.startswith(u'*.'):
+            return "extension"
+        else:
+            return "basename"
+
+    @staticmethod
+    def is_pattern_valid(pattern):
+        """Returns True if pattern is valid.
+
+        :param pattern: Normalized pattern.
+        is_pattern_valid() assumes pattern to be normalized.
+        see: globbing.normalize_pattern
+        """
+        result = True
+        translator = Globster.pattern_info[Globster.identify(pattern)]["translator"]
+        tpattern = '(%s)' % translator(pattern)
+        try:
+            re_obj = re.compile(tpattern, re.UNICODE)
+            re_obj.search("") # force compile
+        except errors.InvalidPattern, e:
+            result = False
+        return result
+
+
 class ExceptionGlobster(object):
     """A Globster that supports exception patterns.
     
@@ -272,14 +329,9 @@
         self._regex_patterns = []
         for pat in patterns:
             pat = normalize_pattern(pat)
-            if pat.startswith(u'RE:') or u'/' in pat:
-                self._add_patterns([pat], _sub_fullpath)
-            elif pat.startswith(u'*.'):
-                self._add_patterns([pat], _sub_extension,
-                    prefix=r'(?:.*/)?(?!.*/)(?:.*\.)')
-            else:
-                self._add_patterns([pat], _sub_basename,
-                    prefix=r'(?:.*/)?(?!.*/)')
+            t = Globster.identify(pat)
+            self._add_patterns([pat], Globster.pattern_info[t]["translator"],
+                Globster.pattern_info[t]["prefix"])
 
 
 _slashes = re.compile(r'[\\/]+')

=== modified file 'bzrlib/groupcompress.py'
--- bzrlib/groupcompress.py	2010-05-20 02:57:52 +0000
+++ bzrlib/groupcompress.py	2010-08-06 18:14:22 +0000
@@ -1809,6 +1809,54 @@
         return result
 
 
+class _GCBuildDetails(object):
+    """A blob of data about the build details.
+
+    This stores the minimal data, which then allows compatibility with the old
+    api, without taking as much memory.
+    """
+
+    __slots__ = ('_index', '_group_start', '_group_end', '_basis_end',
+                 '_delta_end', '_parents')
+
+    method = 'group'
+    compression_parent = None
+
+    def __init__(self, parents, position_info):
+        self._parents = parents
+        (self._index, self._group_start, self._group_end, self._basis_end,
+         self._delta_end) = position_info
+
+    def __repr__(self):
+        return '%s(%s, %s)' % (self.__class__.__name__,
+            self.index_memo, self._parents)
+
+    @property
+    def index_memo(self):
+        return (self._index, self._group_start, self._group_end,
+                self._basis_end, self._delta_end)
+
+    @property
+    def record_details(self):
+        return static_tuple.StaticTuple(self.method, None)
+
+    def __getitem__(self, offset):
+        """Compatibility thunk to act like a tuple."""
+        if offset == 0:
+            return self.index_memo
+        elif offset == 1:
+            return self.compression_parent # Always None
+        elif offset == 2:
+            return self._parents
+        elif offset == 3:
+            return self.record_details
+        else:
+            raise IndexError('offset out of range')
+            
+    def __len__(self):
+        return 4
+
+
 class _GCGraphIndex(object):
     """Mapper from GroupCompressVersionedFiles needs into GraphIndex storage."""
 
@@ -2009,9 +2057,8 @@
                 parents = None
             else:
                 parents = entry[3][0]
-            method = 'group'
-            result[key] = (self._node_to_position(entry),
-                                  None, parents, (method, None))
+            details = _GCBuildDetails(parents, self._node_to_position(entry))
+            result[key] = details
         return result
 
     def keys(self):
@@ -2033,7 +2080,7 @@
         # each, or about 7MB. Note that it might be even more when you consider
         # how PyInt is allocated in separate slabs. And you can't return a slab
         # to the OS if even 1 int on it is in use. Note though that Python uses
-        # a LIFO when re-using PyInt slots, which probably causes more
+        # a LIFO when re-using PyInt slots, which might cause more
         # fragmentation.
         start = int(bits[0])
         start = self._int_cache.setdefault(start, start)

=== modified file 'bzrlib/help_topics/en/conflict-types.txt'
--- bzrlib/help_topics/en/conflict-types.txt	2010-02-04 13:29:34 +0000
+++ bzrlib/help_topics/en/conflict-types.txt	2010-04-28 13:15:14 +0000
@@ -28,11 +28,11 @@
 
 Whatever the conflict is, resolving it is roughly done in two steps::
 
-- modify the working tree content so that the conflicted item is now in the
-  state you want to keep,
+ - modify the working tree content so that the conflicted item is now in the
+   state you want to keep,
 
-- inform Bazaar that the conflict is now solved and ask to cleanup any
-  remaining generated information (``bzr resolve <item>``).
+ - inform Bazaar that the conflict is now solved and ask to cleanup any
+   remaining generated information (``bzr resolve <item>``).
 
 For most conflict types, there are some obvious ways to modify the working
 tree and put it into the desired state. For some types of conflicts, Bazaar
@@ -126,9 +126,9 @@
 
 ``bzr resolve`` recognizes the following actions:
 
-- ``--action=take-this`` will issue ``bzr mv FILE.THIS FILE``,
-- ``--action=take-other`` will issue ``bzr mv FILE.OTHER FILE``,
-- ``--action=done`` will just mark the conflict as resolved.
+ - ``--action=take-this`` will issue ``bzr mv FILE.THIS FILE``,
+ - ``--action=take-other`` will issue ``bzr mv FILE.OTHER FILE``,
+ - ``--action=done`` will just mark the conflict as resolved.
 
 Any action will also delete the previously generated ``.BASE``, ``.THIS`` and
 ``.OTHER`` files if they are still present in the working tree.
@@ -174,9 +174,9 @@
 
 ``bzr resolve`` recognizes the following actions::
 
-- ``--action=take-this`` will issue ``bzr rm FILE ; bzr mv FILE.moved FILE``,
-- ``--action=take-other`` will issue ``bzr rm FILE.moved``,
-- ``--action=done`` will just mark the conflict as resolved.
+ - ``--action=take-this`` will issue ``bzr rm FILE ; bzr mv FILE.moved FILE``,
+ - ``--action=take-other`` will issue ``bzr rm FILE.moved``,
+ - ``--action=done`` will just mark the conflict as resolved.
 
 Note that you must get rid of FILE.moved before using ``--action=done``.
 
@@ -215,10 +215,11 @@
 
 ``bzr resolve`` recognizes the following actions::
 
-- ``--action=take-this`` will issue ``bzr rm directory`` including the children,
-- ``--action=take-other`` will acknowledge Bazaar choice to keep the children
-  and restoring the directory,
-- ``--action=done`` will just mark the conflict as resolved.
+ - ``--action=take-this`` will issue ``bzr rm directory`` including the
+   children,
+ - ``--action=take-other`` will acknowledge Bazaar choice to keep the children
+   and restoring the directory,
+ - ``--action=done`` will just mark the conflict as resolved.
 
 Bazaar cannot auto-detect when conflicts of this kind have been resolved.
 
@@ -238,10 +239,10 @@
 
 ``bzr resolve`` recognizes the following actions::
 
-- ``--action=take-this`` will acknowledge Bazaar choice to keep the directory,
-- ``--action=take-other`` will issue ``bzr rm directory`` including the 
-  children,
-- ``--action=done`` will just mark the conflict as resolved.
+ - ``--action=take-this`` will acknowledge Bazaar choice to keep the directory,
+ - ``--action=take-other`` will issue ``bzr rm directory`` including the 
+   children,
+ - ``--action=done`` will just mark the conflict as resolved.
 
 Bazaar cannot auto-detect when conflicts of this kind have been resolved.
 
@@ -260,10 +261,10 @@
 
 ``bzr resolve`` recognizes the following actions::
 
-- ``--action=take-this`` will revert Bazaar choice and keep ``PATH1`` by
-  issuing ``bzr mv PATH2 PATH1``,
-- ``--action=take-other`` will acknowledge Bazaar choice of keeping ``PATH2``,
-- ``--action=done`` will just mark the conflict as resolved.
+ - ``--action=take-this`` will revert Bazaar choice and keep ``PATH1`` by
+   issuing ``bzr mv PATH2 PATH1``,
+ - ``--action=take-other`` will acknowledge Bazaar choice of keeping ``PATH2``,
+ - ``--action=done`` will just mark the conflict as resolved.
 
 Bazaar cannot auto-detect when conflicts of this kind have been resolved.
 
@@ -295,11 +296,11 @@
 
 ``bzr resolve`` recognizes the following actions::
 
-- ``--action=take-this`` will acknowledge Bazaar choice of leaving ``white`` 
-  in ``black``,
-- ``--action=take-other`` will revert Bazaar choice and move ``black`` in
-  ``white`` by issuing ``bzr mv black/white white ; bzr mv black white``,
-- ``--action=done`` will just mark the conflict as resolved.
+ - ``--action=take-this`` will acknowledge Bazaar choice of leaving ``white`` 
+   in ``black``,
+ - ``--action=take-other`` will revert Bazaar choice and move ``black`` in
+   ``white`` by issuing ``bzr mv black/white white ; bzr mv black white``,
+ - ``--action=done`` will just mark the conflict as resolved.
 
 Bazaar cannot auto-detect when conflicts of this kind have been resolved.
 
@@ -330,11 +331,11 @@
 
 ``bzr resolve`` recognizes the following actions::
 
-- ``--action=take-this`` will issue ``bzr rm --force foo.new`` and 
-  ``bzr add foo``,
-- ``--action=take-other`` will issue ``bzr rm --force foo`` and 
-  ``bzr mv foo.new foo``,
-- ``--action=done`` will just mark the conflict as resolved.
+ - ``--action=take-this`` will issue ``bzr rm --force foo.new`` and 
+   ``bzr add foo``,
+ - ``--action=take-other`` will issue ``bzr rm --force foo`` and 
+   ``bzr mv foo.new foo``,
+ - ``--action=done`` will just mark the conflict as resolved.
 
 Bazaar cannot auto-detect when conflicts of this kind have been resolved.
 

=== modified file 'bzrlib/help_topics/en/patterns.txt'
--- bzrlib/help_topics/en/patterns.txt	2010-01-02 07:36:36 +0000
+++ bzrlib/help_topics/en/patterns.txt	2010-07-16 12:51:21 +0000
@@ -10,7 +10,7 @@
 slash or is a regular expression, it is compared to the whole path
 from the branch root. Otherwise, it is compared to only the last
 component of the path. To match a file only in the root directory,
-prepend './'. Patterns specifying absolute paths are not allowed.
+prepend ``./``. Patterns specifying absolute paths are not allowed.
 
 Patterns may include globbing wildcards such as::
 
@@ -19,10 +19,20 @@
   /**/ - Matches 0 or more directories in a path
   [a-z] - Matches a single character from within a group of characters
 
-Patterns may also be Python regular expressions. Regular expression
-patterns are identified by a 'RE:' prefix followed by the regular
+Patterns may also be `Python regular expressions`_. Regular expression
+patterns are identified by a ``RE:`` prefix followed by the regular
 expression.  Regular expression patterns may not include named or
 numbered groups.
 
-Ignore patterns may be prefixed with '!', which means that a filename
+Case insensitive ignore patterns can be specified with regular expressions
+by using the ``i`` (for ignore case) flag in the pattern.
+
+For example, a case insensitive match for ``foo`` may be specified as::
+
+  RE:(?i)foo
+
+Ignore patterns may be prefixed with ``!``, which means that a filename
 matched by that pattern will not be ignored.
+
+.. _Python regular expressions: http://docs.python.org/library/re.html
+

=== modified file 'bzrlib/inventory.py'
--- bzrlib/inventory.py	2010-05-11 07:52:16 +0000
+++ bzrlib/inventory.py	2010-08-09 10:13:33 +0000
@@ -35,13 +35,11 @@
 import re
 import tarfile
 
-import bzrlib
 from bzrlib import (
     chk_map,
     errors,
     generate_ids,
     osutils,
-    symbol_versioning,
     )
 """)
 
@@ -49,7 +47,6 @@
     BzrCheckError,
     BzrError,
     )
-from bzrlib.symbol_versioning import deprecated_in, deprecated_method
 from bzrlib.trace import mutter
 from bzrlib.static_tuple import StaticTuple
 
@@ -131,7 +128,23 @@
     RENAMED = 'renamed'
     MODIFIED_AND_RENAMED = 'modified and renamed'
 
-    __slots__ = []
+    __slots__ = ['file_id', 'revision', 'parent_id', 'name']
+
+    # Attributes that all InventoryEntry instances are expected to have, but
+    # that don't vary for all kinds of entry.  (e.g. symlink_target is only
+    # relevant to InventoryLink, so there's no reason to make every
+    # InventoryFile instance allocate space to hold a value for it.)
+    # Attributes that only vary for files: executable, text_sha1, text_size,
+    # text_id
+    executable = False
+    text_sha1 = None
+    text_size = None
+    text_id = None
+    # Attributes that only vary for symlinks: symlink_target
+    symlink_target = None
+    # Attributes that only vary for tree-references: reference_revision
+    reference_revision = None
+
 
     def detect_changes(self, old_entry):
         """Return a (text_modified, meta_modified) from this to old_entry.
@@ -176,16 +189,6 @@
                     candidates[ie.revision] = ie
         return candidates
 
-    @deprecated_method(deprecated_in((1, 6, 0)))
-    def get_tar_item(self, root, dp, now, tree):
-        """Get a tarfile item and a file stream for its content."""
-        item = tarfile.TarInfo(osutils.pathjoin(root, dp).encode('utf8'))
-        # TODO: would be cool to actually set it to the timestamp of the
-        # revision it was last changed
-        item.mtime = now
-        fileobj = self._put_in_tar(item, tree)
-        return item, fileobj
-
     def has_text(self):
         """Return true if the object this entry represents has textual data.
 
@@ -197,7 +200,7 @@
         """
         return False
 
-    def __init__(self, file_id, name, parent_id, text_id=None):
+    def __init__(self, file_id, name, parent_id):
         """Create an InventoryEntry
 
         The filename must be a single component, relative to the
@@ -214,16 +217,10 @@
         """
         if '/' in name or '\\' in name:
             raise errors.InvalidEntryName(name=name)
-        self.executable = False
+        self.file_id = file_id
         self.revision = None
-        self.text_sha1 = None
-        self.text_size = None
-        self.file_id = file_id
         self.name = name
-        self.text_id = text_id
         self.parent_id = parent_id
-        self.symlink_target = None
-        self.reference_revision = None
 
     def kind_character(self):
         """Return a short kind indicator useful for appending to names."""
@@ -231,29 +228,6 @@
 
     known_kinds = ('file', 'directory', 'symlink')
 
-    def _put_in_tar(self, item, tree):
-        """populate item for stashing in a tar, and return the content stream.
-
-        If no content is available, return None.
-        """
-        raise BzrError("don't know how to export {%s} of kind %r" %
-                       (self.file_id, self.kind))
-
-    @deprecated_method(deprecated_in((1, 6, 0)))
-    def put_on_disk(self, dest, dp, tree):
-        """Create a representation of self on disk in the prefix dest.
-
-        This is a template method - implement _put_on_disk in subclasses.
-        """
-        fullpath = osutils.pathjoin(dest, dp)
-        self._put_on_disk(fullpath, tree)
-        # mutter("  export {%s} kind %s to %s", self.file_id,
-        #         self.kind, fullpath)
-
-    def _put_on_disk(self, fullpath, tree):
-        """Put this entry onto disk at fullpath, from tree tree."""
-        raise BzrError("don't know how to export {%s} of kind %r" % (self.file_id, self.kind))
-
     def sorted_children(self):
         return sorted(self.children.items())
 
@@ -397,47 +371,15 @@
         pass
 
 
-class RootEntry(InventoryEntry):
-
-    __slots__ = ['text_sha1', 'text_size', 'file_id', 'name', 'kind',
-                 'text_id', 'parent_id', 'children', 'executable',
-                 'revision', 'symlink_target', 'reference_revision']
-
-    def _check(self, checker, rev_id):
-        """See InventoryEntry._check"""
-
-    def __init__(self, file_id):
-        self.file_id = file_id
-        self.children = {}
-        self.kind = 'directory'
-        self.parent_id = None
-        self.name = u''
-        self.revision = None
-        symbol_versioning.warn('RootEntry is deprecated as of bzr 0.10.'
-                               '  Please use InventoryDirectory instead.',
-                               DeprecationWarning, stacklevel=2)
-
-    def __eq__(self, other):
-        if not isinstance(other, RootEntry):
-            return NotImplemented
-
-        return (self.file_id == other.file_id) \
-               and (self.children == other.children)
-
-
 class InventoryDirectory(InventoryEntry):
     """A directory in an inventory."""
 
-    __slots__ = ['text_sha1', 'text_size', 'file_id', 'name', 'kind',
-                 'text_id', 'parent_id', 'children', 'executable',
-                 'revision', 'symlink_target', 'reference_revision']
+    __slots__ = ['children']
+
+    kind = 'directory'
 
     def _check(self, checker, rev_id):
         """See InventoryEntry._check"""
-        if (self.text_sha1 is not None or self.text_size is not None or
-            self.text_id is not None):
-            checker._report_items.append('directory {%s} has text in revision {%s}'
-                                % (self.file_id, rev_id))
         # In non rich root repositories we do not expect a file graph for the
         # root.
         if self.name == '' and not checker.rich_roots:
@@ -459,32 +401,25 @@
     def __init__(self, file_id, name, parent_id):
         super(InventoryDirectory, self).__init__(file_id, name, parent_id)
         self.children = {}
-        self.kind = 'directory'
 
     def kind_character(self):
         """See InventoryEntry.kind_character."""
         return '/'
 
-    def _put_in_tar(self, item, tree):
-        """See InventoryEntry._put_in_tar."""
-        item.type = tarfile.DIRTYPE
-        fileobj = None
-        item.name += '/'
-        item.size = 0
-        item.mode = 0755
-        return fileobj
-
-    def _put_on_disk(self, fullpath, tree):
-        """See InventoryEntry._put_on_disk."""
-        os.mkdir(fullpath)
-
 
 class InventoryFile(InventoryEntry):
     """A file in an inventory."""
 
-    __slots__ = ['text_sha1', 'text_size', 'file_id', 'name', 'kind',
-                 'text_id', 'parent_id', 'children', 'executable',
-                 'revision', 'symlink_target', 'reference_revision']
+    __slots__ = ['text_sha1', 'text_size', 'text_id', 'executable']
+
+    kind = 'file'
+
+    def __init__(self, file_id, name, parent_id):
+        super(InventoryFile, self).__init__(file_id, name, parent_id)
+        self.text_sha1 = None
+        self.text_size = None
+        self.text_id = None
+        self.executable = False
 
     def _check(self, checker, tree_revision_id):
         """See InventoryEntry._check"""
@@ -533,31 +468,10 @@
         """See InventoryEntry.has_text."""
         return True
 
-    def __init__(self, file_id, name, parent_id):
-        super(InventoryFile, self).__init__(file_id, name, parent_id)
-        self.kind = 'file'
-
     def kind_character(self):
         """See InventoryEntry.kind_character."""
         return ''
 
-    def _put_in_tar(self, item, tree):
-        """See InventoryEntry._put_in_tar."""
-        item.type = tarfile.REGTYPE
-        fileobj = tree.get_file(self.file_id)
-        item.size = self.text_size
-        if tree.is_executable(self.file_id):
-            item.mode = 0755
-        else:
-            item.mode = 0644
-        return fileobj
-
-    def _put_on_disk(self, fullpath, tree):
-        """See InventoryEntry._put_on_disk."""
-        osutils.pumpfile(tree.get_file(self.file_id), file(fullpath, 'wb'))
-        if tree.is_executable(self.file_id):
-            os.chmod(fullpath, 0755)
-
     def _read_tree_state(self, path, work_tree):
         """See InventoryEntry._read_tree_state."""
         self.text_sha1 = work_tree.get_file_sha1(self.file_id, path=path)
@@ -595,16 +509,16 @@
 class InventoryLink(InventoryEntry):
     """A file in an inventory."""
 
-    __slots__ = ['text_sha1', 'text_size', 'file_id', 'name', 'kind',
-                 'text_id', 'parent_id', 'children', 'executable',
-                 'revision', 'symlink_target', 'reference_revision']
+    __slots__ = ['symlink_target']
+
+    kind = 'symlink'
+
+    def __init__(self, file_id, name, parent_id):
+        super(InventoryLink, self).__init__(file_id, name, parent_id)
+        self.symlink_target = None
 
     def _check(self, checker, tree_revision_id):
         """See InventoryEntry._check"""
-        if self.text_sha1 is not None or self.text_size is not None or self.text_id is not None:
-            checker._report_items.append(
-               'symlink {%s} has text in revision {%s}'
-                    % (self.file_id, tree_revision_id))
         if self.symlink_target is None:
             checker._report_items.append(
                 'symlink {%s} has no target in revision {%s}'
@@ -648,30 +562,10 @@
         differ = DiffSymlink(old_tree, new_tree, output_to)
         return differ.diff_symlink(old_target, new_target)
 
-    def __init__(self, file_id, name, parent_id):
-        super(InventoryLink, self).__init__(file_id, name, parent_id)
-        self.kind = 'symlink'
-
     def kind_character(self):
         """See InventoryEntry.kind_character."""
         return ''
 
-    def _put_in_tar(self, item, tree):
-        """See InventoryEntry._put_in_tar."""
-        item.type = tarfile.SYMTYPE
-        fileobj = None
-        item.size = 0
-        item.mode = 0755
-        item.linkname = self.symlink_target
-        return fileobj
-
-    def _put_on_disk(self, fullpath, tree):
-        """See InventoryEntry._put_on_disk."""
-        try:
-            os.symlink(self.symlink_target, fullpath)
-        except OSError,e:
-            raise BzrError("Failed to create symlink %r -> %r, error: %s" % (fullpath, self.symlink_target, e))
-
     def _read_tree_state(self, path, work_tree):
         """See InventoryEntry._read_tree_state."""
         self.symlink_target = work_tree.get_symlink_target(self.file_id)
@@ -689,6 +583,8 @@
 
 class TreeReference(InventoryEntry):
 
+    __slots__ = ['reference_revision']
+
     kind = 'tree-reference'
 
     def __init__(self, file_id, name, parent_id, revision=None,
@@ -2241,17 +2137,13 @@
 class CHKInventoryDirectory(InventoryDirectory):
     """A directory in an inventory."""
 
-    __slots__ = ['text_sha1', 'text_size', 'file_id', 'name', 'kind',
-                 'text_id', 'parent_id', '_children', 'executable',
-                 'revision', 'symlink_target', 'reference_revision',
-                 '_chk_inventory']
+    __slots__ = ['_children', '_chk_inventory']
 
     def __init__(self, file_id, name, parent_id, chk_inventory):
         # Don't call InventoryDirectory.__init__ - it isn't right for this
         # class.
         InventoryEntry.__init__(self, file_id, name, parent_id)
         self._children = None
-        self.kind = 'directory'
         self._chk_inventory = chk_inventory
 
     @property

=== modified file 'bzrlib/log.py'
--- bzrlib/log.py	2010-06-30 12:03:30 +0000
+++ bzrlib/log.py	2010-07-16 13:29:07 +0000
@@ -2017,7 +2017,7 @@
       kind is one of values 'directory', 'file', 'symlink', 'tree-reference'.
       branch will be read-locked.
     """
-    from builtins import _get_revision_range, safe_relpath_files
+    from builtins import _get_revision_range
     tree, b, path = bzrdir.BzrDir.open_containing_tree_or_branch(file_list[0])
     add_cleanup(b.lock_read().unlock)
     # XXX: It's damn messy converting a list of paths to relative paths when
@@ -2029,7 +2029,7 @@
     # case of running log in a nested directory, assuming paths beyond the
     # first one haven't been deleted ...
     if tree:
-        relpaths = [path] + safe_relpath_files(tree, file_list[1:])
+        relpaths = [path] + tree.safe_relpath_files(file_list[1:])
     else:
         relpaths = [path] + file_list[1:]
     info_list = []

=== modified file 'bzrlib/lru_cache.py'
--- bzrlib/lru_cache.py	2009-07-08 15:43:51 +0000
+++ bzrlib/lru_cache.py	2010-07-15 13:05:40 +0000
@@ -17,7 +17,6 @@
 """A simple least-recently-used (LRU) cache."""
 
 from bzrlib import (
-    symbol_versioning,
     trace,
     )
 
@@ -61,14 +60,7 @@
 class LRUCache(object):
     """A class which manages a cache of entries, removing unused ones."""
 
-    def __init__(self, max_cache=100, after_cleanup_count=None,
-                 after_cleanup_size=symbol_versioning.DEPRECATED_PARAMETER):
-        if symbol_versioning.deprecated_passed(after_cleanup_size):
-            symbol_versioning.warn('LRUCache.__init__(after_cleanup_size) was'
-                                   ' deprecated in 1.11. Use'
-                                   ' after_cleanup_count instead.',
-                                   DeprecationWarning)
-            after_cleanup_count = after_cleanup_size
+    def __init__(self, max_cache=100, after_cleanup_count=None):
         self._cache = {}
         # The "HEAD" of the lru linked list
         self._most_recently_used = None

=== modified file 'bzrlib/merge.py'
--- bzrlib/merge.py	2010-06-04 03:09:35 +0000
+++ bzrlib/merge.py	2010-07-29 03:56:54 +0000
@@ -22,7 +22,7 @@
     branch as _mod_branch,
     conflicts as _mod_conflicts,
     debug,
-    errors,
+    generate_ids,
     graph as _mod_graph,
     merge3,
     osutils,
@@ -35,11 +35,13 @@
     tsort,
     ui,
     versionedfile,
+    workingtree,
     )
 from bzrlib.cleanup import OperationWithCleanups
 """)
 from bzrlib import (
     decorators,
+    errors,
     hooks,
     )
 from bzrlib.symbol_versioning import (
@@ -426,7 +428,6 @@
         return self._cached_trees[revision_id]
 
     def _get_tree(self, treespec, possible_transports=None):
-        from bzrlib import workingtree
         location, revno = treespec
         if revno is None:
             tree = workingtree.WorkingTree.open_containing(location)[0]
@@ -861,6 +862,13 @@
         finally:
             child_pb.finished()
         self.fix_root()
+        self._finish_computing_transform()
+
+    def _finish_computing_transform(self):
+        """Finalize the transform and report the changes.
+
+        This is the second half of _compute_transform.
+        """
         child_pb = ui.ui_factory.nested_progress_bar()
         try:
             fs_conflicts = transform.resolve_conflicts(self.tt, child_pb,
@@ -1076,7 +1084,6 @@
                           ))
         return result
 
-
     def fix_root(self):
         try:
             self.tt.final_kind(self.tt.root)
@@ -1755,6 +1762,168 @@
             osutils.rmtree(temp_dir)
 
 
+class PathNotInTree(errors.BzrError):
+
+    _fmt = """Merge-into failed because %(tree)s does not contain %(path)s."""
+
+    def __init__(self, path, tree):
+        errors.BzrError.__init__(self, path=path, tree=tree)
+
+
+class MergeIntoMerger(Merger):
+    """Merger that understands other_tree will be merged into a subdir.
+
+    This also changes the Merger api so that it uses real Branch, revision_id,
+    and RevisonTree objects, rather than using revision specs.
+    """
+
+    def __init__(self, this_tree, other_branch, other_tree, target_subdir,
+            source_subpath, other_rev_id=None):
+        """Create a new MergeIntoMerger object.
+
+        source_subpath in other_tree will be effectively copied to
+        target_subdir in this_tree.
+
+        :param this_tree: The tree that we will be merging into.
+        :param other_branch: The Branch we will be merging from.
+        :param other_tree: The RevisionTree object we want to merge.
+        :param target_subdir: The relative path where we want to merge
+            other_tree into this_tree
+        :param source_subpath: The relative path specifying the subtree of
+            other_tree to merge into this_tree.
+        """
+        # It is assumed that we are merging a tree that is not in our current
+        # ancestry, which means we are using the "EmptyTree" as our basis.
+        null_ancestor_tree = this_tree.branch.repository.revision_tree(
+                                _mod_revision.NULL_REVISION)
+        super(MergeIntoMerger, self).__init__(
+            this_branch=this_tree.branch,
+            this_tree=this_tree,
+            other_tree=other_tree,
+            base_tree=null_ancestor_tree,
+            )
+        self._target_subdir = target_subdir
+        self._source_subpath = source_subpath
+        self.other_branch = other_branch
+        if other_rev_id is None:
+            other_rev_id = other_tree.get_revision_id()
+        self.other_rev_id = self.other_basis = other_rev_id
+        self.base_is_ancestor = True
+        self.backup_files = True
+        self.merge_type = Merge3Merger
+        self.show_base = False
+        self.reprocess = False
+        self.interesting_ids = None
+        self.merge_type = _MergeTypeParameterizer(MergeIntoMergeType,
+              target_subdir=self._target_subdir,
+              source_subpath=self._source_subpath)
+        if self._source_subpath != '':
+            # If this isn't a partial merge make sure the revisions will be
+            # present.
+            self._maybe_fetch(self.other_branch, self.this_branch,
+                self.other_basis)
+
+    def set_pending(self):
+        if self._source_subpath != '':
+            return
+        Merger.set_pending(self)
+
+
+class _MergeTypeParameterizer(object):
+    """Wrap a merge-type class to provide extra parameters.
+    
+    This is hack used by MergeIntoMerger to pass some extra parameters to its
+    merge_type.  Merger.do_merge() sets up its own set of parameters to pass to
+    the 'merge_type' member.  It is difficult override do_merge without
+    re-writing the whole thing, so instead we create a wrapper which will pass
+    the extra parameters.
+    """
+
+    def __init__(self, merge_type, **kwargs):
+        self._extra_kwargs = kwargs
+        self._merge_type = merge_type
+
+    def __call__(self, *args, **kwargs):
+        kwargs.update(self._extra_kwargs)
+        return self._merge_type(*args, **kwargs)
+
+    def __getattr__(self, name):
+        return getattr(self._merge_type, name)
+
+
+class MergeIntoMergeType(Merge3Merger):
+    """Merger that incorporates a tree (or part of a tree) into another."""
+
+    def __init__(self, *args, **kwargs):
+        """Initialize the merger object.
+
+        :param args: See Merge3Merger.__init__'s args.
+        :param kwargs: See Merge3Merger.__init__'s keyword args, except for
+            source_subpath and target_subdir.
+        :keyword source_subpath: The relative path specifying the subtree of
+            other_tree to merge into this_tree.
+        :keyword target_subdir: The relative path where we want to merge
+            other_tree into this_tree
+        """
+        # All of the interesting work happens during Merge3Merger.__init__(),
+        # so we have have to hack in to get our extra parameters set.
+        self._source_subpath = kwargs.pop('source_subpath')
+        self._target_subdir = kwargs.pop('target_subdir')
+        super(MergeIntoMergeType, self).__init__(*args, **kwargs)
+
+    def _compute_transform(self):
+        child_pb = ui.ui_factory.nested_progress_bar()
+        try:
+            entries = self._entries_to_incorporate()
+            entries = list(entries)
+            for num, (entry, parent_id) in enumerate(entries):
+                child_pb.update('Preparing file merge', num, len(entries))
+                parent_trans_id = self.tt.trans_id_file_id(parent_id)
+                trans_id = transform.new_by_entry(self.tt, entry,
+                    parent_trans_id, self.other_tree)
+        finally:
+            child_pb.finished()
+        self._finish_computing_transform()
+
+    def _entries_to_incorporate(self):
+        """Yields pairs of (inventory_entry, new_parent)."""
+        other_inv = self.other_tree.inventory
+        subdir_id = other_inv.path2id(self._source_subpath)
+        if subdir_id is None:
+            # XXX: The error would be clearer if it gave the URL of the source
+            # branch, but we don't have a reference to that here.
+            raise PathNotInTree(self._source_subpath, "Source tree")
+        subdir = other_inv[subdir_id]
+        parent_in_target = osutils.dirname(self._target_subdir)
+        target_id = self.this_tree.inventory.path2id(parent_in_target)
+        if target_id is None:
+            raise PathNotInTree(self._target_subdir, "Target tree")
+        name_in_target = osutils.basename(self._target_subdir)
+        merge_into_root = subdir.copy()
+        merge_into_root.name = name_in_target
+        if merge_into_root.file_id in self.this_tree.inventory:
+            # Give the root a new file-id.
+            # This can happen fairly easily if the directory we are
+            # incorporating is the root, and both trees have 'TREE_ROOT' as
+            # their root_id.  Users will expect this to Just Work, so we
+            # change the file-id here.
+            # Non-root file-ids could potentially conflict too.  That's really
+            # an edge case, so we don't do anything special for those.  We let
+            # them cause conflicts.
+            merge_into_root.file_id = generate_ids.gen_file_id(name_in_target)
+        yield (merge_into_root, target_id)
+        if subdir.kind != 'directory':
+            # No children, so we are done.
+            return
+        for ignored_path, entry in other_inv.iter_entries_by_dir(subdir_id):
+            parent_id = entry.parent_id
+            if parent_id == subdir.file_id:
+                # The root's parent ID has changed, so make sure children of
+                # the root refer to the new ID.
+                parent_id = merge_into_root.file_id
+            yield (entry, parent_id)
+
+
 def merge_inner(this_branch, other_tree, base_tree, ignore_zero=False,
                 backup_files=False,
                 merge_type=Merge3Merger,
@@ -1768,10 +1937,11 @@
                 change_reporter=None):
     """Primary interface for merging.
 
-        typical use is probably
-        'merge_inner(branch, branch.get_revision_tree(other_revision),
-                     branch.get_revision_tree(base_revision))'
-        """
+    Typical use is probably::
+
+        merge_inner(branch, branch.get_revision_tree(other_revision),
+                    branch.get_revision_tree(base_revision))
+    """
     if this_tree is None:
         raise errors.BzrError("bzrlib.merge.merge_inner requires a this_tree "
                               "parameter as of bzrlib version 0.8.")

=== modified file 'bzrlib/multiparent.py'
--- bzrlib/multiparent.py	2009-06-10 03:56:49 +0000
+++ bzrlib/multiparent.py	2010-08-11 01:31:11 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2007 Canonical Ltd
+# Copyright (C) 2007-2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -76,6 +76,8 @@
 class MultiParent(object):
     """A multi-parent diff"""
 
+    __slots__ = ['hunks']
+
     def __init__(self, hunks=None):
         if hunks is not None:
             self.hunks = hunks
@@ -258,6 +260,8 @@
 class NewText(object):
     """The contents of text that is introduced by this text"""
 
+    __slots__ = ['lines']
+
     def __init__(self, lines):
         self.lines = lines
 
@@ -279,24 +283,30 @@
 class ParentText(object):
     """A reference to text present in a parent text"""
 
+    __slots__ = ['parent', 'parent_pos', 'child_pos', 'num_lines']
+
     def __init__(self, parent, parent_pos, child_pos, num_lines):
         self.parent = parent
         self.parent_pos = parent_pos
         self.child_pos = child_pos
         self.num_lines = num_lines
 
+    def _as_dict(self):
+        return dict(parent=self.parent, parent_pos=self.parent_pos,
+                    child_pos=self.child_pos, num_lines=self.num_lines)
+
     def __repr__(self):
-        return 'ParentText(%(parent)r, %(parent_pos)r, %(child_pos)r,'\
-            ' %(num_lines)r)' % self.__dict__
+        return ('ParentText(%(parent)r, %(parent_pos)r, %(child_pos)r,'
+                ' %(num_lines)r)' % self._as_dict())
 
     def __eq__(self, other):
         if self.__class__ is not other.__class__:
             return False
-        return (self.__dict__ == other.__dict__)
+        return self._as_dict() == other._as_dict()
 
     def to_patch(self):
-        yield 'c %(parent)d %(parent_pos)d %(child_pos)d %(num_lines)d\n'\
-            % self.__dict__
+        yield ('c %(parent)d %(parent_pos)d %(child_pos)d %(num_lines)d\n'
+               % self._as_dict())
 
 
 class BaseVersionedFile(object):

=== modified file 'bzrlib/mutabletree.py'
--- bzrlib/mutabletree.py	2010-05-10 11:34:20 +0000
+++ bzrlib/mutabletree.py	2010-07-29 11:17:57 +0000
@@ -375,6 +375,10 @@
         This is designed more towards DWIM for humans than API clarity.
         For the specific behaviour see the help for cmd_add().
 
+        :param file_list: List of zero or more paths.  *NB: these are 
+            interpreted relative to the process cwd, not relative to the 
+            tree.*  (Add and most other tree methods use tree-relative
+            paths.)
         :param action: A reporter to be called with the inventory, parent_ie,
             path and kind of the path being added. It may return a file_id if
             a specific one should be used.

=== modified file 'bzrlib/plugins/launchpad/lp_directory.py'
--- bzrlib/plugins/launchpad/lp_directory.py	2010-03-30 11:05:14 +0000
+++ bzrlib/plugins/launchpad/lp_directory.py	2010-07-26 17:19:33 +0000
@@ -64,7 +64,16 @@
         """Resolve the base URL for this transport."""
         service = LaunchpadService.for_url(url)
         result = urlsplit(url)
-        resolve = _request_factory(result[2].strip('/'))
+        if _lp_login is None:
+            _lp_login = get_lp_login()
+        path = result[2].strip('/')
+        if path.startswith('~/'):
+            if _lp_login is None:
+                raise errors.InvalidURL(path=url,
+                    extra='Cannot resolve "~" to your username.'
+                          ' See "bzr help launchpad-login"')
+            path = '~' + _lp_login + path[1:]
+        resolve = _request_factory(path)
         try:
             result = resolve.submit(service)
         except xmlrpclib.Fault, fault:
@@ -74,8 +83,6 @@
         if 'launchpad' in debug.debug_flags:
             trace.mutter("resolve_lp_path(%r) == %r", url, result)
 
-        if _lp_login is None:
-            _lp_login = get_lp_login()
         _warned_login = False
         for url in result['urls']:
             scheme, netloc, path, query, fragment = urlsplit(url)

=== modified file 'bzrlib/plugins/launchpad/test_lp_directory.py'
--- bzrlib/plugins/launchpad/test_lp_directory.py	2010-06-20 11:18:38 +0000
+++ bzrlib/plugins/launchpad/test_lp_directory.py	2010-07-26 17:19:33 +0000
@@ -36,7 +36,7 @@
     )
 from bzrlib.plugins.launchpad.lp_directory import (
     LaunchpadDirectory)
-from bzrlib.plugins.launchpad.account import get_lp_login
+from bzrlib.plugins.launchpad.account import get_lp_login, set_lp_login
 from bzrlib.tests import (
     http_server,
     http_utils,
@@ -199,6 +199,29 @@
         self.assertRaises(errors.InvalidURL,
             directory._resolve, 'lp://ratotehunoahu')
 
+    def test_resolve_tilde_to_user(self):
+        factory = FakeResolveFactory(
+            self, '~username/apt/test', dict(urls=[
+                    'bzr+ssh://bazaar.launchpad.net/~username/apt/test']))
+        directory = LaunchpadDirectory()
+        self.assertEquals(
+            'bzr+ssh://bazaar.launchpad.net/~username/apt/test',
+            directory._resolve('lp:~/apt/test', factory, _lp_login='username'))
+        # Should also happen when the login is just set by config
+        set_lp_login('username')
+        self.assertEquals(
+            'bzr+ssh://bazaar.launchpad.net/~username/apt/test',
+            directory._resolve('lp:~/apt/test', factory))
+
+    def test_tilde_fails_no_login(self):
+        factory = FakeResolveFactory(
+            self, '~username/apt/test', dict(urls=[
+                    'bzr+ssh://bazaar.launchpad.net/~username/apt/test']))
+        self.assertIs(None, get_lp_login())
+        directory = LaunchpadDirectory()
+        e = self.assertRaises(errors.InvalidURL,
+            directory._resolve, 'lp:~/apt/test', factory)
+
 
 class DirectoryOpenBranchTests(TestCaseWithMemoryTransport):
 

=== modified file 'bzrlib/progress.py'
--- bzrlib/progress.py	2010-04-30 11:03:59 +0000
+++ bzrlib/progress.py	2010-07-17 16:39:20 +0000
@@ -152,19 +152,6 @@
                 own_fraction = 0.0
             return self._parent_task._overall_completion_fraction(own_fraction)
 
-    @deprecated_method(deprecated_in((2, 1, 0)))
-    def note(self, fmt_string, *args):
-        """Record a note without disrupting the progress bar.
-        
-        Deprecated: use ui_factory.note() instead or bzrlib.trace.  Note that
-        ui_factory.note takes just one string as the argument, not a format
-        string and arguments.
-        """
-        if args:
-            self.ui_factory.note(fmt_string % args)
-        else:
-            self.ui_factory.note(fmt_string)
-
     def clear(self):
         # TODO: deprecate this method; the model object shouldn't be concerned
         # with whether it's shown or not.  Most callers use this because they
@@ -220,12 +207,6 @@
         self.clear()
         self._stack.return_pb(self)
 
-    def note(self, fmt_string, *args, **kwargs):
-        """Record a note without disrupting the progress bar."""
-        self.clear()
-        self.to_messages_file.write(fmt_string % args)
-        self.to_messages_file.write('\n')
-
 
 class DummyProgress(object):
     """Progress-bar standin that does nothing.
@@ -248,9 +229,6 @@
     def clear(self):
         pass
 
-    def note(self, fmt_string, *args, **kwargs):
-        """See _BaseProgressBar.note()."""
-
     def child_progress(self, **kwargs):
         return DummyProgress(**kwargs)
 

=== modified file 'bzrlib/revision.py'
--- bzrlib/revision.py	2010-02-23 07:43:11 +0000
+++ bzrlib/revision.py	2010-07-15 12:37:32 +0000
@@ -121,21 +121,6 @@
         else:
             return ''
 
-    @symbol_versioning.deprecated_method(symbol_versioning.deprecated_in((1, 13, 0)))
-    def get_apparent_author(self):
-        """Return the apparent author of this revision.
-
-        This method is deprecated in favour of get_apparent_authors.
-
-        If the revision properties contain any author names,
-        return the first. Otherwise return the committer name.
-        """
-        authors = self.get_apparent_authors()
-        if authors:
-            return authors[0]
-        else:
-            return None
-
     def get_apparent_authors(self):
         """Return the apparent authors of this revision.
 

=== modified file 'bzrlib/shelf_ui.py'
--- bzrlib/shelf_ui.py	2010-05-26 15:58:08 +0000
+++ bzrlib/shelf_ui.py	2010-07-16 13:29:07 +0000
@@ -175,7 +175,7 @@
         try:
             target_tree = builtins._get_one_revision_tree('shelf2', revision,
                 tree.branch, tree)
-            files = builtins.safe_relpath_files(tree, file_list)
+            files = tree.safe_relpath_files(file_list)
             return klass(tree, target_tree, diff_writer, all, all, files,
                          message, destroy)
         finally:

=== modified file 'bzrlib/tests/TestUtil.py'
--- bzrlib/tests/TestUtil.py	2010-02-17 17:11:16 +0000
+++ bzrlib/tests/TestUtil.py	2010-08-05 18:13:23 +0000
@@ -135,7 +135,13 @@
         >>>         result.addTests([test, test])
         >>>     return result
         """
-        basic_tests = super(TestLoader, self).loadTestsFromModule(module)
+        if sys.version_info < (2, 7):
+            basic_tests = super(TestLoader, self).loadTestsFromModule(module)
+        else:
+            # GZ 2010-07-19: Python 2.7 unittest also uses load_tests but with
+            #                a different and incompatible signature
+            basic_tests = super(TestLoader, self).loadTestsFromModule(module,
+                use_load_tests=False)
         load_tests = getattr(module, "load_tests", None)
         if load_tests is not None:
             return load_tests(basic_tests, module, self)

=== modified file 'bzrlib/tests/__init__.py'
--- bzrlib/tests/__init__.py	2010-07-08 10:34:12 +0000
+++ bzrlib/tests/__init__.py	2010-08-10 18:07:54 +0000
@@ -34,6 +34,7 @@
 import difflib
 import doctest
 import errno
+import itertools
 import logging
 import math
 import os
@@ -140,7 +141,7 @@
 SUBUNIT_SEEK_CUR = 1
 
 
-class ExtendedTestResult(unittest._TextTestResult):
+class ExtendedTestResult(testtools.TextTestResult):
     """Accepts, reports and accumulates the results of running tests.
 
     Compared to the unittest version this class adds support for
@@ -167,7 +168,7 @@
         :param bench_history: Optionally, a writable file object to accumulate
             benchmark results.
         """
-        unittest._TextTestResult.__init__(self, stream, descriptions, verbosity)
+        testtools.TextTestResult.__init__(self, stream)
         if bench_history is not None:
             from bzrlib.version import _get_bzr_source_tree
             src_tree = _get_bzr_source_tree()
@@ -200,11 +201,13 @@
         actionTaken = "Ran"
         stopTime = time.time()
         timeTaken = stopTime - self.startTime
-        self.printErrors()
-        self.stream.writeln(self.separator2)
-        self.stream.writeln("%s %d test%s in %.3fs" % (actionTaken,
+        # GZ 2010-07-19: Seems testtools has no printErrors method, and though
+        #                the parent class method is similar have to duplicate
+        self._show_list('ERROR', self.errors)
+        self._show_list('FAIL', self.failures)
+        self.stream.write(self.sep2)
+        self.stream.write("%s %d test%s in %.3fs\n\n" % (actionTaken,
                             run, run != 1 and "s" or "", timeTaken))
-        self.stream.writeln()
         if not self.wasSuccessful():
             self.stream.write("FAILED (")
             failed, errored = map(len, (self.failures, self.errors))
@@ -217,20 +220,20 @@
                 if failed or errored: self.stream.write(", ")
                 self.stream.write("known_failure_count=%d" %
                     self.known_failure_count)
-            self.stream.writeln(")")
+            self.stream.write(")\n")
         else:
             if self.known_failure_count:
-                self.stream.writeln("OK (known_failures=%d)" %
+                self.stream.write("OK (known_failures=%d)\n" %
                     self.known_failure_count)
             else:
-                self.stream.writeln("OK")
+                self.stream.write("OK\n")
         if self.skip_count > 0:
             skipped = self.skip_count
-            self.stream.writeln('%d test%s skipped' %
+            self.stream.write('%d test%s skipped\n' %
                                 (skipped, skipped != 1 and "s" or ""))
         if self.unsupported:
             for feature, count in sorted(self.unsupported.items()):
-                self.stream.writeln("Missing feature '%s' skipped %d tests." %
+                self.stream.write("Missing feature '%s' skipped %d tests.\n" %
                     (feature, count))
         if self._strict:
             ok = self.wasStrictlySuccessful()
@@ -274,11 +277,11 @@
 
     def _shortened_test_description(self, test):
         what = test.id()
-        what = re.sub(r'^bzrlib\.(tests|benchmarks)\.', '', what)
+        what = re.sub(r'^bzrlib\.tests\.', '', what)
         return what
 
     def startTest(self, test):
-        unittest.TestResult.startTest(self, test)
+        super(ExtendedTestResult, self).startTest(test)
         if self.count == 0:
             self.startTests()
         self.report_test_start(test)
@@ -322,7 +325,7 @@
         fails with an unexpected error.
         """
         self._post_mortem()
-        unittest.TestResult.addError(self, test, err)
+        super(ExtendedTestResult, self).addError(test, err)
         self.error_count += 1
         self.report_error(test, err)
         if self.stop_early:
@@ -336,7 +339,7 @@
         fails because e.g. an assert() method failed.
         """
         self._post_mortem()
-        unittest.TestResult.addFailure(self, test, err)
+        super(ExtendedTestResult, self).addFailure(test, err)
         self.failure_count += 1
         self.report_failure(test, err)
         if self.stop_early:
@@ -356,7 +359,7 @@
                     test.id()))
         self.report_success(test)
         self._cleanupLogFile(test)
-        unittest.TestResult.addSuccess(self, test)
+        super(ExtendedTestResult, self).addSuccess(test)
         test._log_contents = ''
 
     def addExpectedFailure(self, test, err):
@@ -550,40 +553,40 @@
         return '%s%s' % (indent, err[1])
 
     def report_error(self, test, err):
-        self.stream.writeln('ERROR %s\n%s'
+        self.stream.write('ERROR %s\n%s\n'
                 % (self._testTimeString(test),
                    self._error_summary(err)))
 
     def report_failure(self, test, err):
-        self.stream.writeln(' FAIL %s\n%s'
+        self.stream.write(' FAIL %s\n%s\n'
                 % (self._testTimeString(test),
                    self._error_summary(err)))
 
     def report_known_failure(self, test, err):
-        self.stream.writeln('XFAIL %s\n%s'
+        self.stream.write('XFAIL %s\n%s\n'
                 % (self._testTimeString(test),
                    self._error_summary(err)))
 
     def report_success(self, test):
-        self.stream.writeln('   OK %s' % self._testTimeString(test))
+        self.stream.write('   OK %s\n' % self._testTimeString(test))
         for bench_called, stats in getattr(test, '_benchcalls', []):
-            self.stream.writeln('LSProf output for %s(%s, %s)' % bench_called)
+            self.stream.write('LSProf output for %s(%s, %s)\n' % bench_called)
             stats.pprint(file=self.stream)
         # flush the stream so that we get smooth output. This verbose mode is
         # used to show the output in PQM.
         self.stream.flush()
 
     def report_skip(self, test, reason):
-        self.stream.writeln(' SKIP %s\n%s'
+        self.stream.write(' SKIP %s\n%s\n'
                 % (self._testTimeString(test), reason))
 
     def report_not_applicable(self, test, reason):
-        self.stream.writeln('  N/A %s\n    %s'
+        self.stream.write('  N/A %s\n    %s\n'
                 % (self._testTimeString(test), reason))
 
     def report_unsupported(self, test, feature):
         """test cannot be run because feature is missing."""
-        self.stream.writeln("NODEP %s\n    The feature '%s' is not available."
+        self.stream.write("NODEP %s\n    The feature '%s' is not available.\n"
                 %(self._testTimeString(test), feature))
 
 
@@ -618,7 +621,7 @@
             encode = codec.encode
         stream = osutils.UnicodeOrBytesToBytesWriter(encode, stream)
         stream.encoding = new_encoding
-        self.stream = unittest._WritelnDecorator(stream)
+        self.stream = stream
         self.descriptions = descriptions
         self.verbosity = verbosity
         self._bench_history = bench_history
@@ -2009,7 +2012,7 @@
 
     def get_bzr_path(self):
         """Return the path of the 'bzr' executable for this test suite."""
-        bzr_path = self.get_source_path()+'/bzr'
+        bzr_path = os.path.join(self.get_source_path(), "bzr")
         if not os.path.isfile(bzr_path):
             # We are probably installed. Assume sys.argv is the right file
             bzr_path = sys.argv[0]
@@ -3196,15 +3199,16 @@
 
 def partition_tests(suite, count):
     """Partition suite into count lists of tests."""
-    result = []
-    tests = list(iter_suite_tests(suite))
-    tests_per_process = int(math.ceil(float(len(tests)) / count))
-    for block in range(count):
-        low_test = block * tests_per_process
-        high_test = low_test + tests_per_process
-        process_tests = tests[low_test:high_test]
-        result.append(process_tests)
-    return result
+    # This just assigns tests in a round-robin fashion.  On one hand this
+    # splits up blocks of related tests that might run faster if they shared
+    # resources, but on the other it avoids assigning blocks of slow tests to
+    # just one partition.  So the slowest partition shouldn't be much slower
+    # than the fastest.
+    partitions = [list() for i in range(count)]
+    tests = iter_suite_tests(suite)
+    for partition, test in itertools.izip(itertools.cycle(partitions), tests):
+        partition.append(test)
+    return partitions
 
 
 def workaround_zealous_crypto_random():
@@ -3643,6 +3647,7 @@
         'bzrlib.doc',
         'bzrlib.tests.blackbox',
         'bzrlib.tests.commands',
+        'bzrlib.tests.doc_generate',
         'bzrlib.tests.per_branch',
         'bzrlib.tests.per_bzrdir',
         'bzrlib.tests.per_bzrdir_colo',
@@ -3813,6 +3818,7 @@
         'bzrlib.tests.test_transport_log',
         'bzrlib.tests.test_tree',
         'bzrlib.tests.test_treebuilder',
+        'bzrlib.tests.test_treeshape',
         'bzrlib.tests.test_tsort',
         'bzrlib.tests.test_tuned_gzip',
         'bzrlib.tests.test_ui',
@@ -3822,6 +3828,7 @@
         'bzrlib.tests.test_urlutils',
         'bzrlib.tests.test_version',
         'bzrlib.tests.test_version_info',
+        'bzrlib.tests.test_versionedfile',
         'bzrlib.tests.test_weave',
         'bzrlib.tests.test_whitebox',
         'bzrlib.tests.test_win32utils',

=== modified file 'bzrlib/tests/blackbox/test_add.py'
--- bzrlib/tests/blackbox/test_add.py	2010-02-23 07:43:11 +0000
+++ bzrlib/tests/blackbox/test_add.py	2010-07-16 13:53:26 +0000
@@ -23,6 +23,9 @@
     osutils,
     tests,
     )
+from bzrlib.tests import (
+    script,
+    )
 
 
 def load_tests(standard_tests, module, loader):
@@ -217,3 +220,14 @@
         os.symlink(osutils.abspath('target'), 'tree/link')
         out = self.run_bzr(['add', 'tree/link'])[0]
         self.assertEquals(out, 'adding link\n')
+
+    def test_add_not_child(self):
+        # https://bugs.launchpad.net/bzr/+bug/98735
+        sr = script.ScriptRunner()
+        self.make_branch_and_tree('tree1')
+        self.make_branch_and_tree('tree2')
+        self.build_tree(['tree1/a', 'tree2/b'])
+        sr.run_script(self, '''
+        $ bzr add tree1/a tree2/b
+        2>bzr: ERROR: Path "...tree2/b" is not a child of path "...tree1"
+        ''')

=== modified file 'bzrlib/tests/blackbox/test_branch.py'
--- bzrlib/tests/blackbox/test_branch.py	2010-06-11 07:32:12 +0000
+++ bzrlib/tests/blackbox/test_branch.py	2010-07-21 20:09:34 +0000
@@ -174,6 +174,29 @@
         target_stat = os.stat('target/file1')
         self.assertEqual(source_stat, target_stat)
 
+    def test_branch_files_from(self):
+        source = self.make_branch_and_tree('source')
+        self.build_tree(['source/file1'])
+        source.add('file1')
+        source.commit('added file')
+        out, err = self.run_bzr('branch source target --files-from source')
+        self.failUnlessExists('target/file1')
+
+    def test_branch_files_from_hardlink(self):
+        self.requireFeature(HardlinkFeature)
+        source = self.make_branch_and_tree('source')
+        self.build_tree(['source/file1'])
+        source.add('file1')
+        source.commit('added file')
+        source.bzrdir.sprout('second')
+        out, err = self.run_bzr('branch source target --files-from second'
+                                ' --hardlink')
+        source_stat = os.stat('source/file1')
+        second_stat = os.stat('second/file1')
+        target_stat = os.stat('target/file1')
+        self.assertNotEqual(source_stat, target_stat)
+        self.assertEqual(second_stat, target_stat)
+
     def test_branch_standalone(self):
         shared_repo = self.make_repository('repo', shared=True)
         self.example_branch('source')

=== modified file 'bzrlib/tests/blackbox/test_break_lock.py'
--- bzrlib/tests/blackbox/test_break_lock.py	2010-06-11 07:32:12 +0000
+++ bzrlib/tests/blackbox/test_break_lock.py	2010-07-21 13:32:27 +0000
@@ -20,15 +20,15 @@
 
 import bzrlib
 from bzrlib import (
+    branch,
+    bzrdir,
     errors,
     lockdir,
+    tests,
     )
-from bzrlib.branch import Branch
-from bzrlib.bzrdir import BzrDir
-from bzrlib.tests import TestCaseWithTransport
-
-
-class TestBreakLock(TestCaseWithTransport):
+
+
+class TestBreakLock(tests.TestCaseWithTransport):
 
     # General principal for break-lock: All the elements that might be locked
     # by a bzr operation on PATH, are candidates that break-lock may unlock.
@@ -52,14 +52,14 @@
              'repo/',
              'repo/branch/',
              'checkout/'])
-        bzrlib.bzrdir.BzrDir.create('master-repo').create_repository()
-        self.master_branch = bzrlib.bzrdir.BzrDir.create_branch_convenience(
+        bzrdir.BzrDir.create('master-repo').create_repository()
+        self.master_branch = bzrdir.BzrDir.create_branch_convenience(
             'master-repo/master-branch')
-        bzrlib.bzrdir.BzrDir.create('repo').create_repository()
-        local_branch = bzrlib.bzrdir.BzrDir.create_branch_convenience('repo/branch')
+        bzrdir.BzrDir.create('repo').create_repository()
+        local_branch = bzrdir.BzrDir.create_branch_convenience('repo/branch')
         local_branch.bind(self.master_branch)
-        checkoutdir = bzrlib.bzrdir.BzrDir.create('checkout')
-        bzrlib.branch.BranchReferenceFormat().initialize(
+        checkoutdir = bzrdir.BzrDir.create('checkout')
+        branch.BranchReferenceFormat().initialize(
             checkoutdir, target_branch=local_branch)
         self.wt = checkoutdir.create_workingtree()
 
@@ -82,22 +82,22 @@
         # we need 5 yes's - wt, branch, repo, bound branch, bound repo.
         self.run_bzr('break-lock checkout', stdin="y\ny\ny\ny\n")
         # a new tree instance should be lockable
-        branch = bzrlib.branch.Branch.open('checkout')
-        branch.lock_write()
-        branch.unlock()
+        br = branch.Branch.open('checkout')
+        br.lock_write()
+        br.unlock()
         # and a new instance of the master branch
-        mb = branch.get_master_branch()
+        mb = br.get_master_branch()
         mb.lock_write()
         mb.unlock()
         self.assertRaises(errors.LockBroken, self.wt.unlock)
         self.assertRaises(errors.LockBroken, self.master_branch.unlock)
 
 
-class TestBreakLockOldBranch(TestCaseWithTransport):
+class TestBreakLockOldBranch(tests.TestCaseWithTransport):
 
     def test_break_lock_format_5_bzrdir(self):
         # break lock on a format 5 bzrdir should just return
-        self.make_branch_and_tree('foo', format=bzrlib.bzrdir.BzrDirFormat5())
+        self.make_branch_and_tree('foo', format=bzrdir.BzrDirFormat5())
         out, err = self.run_bzr('break-lock foo')
         self.assertEqual('', out)
         self.assertEqual('', err)

=== modified file 'bzrlib/tests/blackbox/test_checkout.py'
--- bzrlib/tests/blackbox/test_checkout.py	2010-06-11 07:32:12 +0000
+++ bzrlib/tests/blackbox/test_checkout.py	2010-07-20 10:18:05 +0000
@@ -156,9 +156,20 @@
         self.build_tree(['source/file1'])
         source.add('file1')
         source.commit('added file')
-        out, err = self.run_bzr(['checkout', 'source', 'target',
-            '--files-from', 'source',
-            '--hardlink'])
+        out, err = self.run_bzr('checkout source target --hardlink')
         source_stat = os.stat('source/file1')
         target_stat = os.stat('target/file1')
         self.assertEqual(source_stat, target_stat)
+
+    def test_checkout_hardlink_files_from(self):
+        self.requireFeature(HardlinkFeature)
+        source = self.make_branch_and_tree('source')
+        self.build_tree(['source/file1'])
+        source.add('file1')
+        source.commit('added file')
+        source.bzrdir.sprout('second')
+        out, err = self.run_bzr('checkout source target --hardlink'
+                                ' --files-from second')
+        second_stat = os.stat('second/file1')
+        target_stat = os.stat('target/file1')
+        self.assertEqual(second_stat, target_stat)

=== modified file 'bzrlib/tests/blackbox/test_commit.py'
--- bzrlib/tests/blackbox/test_commit.py	2010-06-28 02:41:22 +0000
+++ bzrlib/tests/blackbox/test_commit.py	2010-07-14 08:53:58 +0000
@@ -22,6 +22,7 @@
 import sys
 
 from bzrlib import (
+    bzrdir,
     osutils,
     ignores,
     msgeditor,
@@ -757,3 +758,18 @@
         osutils.set_or_unset_env('BZR_EMAIL', None)
         out, err = self.run_bzr(['commit', '-m', 'initial'], 3)
         self.assertContainsRe(err, 'Unable to determine your name')
+
+    def test_commit_recursive_checkout(self):
+        """Ensure that a commit to a recursive checkout fails cleanly.
+        """
+        self.run_bzr(['init', 'test_branch'])
+        self.run_bzr(['checkout', 'test_branch', 'test_checkout'])
+        os.chdir('test_checkout')
+        self.run_bzr(['bind', '.']) # bind to self
+        open('foo.txt', 'w').write('hello')
+        self.run_bzr(['add'])
+        out, err = self.run_bzr(['commit', '-m', 'addedfoo'], 3)
+        self.assertEqual(out, '')
+        self.assertContainsRe(err,
+            'Branch.*test_checkout.*appears to be bound to itself')
+

=== modified file 'bzrlib/tests/blackbox/test_diff.py'
--- bzrlib/tests/blackbox/test_diff.py	2010-04-05 21:56:39 +0000
+++ bzrlib/tests/blackbox/test_diff.py	2010-07-18 06:54:01 +0000
@@ -155,6 +155,10 @@
         self.assertContainsRe(err,
             "Requested revision: '1.1' does not exist in branch:")
 
+    def test_diff_diff_options_and_using(self):
+        out, err = self.run_bzr('diff --diff-options -wu --using /usr/bin/diff', retcode=3,
+          error_regexes=('are mutually exclusive.',))
+
     def test_diff_unversioned(self):
         # Get an error when diffing a non-versioned file.
         # (Malone #3619)
@@ -321,7 +325,6 @@
         output = self.run_bzr('diff --format=boo', retcode=1)
         self.assertTrue("BOO!" in output[0])
 
-
 class TestCheckoutDiff(TestDiff):
 
     def make_example_branch(self):

=== modified file 'bzrlib/tests/blackbox/test_ignore.py'
--- bzrlib/tests/blackbox/test_ignore.py	2010-06-11 07:32:12 +0000
+++ bzrlib/tests/blackbox/test_ignore.py	2010-07-08 12:36:29 +0000
@@ -162,3 +162,19 @@
         tree = self.make_branch_and_tree('a')
         self.run_bzr(['ignore', '--directory=a', 'README'])
         self.check_file_contents('a/.bzrignore', 'README\n')
+
+    def test_ignored_invalid_pattern(self):
+        """Ensure graceful handling for invalid ignore pattern.
+
+        Test case for #300062.
+        Invalid pattern should show clear error message.
+        Invalid pattern should not be added to .bzrignore file.
+        """
+        tree = self.make_branch_and_tree('.')
+        out, err = self.run_bzr(['ignore', 'RE:*.cpp', 'foo', 'RE:['], 3)
+        self.assertEqual(out, '')
+        self.assertContainsRe(err,
+            'Invalid ignore pattern.*RE:\*\.cpp.*RE:\[', re.DOTALL)
+        self.assertNotContainsRe(err, 'foo', re.DOTALL)
+        self.assertFalse(os.path.isfile('.bzrignore'))
+

=== modified file 'bzrlib/tests/blackbox/test_selftest.py'
--- bzrlib/tests/blackbox/test_selftest.py	2010-04-18 08:51:37 +0000
+++ bzrlib/tests/blackbox/test_selftest.py	2010-07-18 14:28:12 +0000
@@ -17,7 +17,6 @@
 """UI tests for the test framework."""
 
 from bzrlib import (
-    benchmarks,
     tests,
     )
 from bzrlib.tests import (
@@ -46,24 +45,6 @@
             tests.selftest = original_selftest
 
 
-class TestOptionsWritingToDisk(tests.TestCaseInTempDir, SelfTestPatch):
-
-    def test_benchmark_runs_benchmark_tests(self):
-        """selftest --benchmark should change the suite factory."""
-        params = self.get_params_passed_to_core('selftest --benchmark')
-        self.assertEqual(benchmarks.test_suite,
-            params[1]['test_suite_factory'])
-        self.assertNotEqual(None, params[1]['bench_history'])
-        benchfile = open(".perf_history", "rt")
-        try:
-            lines = benchfile.readlines()
-        finally:
-            benchfile.close()
-        # Because we don't run the actual test code no output is made to the
-        # file.
-        self.assertEqual(0, len(lines))
-
-
 class TestOptions(tests.TestCase, SelfTestPatch):
 
     def test_load_list(self):

=== modified file 'bzrlib/tests/blackbox/test_status.py'
--- bzrlib/tests/blackbox/test_status.py	2010-04-07 21:34:13 +0000
+++ bzrlib/tests/blackbox/test_status.py	2010-06-24 06:57:31 +0000
@@ -704,16 +704,6 @@
 
 class TestStatusEncodings(TestCaseWithTransport):
 
-    def setUp(self):
-        TestCaseWithTransport.setUp(self)
-        self.user_encoding = osutils._cached_user_encoding
-        self.stdout = sys.stdout
-
-    def tearDown(self):
-        osutils._cached_user_encoding = self.user_encoding
-        sys.stdout = self.stdout
-        TestCaseWithTransport.tearDown(self)
-
     def make_uncommitted_tree(self):
         """Build a branch with uncommitted unicode named changes in the cwd."""
         working_tree = self.make_branch_and_tree(u'.')
@@ -727,8 +717,7 @@
         return working_tree
 
     def test_stdout_ascii(self):
-        sys.stdout = StringIO()
-        osutils._cached_user_encoding = 'ascii'
+        self.overrideAttr(osutils, '_cached_user_encoding', 'ascii')
         working_tree = self.make_uncommitted_tree()
         stdout, stderr = self.run_bzr("status")
 
@@ -738,8 +727,7 @@
 """)
 
     def test_stdout_latin1(self):
-        sys.stdout = StringIO()
-        osutils._cached_user_encoding = 'latin-1'
+        self.overrideAttr(osutils, '_cached_user_encoding', 'latin-1')
         working_tree = self.make_uncommitted_tree()
         stdout, stderr = self.run_bzr('status')
 

=== added directory 'bzrlib/tests/doc_generate'
=== added file 'bzrlib/tests/doc_generate/__init__.py'
--- bzrlib/tests/doc_generate/__init__.py	1970-01-01 00:00:00 +0000
+++ bzrlib/tests/doc_generate/__init__.py	2010-07-21 08:07:14 +0000
@@ -0,0 +1,108 @@
+# Copyright (C) 2010 Canonical Ltd
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
+
+"""Documentation generation tests."""
+
+import os
+from bzrlib import tests
+from bzrlib.doc_generate import (
+    # FIXME: doc/en/conf.py should be used here, or rather merged into
+    # bzrlib/doc_generate/conf.py -- vila 20100429
+    conf,
+    )
+from bzrlib.tests import features
+
+
+def load_tests(basic_tests, module, loader):
+    suite = loader.suiteClass()
+    # add the tests for this module
+    suite.addTests(basic_tests)
+
+    testmod_names = [
+        'builders',
+        'writers',
+        ]
+    # add the tests for the sub modules
+    suite.addTests(loader.loadTestsFromModuleNames(
+            ['bzrlib.tests.doc_generate.' + name
+             for name in testmod_names]))
+
+    return suite
+
+
+class TestSphinx(tests.TestCaseInTempDir):
+    """Base class for sphinx tests.
+
+    This is used for both the builder and the writer until a better solution is
+    found to test at a lower level.
+    """
+
+    _test_needs_features = [features.sphinx]
+
+    def make_sphinx(self):
+        out = tests.StringIOWrapper()
+        err = tests.StringIOWrapper()
+        from sphinx import application
+        app = application.Sphinx(
+            '.', confdir=os.path.dirname(conf.__file__), outdir='.',
+            doctreedir='.',
+            buildername='texinfo',
+            confoverrides={},
+            status=out, warning=err,
+            freshenv=True)
+        return app, out, err
+
+    def build(self, app, all_files=True, file_names=None):
+        if file_names is None:
+            file_names = []
+        app.build(all_files, file_names)
+
+    # FIXME: something smells wrong here as we can't process a single file
+    # alone. On top of that, it seems the doc tree must contain an index.txt
+    # file. We may need a texinfo builder ? -- vila 20100505
+
+    def create_content(self, content):
+        """Put content into a single file.
+
+        This is appropriate for simple tests about the content of a single file.
+        """
+        app, out, err = self.make_sphinx()
+        self.build_tree_contents([('index.txt', content),])
+        self.build(app)
+
+    def assertContent(self, expected, header=None, end=None):
+        """Check the content of the file created with creste_content().
+
+        Most texinfo constructs can be tested this way without caring for any
+        boilerplate that texinfo may require at the beginning or the end of the
+        file.
+        """
+        if header is None:
+            # default boilerplate
+            header = '''\
+This file has been converted using a beta rst->texinfo converter. 
+Most of the info links are currently bogus, don't report bugs about them,
+this is currently worked on.
+@node Top
+@top Placeholder
+'''
+        if end is None:
+            # By default we test constructs that are embedded into a paragraph
+            # which always end with two \n (even if the input has none)
+            end = '\n\n'
+        self.assertFileEqual(header + expected + end, 'index.texi')
+
+

=== added directory 'bzrlib/tests/doc_generate/builders'
=== added file 'bzrlib/tests/doc_generate/builders/__init__.py'
--- bzrlib/tests/doc_generate/builders/__init__.py	1970-01-01 00:00:00 +0000
+++ bzrlib/tests/doc_generate/builders/__init__.py	2010-04-29 16:10:59 +0000
@@ -0,0 +1,36 @@
+# Copyright (C) 2010 Canonical Ltd
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
+
+
+"""Sphinx builders tests."""
+
+from bzrlib.tests import features
+
+def load_tests(basic_tests, module, loader):
+    suite = loader.suiteClass()
+    # add the tests for this module
+    suite.addTests(basic_tests)
+
+    if features.sphinx.available():
+        testmod_names = [
+            'texinfo',
+            ]
+        # add the tests for the sub modules
+        suite.addTests(loader.loadTestsFromModuleNames(
+                ['bzrlib.tests.doc_generate.builders.test_' + name
+                 for name in testmod_names]))
+
+    return suite

=== added file 'bzrlib/tests/doc_generate/builders/test_texinfo.py'
--- bzrlib/tests/doc_generate/builders/test_texinfo.py	1970-01-01 00:00:00 +0000
+++ bzrlib/tests/doc_generate/builders/test_texinfo.py	2010-07-06 13:22:32 +0000
@@ -0,0 +1,71 @@
+# Copyright (C) 2010 Canonical Ltd
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
+
+"""sphinx texinfo builder tests."""
+
+from bzrlib import tests
+from bzrlib.doc_generate import (
+    # FIXME: doc/en/conf.py should be used here, or rather merged into
+    # bzrlib/doc_generate/conf.py -- vila 20100429
+    conf,
+    )
+from bzrlib.tests import (
+    doc_generate as test_dg, # Avoid clash with from bzrlib import doc_generate
+    )
+
+
+class TestBuilderDefined(tests.TestCase):
+
+    def test_builder_defined(self):
+        self.assertTrue('bzrlib.doc_generate.builders.texinfo'
+                        in conf.extensions)
+
+class TestBuilderLoaded(test_dg.TestSphinx):
+
+    def test_builder_loaded(self):
+        app, out, err = self.make_sphinx()
+        self.assertTrue('texinfo' in app.builderclasses)
+
+
+class TestFileProduction(test_dg.TestSphinx):
+
+    def test_files_generated(self):
+        self.build_tree_contents(
+            [('index.txt', """
+Table of Contents
+=================
+
+.. toctree::
+   :maxdepth: 1
+
+   content
+"""),
+             ('content.txt', """
+
+bzr 0.0.8
+*********
+
+Improvements
+============
+
+* Adding a file whose parent directory is not versioned will
+  implicitly add the parent, and so on up to the root.
+"""),
+             ])
+        app, out, err = self.make_sphinx()
+        self.build(app)
+        self.failUnlessExists('index.texi')
+        self.failUnlessExists('content.texi')

=== added directory 'bzrlib/tests/doc_generate/writers'
=== added file 'bzrlib/tests/doc_generate/writers/__init__.py'
--- bzrlib/tests/doc_generate/writers/__init__.py	1970-01-01 00:00:00 +0000
+++ bzrlib/tests/doc_generate/writers/__init__.py	2010-07-06 13:22:32 +0000
@@ -0,0 +1,36 @@
+# Copyright (C) 2010 Canonical Ltd
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
+
+
+"""Sphinx writers tests."""
+
+from bzrlib.tests import features
+
+def load_tests(basic_tests, module, loader):
+    suite = loader.suiteClass()
+    # add the tests for this module
+    suite.addTests(basic_tests)
+
+    if features.sphinx.available():
+        testmod_names = [
+            'texinfo',
+            ]
+        # add the tests for the sub modules
+        suite.addTests(loader.loadTestsFromModuleNames(
+                ['bzrlib.tests.doc_generate.writers.test_' + name
+                 for name in testmod_names]))
+
+    return suite

=== added file 'bzrlib/tests/doc_generate/writers/test_texinfo.py'
--- bzrlib/tests/doc_generate/writers/test_texinfo.py	1970-01-01 00:00:00 +0000
+++ bzrlib/tests/doc_generate/writers/test_texinfo.py	2010-07-21 08:07:14 +0000
@@ -0,0 +1,335 @@
+# Copyright (C) 2010 Canonical Ltd
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
+
+"""sphinx texinfo writer tests."""
+
+from bzrlib.tests import (
+    doc_generate as test_dg, # Avoid clash with from bzrlib import doc_generate
+    )
+
+
+class TestTextGeneration(test_dg.TestSphinx):
+
+    def test_special_chars(self):
+        self.create_content("A '@' a '{' and a '}'")
+        self.assertContent("A '@@' a '@{' and a '@}'")
+
+    def test_emphasis(self):
+        self.create_content('*important*')
+        self.assertContent('@emph{important}')
+
+    def test_strong(self):
+        self.create_content('**very important**')
+        self.assertContent('@strong{very important}')
+
+    def test_literal(self):
+        self.create_content('the command is ``foo``')
+        self.assertContent('the command is @code{foo}')
+
+    def test_paragraphs(self):
+        self.create_content('''\
+This is a paragraph.
+
+This is another one.
+''')
+        self.assertContent('''\
+This is a paragraph.
+
+This is another one.''')
+
+    def test_literal_block(self):
+        self.create_content('''\
+Do this::
+
+   bzr xxx
+   bzr yyy
+''')
+        self.assertContent('''\
+Do this:
+
+@samp{bzr xxx
+bzr yyy}
+
+''',
+                           end='')
+
+    def test_block_quote(self):
+        self.create_content('''\
+This is an ordinary paragraph, introducing a block quote.
+
+    "It is my business to know things.  That is my trade."
+
+This is another ordinary paragraph.
+''')
+        self.assertContent('''\
+This is an ordinary paragraph, introducing a block quote.
+
+@example
+"It is my business to know things.  That is my trade."
+
+@end example
+
+This is another ordinary paragraph.
+
+''',
+                           # examples are not followed by an empty line
+                           end='')
+
+
+class TestDocumentAttributesGeneration(test_dg.TestSphinx):
+
+    def test_title(self):
+        self.create_content('''\
+####################
+Bazaar Release Notes
+####################
+''')
+        self.assertContent('''\
+@node bazaar-release-notes
+@chapter Bazaar Release Notes
+''',
+                           end='')
+
+
+class TestListGeneration(test_dg.TestSphinx):
+
+    def test_bullet_list(self):
+        self.create_content('''\
+* This is a bulleted list.
+* It has two items, the second
+  item uses two lines.
+''')
+        self.assertContent('''\
+@itemize @bullet
+@item
+This is a bulleted list.
+
+@item
+It has two items, the second
+item uses two lines.
+
+@end itemize
+''',
+                           end='')
+
+    def test_enumerated_list(self):
+        self.create_content('''\
+#. This is a numbered list.
+#. It has two items, the second
+   item uses two lines.
+''')
+        self.assertContent('''\
+@enumerate
+@item
+This is a numbered list.
+
+@item
+It has two items, the second
+item uses two lines.
+
+@end enumerate
+''',
+                           end='')
+
+
+class TestTableGeneration(test_dg.TestSphinx):
+
+    def test_table(self):
+        self.create_content('''\
+  ===========         ================
+  Prefix              Description
+  ===========         ================
+  first               The first
+  second              The second
+  last                The last
+  ===========         ================
+''')
+        # FIXME: Sphinx bug ? Why are tables enclosed in a block_quote
+        # (translated as an @example).
+        self.assertContent('''\
+@example
+@multitable {xxxxxxxxxxx}{xxxxxxxxxxxxxxxx}
+@headitem Prefix @tab Description
+@item first
+@tab The first
+@item second
+@tab The second
+@item last
+@tab The last
+@end multitable
+@end example''')
+
+
+class TestTocTreeGeneration(test_dg.TestSphinx):
+
+    def test_toctree(self):
+        self.build_tree_contents(
+            [('index.txt', """
+Table of Contents
+=================
+
+.. toctree::
+   :maxdepth: 1
+
+   bzr 0.0.8 <bzr-0.0.8>
+"""),
+             ('bzr-0.0.8.txt', """
+
+bzr 0.0.8
+*********
+
+Improvements
+============
+
+* Adding a file whose parent directory is not versioned will
+  implicitly add the parent, and so on up to the root.
+"""),
+             ])
+        app, out, err = self.make_sphinx()
+        self.build(app)
+        self.assertFileEqual("""\
+This file has been converted using a beta rst->texinfo converter. 
+Most of the info links are currently bogus, don't report bugs about them,
+this is currently worked on.
+@node Top
+@top Placeholder
+@node table-of-contents
+@chapter Table of Contents
+@menu
+* bzr 0.0.8: (bzr-0.0.8.info)bzr 0.0.8. 
+@end menu
+""",
+                             'index.texi')
+        self.assertFileEqual("""\
+This file has been converted using a beta rst->texinfo converter. 
+Most of the info links are currently bogus, don't report bugs about them,
+this is currently worked on.
+@node Top
+@top Placeholder
+@node bzr-0-0-8
+@chapter bzr 0.0.8
+@node improvements
+@section Improvements
+@itemize @bullet
+@item
+Adding a file whose parent directory is not versioned will
+implicitly add the parent, and so on up to the root.
+
+@end itemize
+""",
+                             'bzr-0.0.8.texi')
+
+class TestSections(test_dg.TestSphinx):
+
+    def test_sections(self):
+        self.create_content('''\
+###########
+Chapter one
+###########
+
+Chapter introduction.
+
+***********
+section one
+***********
+
+The first section.
+
+
+subsection one
+==============
+
+The first subsection.
+
+subsection two
+==============
+
+The second subsection.
+
+subsubsection one
+-----------------
+
+Here is sus sub section one.
+
+blob one
+^^^^^^^^
+
+Far tooo deep to get a name
+
+thing one
+"""""""""
+
+No idea how to call that, but sphinx says it's a paragraph.
+''')
+        self.assertContent('''\
+@node chapter-one
+@chapter Chapter one
+Chapter introduction.
+
+@node section-one
+@section section one
+The first section.
+
+@node subsection-one
+@subsection subsection one
+The first subsection.
+
+@node subsection-two
+@subsection subsection two
+The second subsection.
+
+@node subsubsection-one
+@subsubsection subsubsection one
+Here is sus sub section one.
+
+@node blob-one
+@heading blob one
+Far tooo deep to get a name
+
+@node thing-one
+@heading thing one
+No idea how to call that, but sphinx says it's a paragraph.''')
+
+
+class TestReferences(test_dg.TestSphinx):
+
+    def test_external_reference(self):
+        self.create_content('''\
+The `example web site`_ is nice.
+
+.. _example web site: http://www.example.com/
+''')
+        self.assertContent('''\
+The @uref{http://www.example.com/,example web site} is nice.''')
+
+
+    def test_internal_reference(self):
+        self.create_content('''\
+The `example web site`_ contains more examples.
+
+Example web site
+----------------
+
+Here we have a lot of nice examples.
+
+''')
+        self.assertContent('''\
+The example web site (@pxref{example-web-site}) contains more examples.
+
+@node example-web-site
+@chapter Example web site
+Here we have a lot of nice examples.''')
+

=== modified file 'bzrlib/tests/features.py'
--- bzrlib/tests/features.py	2010-05-25 21:30:52 +0000
+++ bzrlib/tests/features.py	2010-07-05 12:40:28 +0000
@@ -28,6 +28,7 @@
 pycurl = tests.ModuleAvailableFeature('pycurl')
 pywintypes = tests.ModuleAvailableFeature('pywintypes')
 subunit = tests.ModuleAvailableFeature('subunit')
+sphinx = tests.ModuleAvailableFeature('sphinx')
 
 
 class _BackslashDirSeparatorFeature(tests.Feature):

=== modified file 'bzrlib/tests/http_server.py'
--- bzrlib/tests/http_server.py	2010-02-23 07:43:11 +0000
+++ bzrlib/tests/http_server.py	2010-07-29 11:17:57 +0000
@@ -89,6 +89,41 @@
                                      errno.ECONNABORTED, errno.EBADF)):
                 raise
 
+    error_content_type = 'text/plain'
+    error_message_format = '''\
+Error code: %(code)s.
+Message: %(message)s.
+'''
+
+    def send_error(self, code, message=None):
+        """Send and log an error reply.
+
+        We redefine the python-provided version to be able to set a 
+        ``Content-Length`` header as some http/1.1 clients complain otherwise
+        (see bug #568421).
+
+        :param code: The HTTP error code.
+
+        :param message: The explanation of the error code, Defaults to a short
+             entry.
+        """
+
+        if message is None:
+            try:
+                message = self.responses[code][0]
+            except KeyError:
+                message = '???'
+        self.log_error("code %d, message %s", code, message)
+        content = (self.error_message_format %
+                   {'code': code, 'message': message})
+        self.send_response(code, message)
+        self.send_header("Content-Type", self.error_content_type)
+        self.send_header("Content-Length", "%d" % len(content))
+        self.send_header('Connection', 'close')
+        self.end_headers()
+        if self.command != 'HEAD' and code >= 200 and code not in (204, 304):
+            self.wfile.write(content)
+
     _range_regexp = re.compile(r'^(?P<start>\d+)-(?P<end>\d+)$')
     _tail_regexp = re.compile(r'^-(?P<tail>\d+)$')
 

=== modified file 'bzrlib/tests/per_transport.py'
--- bzrlib/tests/per_transport.py	2010-03-05 05:30:19 +0000
+++ bzrlib/tests/per_transport.py	2010-07-19 11:06:36 +0000
@@ -1122,7 +1122,8 @@
             self.failUnless(t.has(link_name))
 
             st = t.stat(link_name)
-            self.failUnless(S_ISLNK(st.st_mode))
+            self.failUnless(S_ISLNK(st.st_mode),
+                "expected symlink, got mode %o" % st.st_mode)
         except TransportNotPossible:
             raise TestSkipped("Transport %s does not support symlinks." %
                               self._server.__class__)
@@ -1765,3 +1766,15 @@
         # also raise a special error
         self.assertListRaises((errors.ShortReadvError, errors.InvalidRange),
                               transport.readv, 'a', [(12,2)])
+
+    def test_stat_symlink(self):
+        # if a transport points directly to a symlink (and supports symlinks
+        # at all) you can tell this.  helps with bug 32669.
+        t = self.get_transport()
+        try:
+            t.symlink('target', 'link')
+        except TransportNotPossible:
+            raise TestSkipped("symlinks not supported")
+        t2 = t.clone('link')
+        st = t2.stat('')
+        self.assertTrue(stat.S_ISLNK(st.st_mode))

=== modified file 'bzrlib/tests/per_workingtree/__init__.py'
--- bzrlib/tests/per_workingtree/__init__.py	2010-04-01 12:53:53 +0000
+++ bzrlib/tests/per_workingtree/__init__.py	2010-07-29 11:17:57 +0000
@@ -101,6 +101,7 @@
         'revision_tree',
         'set_root_id',
         'smart_add',
+        'symlinks',
         'uncommit',
         'unversion',
         'views',

=== modified file 'bzrlib/tests/per_workingtree/test_is_ignored.py'
--- bzrlib/tests/per_workingtree/test_is_ignored.py	2010-02-17 17:11:16 +0000
+++ bzrlib/tests/per_workingtree/test_is_ignored.py	2010-07-08 13:00:19 +0000
@@ -22,6 +22,16 @@
 
 class TestIsIgnored(TestCaseWithWorkingTree):
 
+    def _set_user_ignore_content(self, ignores):
+        """Create user ignore file and set its content to ignores."""
+        config.ensure_config_dir_exists()
+        user_ignore_file = config.user_ignore_config_filename()
+        f = open(user_ignore_file, 'wb')
+        try:
+            f.write(ignores)
+        finally:
+            f.close()
+
     def test_is_ignored(self):
         tree = self.make_branch_and_tree('.')
         # this will break if a tree changes the ignored format. That is fine
@@ -46,6 +56,11 @@
                            '#comment\n'
                            ' xx \n' # whitespace
             )])
+        # We set user ignore file to contain '' to avoid patterns from
+        # user ignore being used instead of bzrignore. For .e.g. If we
+        # don't do this 'foo.~1~' will match '*~' default user ignore
+        # pattern instead of '*.~*' from bzr ignore as we expect below.
+        self._set_user_ignore_content('')
         # is_ignored returns the matching ignore regex when a path is ignored.
         # we check some expected matches for each rule, and one or more
         # relevant not-matches that look plausible as cases for bugs.
@@ -119,19 +134,16 @@
 
         config.ensure_config_dir_exists()
         user_ignore_file = config.user_ignore_config_filename()
-        f = open(user_ignore_file, 'wb')
-        try:
-            f.write('*.py[co]\n'
-                    './.shelf\n'
-                    '# comment line\n'
-                    '\n' #Blank line
-                    '\r\n' #Blank dos line
-                    ' * \n' #Trailing and suffix spaces
-                    'crlf\r\n' # dos style line
-                    '*\xc3\xa5*\n' # u'\xe5'.encode('utf8')
-                    )
-        finally:
-            f.close()
+        self._set_user_ignore_content(
+            '*.py[co]\n'
+            './.shelf\n'
+            '# comment line\n'
+            '\n' #Blank line
+            '\r\n' #Blank dos line
+            ' * \n' #Trailing and suffix spaces
+            'crlf\r\n' # dos style line
+            '*\xc3\xa5*\n' # u'\xe5'.encode('utf8')
+            )
 
         # Rooted
         self.assertEqual('./.shelf', tree.is_ignored('.shelf'))

=== modified file 'bzrlib/tests/per_workingtree/test_move.py'
--- bzrlib/tests/per_workingtree/test_move.py	2009-07-10 07:14:02 +0000
+++ bzrlib/tests/per_workingtree/test_move.py	2010-07-15 13:33:30 +0000
@@ -79,43 +79,6 @@
             tree.move(['a1'], 'sub1', after=False))
         tree._validate()
 
-    def test_move_deprecated_wrong_call(self):
-        """tree.move has the deprecated parameter 'to_name'.
-        It has been replaced by 'to_dir' for consistency.
-        Test the new API using wrong parameter
-        """
-        self.build_tree(['a1', 'sub1/'])
-        tree = self.make_branch_and_tree('.')
-        tree.add(['a1', 'sub1'])
-        tree.commit('initial commit')
-        self.assertRaises(TypeError, tree.move, ['a1'],
-                          to_this_parameter_does_not_exist='sub1',
-                          after=False)
-        tree._validate()
-
-    def test_move_deprecated_call(self):
-        """tree.move has the deprecated parameter 'to_name'.
-        It has been replaced by 'to_dir' for consistency.
-        Test the new API using deprecated parameter
-        """
-        self.build_tree(['a1', 'sub1/'])
-        tree = self.make_branch_and_tree('.')
-        tree.add(['a1', 'sub1'])
-        tree.commit('initial commit')
-
-        try:
-            self.callDeprecated(['The parameter to_name was deprecated'
-                                 ' in version 0.13. Use to_dir instead'],
-                                tree.move, ['a1'], to_name='sub1',
-                                after=False)
-        except TypeError:
-            # WorkingTreeFormat4 and later don't have to maintain api
-            # compatibility since it was deprecated before they were introduced.
-            if not isinstance(self.workingtree_format,
-                DirStateWorkingTreeFormat):
-                raise
-        tree._validate()
-
     def test_move_target_not_dir(self):
         tree = self.make_branch_and_tree('.')
         self.build_tree(['a'])

=== added file 'bzrlib/tests/per_workingtree/test_symlinks.py'
--- bzrlib/tests/per_workingtree/test_symlinks.py	1970-01-01 00:00:00 +0000
+++ bzrlib/tests/per_workingtree/test_symlinks.py	2010-07-16 15:49:06 +0000
@@ -0,0 +1,98 @@
+# Copyright (C) 2010 Canonical Ltd
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
+
+"""Test symlink support.
+
+See eg <https://bugs.launchpad.net/bzr/+bug/192859>
+"""
+
+from bzrlib import (
+    builtins,
+    tests,
+    workingtree,
+    )
+from bzrlib.tests.per_workingtree import TestCaseWithWorkingTree
+
+
+class TestSmartAddTree(TestCaseWithWorkingTree):
+
+    _test_needs_features = [tests.SymlinkFeature]
+
+    def test_smart_add_symlink(self):
+        tree = self.make_branch_and_tree('tree')
+        self.build_tree_contents([
+            ('tree/link@', 'target'),
+            ])
+        tree.smart_add(['tree/link'])
+        self.assertIsNot(None, tree.path2id('link'))
+        self.assertIs(None, tree.path2id('target'))
+        self.assertEqual('symlink',
+            tree.kind(tree.path2id('link')))
+
+    def test_smart_add_symlink_pointing_outside(self):
+        tree = self.make_branch_and_tree('tree')
+        self.build_tree_contents([
+            ('tree/link@', '../../../../target'),
+            ])
+        tree.smart_add(['tree/link'])
+        self.assertIsNot(None, tree.path2id('link'))
+        self.assertIs(None, tree.path2id('target'))
+        self.assertEqual('symlink',
+            tree.kind(tree.path2id('link')))
+
+    def test_open_containing_through_symlink(self):
+        self.make_test_tree()
+        self.check_open_containing('link/content', 'tree', 'content')
+        self.check_open_containing('link/sublink', 'tree', 'sublink')
+        # this next one is a bit debatable, but arguably it's better that
+        # open_containing is only concerned with opening the tree 
+        # and then you can deal with symlinks along the way if you want
+        self.check_open_containing('link/sublink/subcontent', 'tree',
+            'sublink/subcontent')
+
+    def check_open_containing(self, to_open, expected_tree_name,
+        expected_relpath):
+        wt, relpath = workingtree.WorkingTree.open_containing(to_open)
+        self.assertEquals(relpath, expected_relpath)
+        self.assertEndsWith(wt.basedir, expected_tree_name)
+
+    def test_tree_files(self):
+        # not strictly a WorkingTree method, but it should be
+        # probably the root cause for
+        # <https://bugs.launchpad.net/bzr/+bug/128562>
+        self.make_test_tree()
+        self.check_tree_files(['tree/outerlink'],
+            'tree', ['outerlink'])
+        self.check_tree_files(['link/outerlink'],
+            'tree', ['outerlink'])
+        self.check_tree_files(['link/sublink/subcontent'],
+            'tree', ['subdir/subcontent'])
+
+    def check_tree_files(self, to_open, expected_tree, expect_paths):
+        tree, relpaths = workingtree.WorkingTree.open_containing_paths(to_open)
+        self.assertEndsWith(tree.basedir, expected_tree)
+        self.assertEquals(expect_paths, relpaths)
+
+    def make_test_tree(self):
+        tree = self.make_branch_and_tree('tree')
+        self.build_tree_contents([
+            ('link@', 'tree'),
+            ('tree/outerlink@', '/not/there'),
+            ('tree/content', 'hello'),
+            ('tree/sublink@', 'subdir'),
+            ('tree/subdir/',),
+            ('tree/subdir/subcontent', 'subcontent stuff')
+            ])

=== modified file 'bzrlib/tests/test__simple_set.py'
--- bzrlib/tests/test__simple_set.py	2010-02-17 17:11:16 +0000
+++ bzrlib/tests/test__simple_set.py	2010-08-02 19:20:30 +0000
@@ -379,3 +379,13 @@
         # And even removing an item still causes it to fail
         obj.discard(k2)
         self.assertRaises(RuntimeError, iterator.next)
+
+    def test__sizeof__(self):
+        # SimpleSet needs a custom sizeof implementation, because it allocates
+        # memory that Python cannot directly see (_table).
+        # Too much variability in platform sizes for us to give a fixed size
+        # here. However without a custom implementation, __sizeof__ would give
+        # us only the size of the object, and not its table. We know the table
+        # is at least 4bytes*1024entries in size.
+        obj = self.module.SimpleSet()
+        self.assertTrue(obj.__sizeof__() > 4096)

=== modified file 'bzrlib/tests/test_bundle.py'
--- bzrlib/tests/test_bundle.py	2010-02-23 07:43:11 +0000
+++ bzrlib/tests/test_bundle.py	2010-08-05 04:21:03 +0000
@@ -114,12 +114,12 @@
             ie = InventoryDirectory(file_id, name, parent_id)
         elif kind == 'file':
             ie = InventoryFile(file_id, name, parent_id)
+            ie.text_sha1 = text_sha_1
+            ie.text_size = text_size
         elif kind == 'symlink':
             ie = InventoryLink(file_id, name, parent_id)
         else:
             raise errors.BzrError('unknown kind %r' % kind)
-        ie.text_sha1 = text_sha_1
-        ie.text_size = text_size
         return ie
 
     def add_dir(self, file_id, path):

=== modified file 'bzrlib/tests/test_chk_map.py'
--- bzrlib/tests/test_chk_map.py	2010-02-23 07:43:11 +0000
+++ bzrlib/tests/test_chk_map.py	2010-07-21 09:58:42 +0000
@@ -467,6 +467,25 @@
         # updated key.
         self.assertEqual(new_root, chkmap._root_node._key)
 
+    def test_apply_delete_to_internal_node(self):
+        # applying a delta should be convert an internal root node to a leaf
+        # node if the delta shrinks the map enough.
+        store = self.get_chk_bytes()
+        chkmap = CHKMap(store, None)
+        # Add three items: 2 small enough to fit in one node, and one huge to
+        # force multiple nodes.
+        chkmap._root_node.set_maximum_size(100)
+        chkmap.map(('small',), 'value')
+        chkmap.map(('little',), 'value')
+        chkmap.map(('very-big',), 'x' * 100)
+        # (Check that we have constructed the scenario we want to test)
+        self.assertIsInstance(chkmap._root_node, InternalNode)
+        # Delete the huge item so that the map fits in one node again.
+        delta = [(('very-big',), None, None)]
+        chkmap.apply_delta(delta)
+        self.assertCanonicalForm(chkmap)
+        self.assertIsInstance(chkmap._root_node, LeafNode)
+
     def test_apply_new_keys_must_be_new(self):
         # applying a delta (None, "a", "b") to a map with 'a' in it generates
         # an error.

=== modified file 'bzrlib/tests/test_config.py'
--- bzrlib/tests/test_config.py	2010-04-23 07:15:23 +0000
+++ bzrlib/tests/test_config.py	2010-07-21 03:07:02 +0000
@@ -35,6 +35,7 @@
     trace,
     transport,
     )
+from bzrlib.tests import features
 from bzrlib.util.configobj import configobj
 
 
@@ -367,7 +368,7 @@
             '/home/bogus/.cache')
 
 
-class TestIniConfig(tests.TestCase):
+class TestIniConfig(tests.TestCaseInTempDir):
 
     def make_config_parser(self, s):
         conf = config.IniBasedConfig(None)
@@ -393,6 +394,22 @@
         parser = my_config._get_parser(file=config_file)
         self.failUnless(my_config._get_parser() is parser)
 
+    def _dummy_chown(self, path, uid, gid):
+        self.path, self.uid, self.gid = path, uid, gid
+
+    def test_ini_config_ownership(self):
+        """Ensure that chown is happening during _write_config_file.
+        """
+        self.requireFeature(features.chown_feature)
+        self.overrideAttr(os, 'chown', self._dummy_chown)
+        self.path = self.uid = self.gid = None
+        def get_filename():
+            return 'foo.conf'
+        conf = config.IniBasedConfig(get_filename)
+        conf._write_config_file()
+        self.assertEquals(self.path, 'foo.conf')
+        self.assertTrue(isinstance(self.uid, int))
+        self.assertTrue(isinstance(self.gid, int))
 
 class TestGetUserOptionAs(TestIniConfig):
 

=== modified file 'bzrlib/tests/test_errors.py'
--- bzrlib/tests/test_errors.py	2010-07-09 16:16:11 +0000
+++ bzrlib/tests/test_errors.py	2010-07-14 14:22:40 +0000
@@ -16,6 +16,8 @@
 
 """Tests for the formatting and construction of errors."""
 
+import inspect
+import re
 import socket
 import sys
 
@@ -26,11 +28,36 @@
     symbol_versioning,
     urlutils,
     )
-from bzrlib.tests import TestCase, TestCaseWithTransport
+from bzrlib.tests import TestCase, TestCaseWithTransport, TestSkipped
 
 
 class TestErrors(TestCaseWithTransport):
 
+    def test_no_arg_named_message(self):
+        """Ensure the __init__ and _fmt in errors do not have "message" arg.
+
+        This test fails if __init__ or _fmt in errors has an argument
+        named "message" as this can cause errors in some Python versions.
+        Python 2.5 uses a slot for StandardError.message.
+        See bug #603461
+        """
+        fmt_pattern = re.compile("%\(message\)[sir]")
+        subclasses_present = getattr(errors.BzrError, '__subclasses__', None)
+        if not subclasses_present:
+            raise TestSkipped('__subclasses__ attribute required for classes. '
+                'Requires Python 2.5 or later.')
+        for c in errors.BzrError.__subclasses__():
+            init = getattr(c, '__init__', None)
+            fmt = getattr(c, '_fmt', None)
+            if init:
+                args = inspect.getargspec(init)[0]
+                self.assertFalse('message' in args,
+                    ('Argument name "message" not allowed for '
+                    '"errors.%s.__init__"' % c.__name__))
+            if fmt and fmt_pattern.search(fmt):
+                self.assertFalse(True, ('"message" not allowed in '
+                    '"errors.%s._fmt"' % c.__name__))
+
     def test_bad_filename_encoding(self):
         error = errors.BadFilenameEncoding('bad/filen\xe5me', 'UTF-8')
         self.assertEqualDiff(
@@ -660,6 +687,12 @@
         self.assertEqualDiff("Invalid pattern(s) found. Bad pattern msg.",
             str(error))
 
+    def test_recursive_bind(self):
+        error = errors.RecursiveBind('foo_bar_branch')
+        msg = ('Branch "foo_bar_branch" appears to be bound to itself. '
+            'Please use `bzr unbind` to fix.')
+        self.assertEqualDiff(msg, str(error))
+
 
 class PassThroughError(errors.BzrError):
 

=== modified file 'bzrlib/tests/test_globbing.py'
--- bzrlib/tests/test_globbing.py	2010-07-09 16:16:11 +0000
+++ bzrlib/tests/test_globbing.py	2010-08-07 16:42:09 +0000
@@ -15,6 +15,8 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
 
+import re
+
 from bzrlib import errors
 from bzrlib.globbing import (
     Globster,
@@ -53,14 +55,16 @@
     def test_char_group_digit(self):
         self.assertMatchBasenameAndFullpath([
             # The definition of digit this uses includes arabic digits from
-            # non-latin scripts (arabic, indic, etc.) and subscript/superscript
-            # digits, but neither roman numerals nor vulgar fractions.
+            # non-latin scripts (arabic, indic, etc.) but neither roman
+            # numerals nor vulgar fractions. Some characters such as
+            # subscript/superscript digits may or may not match depending on
+            # the Python version used, see: <http://bugs.python.org/issue6561>
             (u'[[:digit:]]',
-             [u'0', u'5', u'\u0663', u'\u06f9', u'\u0f21', u'\xb9'],
+             [u'0', u'5', u'\u0663', u'\u06f9', u'\u0f21'],
              [u'T', u'q', u' ', u'\u8336', u'.']),
             (u'[^[:digit:]]',
              [u'T', u'q', u' ', u'\u8336', u'.'],
-             [u'0', u'5', u'\u0663', u'\u06f9', u'\u0f21', u'\xb9']),
+             [u'0', u'5', u'\u0663', u'\u06f9', u'\u0f21']),
             ])
 
     def test_char_group_space(self):
@@ -311,10 +315,11 @@
 
     def test_bad_pattern(self):
         """Ensure that globster handles bad patterns cleanly."""
-        patterns = [u'RE:[']
+        patterns = [u'RE:[', u'/home/foo', u'RE:*.cpp']
         g = Globster(patterns)
-        e = self.assertRaises(errors.InvalidPattern, g.match, 'foo')
-        self.assertContainsRe(e.msg, "File.*ignore.*contains errors")
+        e = self.assertRaises(errors.InvalidPattern, g.match, 'filename')
+        self.assertContainsRe(e.msg,
+            "File.*ignore.*contains error.*RE:\[.*RE:\*\.cpp", flags=re.DOTALL)
 
 
 class TestExceptionGlobster(TestCase):

=== modified file 'bzrlib/tests/test_groupcompress.py'
--- bzrlib/tests/test_groupcompress.py	2010-02-17 17:11:16 +0000
+++ bzrlib/tests/test_groupcompress.py	2010-08-05 16:27:35 +0000
@@ -1066,3 +1066,25 @@
         # consumption
         self.add_key_to_manager(('key4',), locations, block, manager)
         self.assertTrue(manager.check_is_well_utilized())
+
+
+class Test_GCBuildDetails(tests.TestCase):
+
+    def test_acts_like_tuple(self):
+        # _GCBuildDetails inlines some of the data that used to be spread out
+        # across a bunch of tuples
+        bd = groupcompress._GCBuildDetails((('parent1',), ('parent2',)),
+            ('INDEX', 10, 20, 0, 5))
+        self.assertEqual(4, len(bd))
+        self.assertEqual(('INDEX', 10, 20, 0, 5), bd[0])
+        self.assertEqual(None, bd[1]) # Compression Parent is always None
+        self.assertEqual((('parent1',), ('parent2',)), bd[2])
+        self.assertEqual(('group', None), bd[3]) # Record details
+
+    def test__repr__(self):
+        bd = groupcompress._GCBuildDetails((('parent1',), ('parent2',)),
+            ('INDEX', 10, 20, 0, 5))
+        self.assertEqual("_GCBuildDetails(('INDEX', 10, 20, 0, 5),"
+                         " (('parent1',), ('parent2',)))",
+                         repr(bd))
+                    

=== modified file 'bzrlib/tests/test_http.py'
--- bzrlib/tests/test_http.py	2010-06-11 10:59:23 +0000
+++ bzrlib/tests/test_http.py	2010-07-15 12:53:44 +0000
@@ -44,9 +44,6 @@
     ui,
     urlutils,
     )
-from bzrlib.symbol_versioning import (
-    deprecated_in,
-    )
 from bzrlib.tests import (
     features,
     http_server,
@@ -1125,10 +1122,7 @@
     def setUp(self):
         tests.TestCase.setUp(self)
         self._old_env = {}
-
-    def tearDown(self):
-        self._restore_env()
-        tests.TestCase.tearDown(self)
+        self.addCleanup(self._restore_env)
 
     def _install_env(self, env):
         for name, value in env.iteritems():
@@ -1342,14 +1336,6 @@
         t = self._transport(self.new_server.get_url())
         self.assertEqual('0123456789', t.get('a').read())
 
-    def test_read_redirected_bundle_from_url(self):
-        from bzrlib.bundle import read_bundle_from_url
-        url = self.old_transport.abspath('bundle')
-        bundle = self.applyDeprecated(deprecated_in((1, 12, 0)),
-                read_bundle_from_url, url)
-        # If read_bundle_from_url was successful we get an empty bundle
-        self.assertEqual([], bundle.revisions)
-
 
 class RedirectedRequest(_urllib2_wrappers.Request):
     """Request following redirections. """
@@ -1974,13 +1960,8 @@
         # We override at class level because constructors may propagate the
         # bound method and render instance overriding ineffective (an
         # alternative would be to define a specific ui factory instead...)
-        self.orig_report_activity = self._transport._report_activity
-        self._transport._report_activity = report_activity
-
-    def tearDown(self):
-        self._transport._report_activity = self.orig_report_activity
-        self.server.stop_server()
-        tests.TestCase.tearDown(self)
+        self.overrideAttr(self._transport, '_report_activity', report_activity)
+        self.addCleanup(self.server.stop_server)
 
     def get_transport(self):
         return self._transport(self.server.get_url())
@@ -2103,51 +2084,22 @@
 class TestActivity(tests.TestCase, TestActivityMixin):
 
     def setUp(self):
-        tests.TestCase.setUp(self)
-        self.server = self._activity_server(self._protocol_version)
-        self.server.start_server()
-        self.activities = {}
-        def report_activity(t, bytes, direction):
-            count = self.activities.get(direction, 0)
-            count += bytes
-            self.activities[direction] = count
-
-        # We override at class level because constructors may propagate the
-        # bound method and render instance overriding ineffective (an
-        # alternative would be to define a specific ui factory instead...)
-        self.orig_report_activity = self._transport._report_activity
-        self._transport._report_activity = report_activity
-
-    def tearDown(self):
-        self._transport._report_activity = self.orig_report_activity
-        self.server.stop_server()
-        tests.TestCase.tearDown(self)
+        TestActivityMixin.setUp(self)
 
 
 class TestNoReportActivity(tests.TestCase, TestActivityMixin):
 
+    # Unlike TestActivity, we are really testing ReportingFileSocket and
+    # ReportingSocket, so we don't need all the parametrization. Since
+    # ReportingFileSocket and ReportingSocket are wrappers, it's easier to
+    # test them through their use by the transport than directly (that's a
+    # bit less clean but far more simpler and effective).
+    _activity_server = ActivityHTTPServer
+    _protocol_version = 'HTTP/1.1'
+
     def setUp(self):
-        tests.TestCase.setUp(self)
-        # Unlike TestActivity, we are really testing ReportingFileSocket and
-        # ReportingSocket, so we don't need all the parametrization. Since
-        # ReportingFileSocket and ReportingSocket are wrappers, it's easier to
-        # test them through their use by the transport than directly (that's a
-        # bit less clean but far more simpler and effective).
-        self.server = ActivityHTTPServer('HTTP/1.1')
-        self._transport=_urllib.HttpTransport_urllib
-
-        self.server.start_server()
-
-        # We override at class level because constructors may propagate the
-        # bound method and render instance overriding ineffective (an
-        # alternative would be to define a specific ui factory instead...)
-        self.orig_report_activity = self._transport._report_activity
-        self._transport._report_activity = None
-
-    def tearDown(self):
-        self._transport._report_activity = self.orig_report_activity
-        self.server.stop_server()
-        tests.TestCase.tearDown(self)
+        self._transport =_urllib.HttpTransport_urllib
+        TestActivityMixin.setUp(self)
 
     def assertActivitiesMatch(self):
         # Nothing to check here

=== modified file 'bzrlib/tests/test_inv.py'
--- bzrlib/tests/test_inv.py	2009-09-24 19:26:45 +0000
+++ bzrlib/tests/test_inv.py	2010-08-03 13:31:06 +0000
@@ -18,7 +18,6 @@
 from bzrlib import (
     chk_map,
     groupcompress,
-    bzrdir,
     errors,
     inventory,
     osutils,
@@ -607,12 +606,7 @@
 
     def test_dir_detect_changes(self):
         left = inventory.InventoryDirectory('123', 'hello.c', ROOT_ID)
-        left.text_sha1 = 123
-        left.executable = True
-        left.symlink_target='foo'
         right = inventory.InventoryDirectory('123', 'hello.c', ROOT_ID)
-        right.text_sha1 = 321
-        right.symlink_target='bar'
         self.assertEqual((False, False), left.detect_changes(right))
         self.assertEqual((False, False), right.detect_changes(left))
 
@@ -632,11 +626,8 @@
 
     def test_symlink_detect_changes(self):
         left = inventory.InventoryLink('123', 'hello.c', ROOT_ID)
-        left.text_sha1 = 123
-        left.executable = True
         left.symlink_target='foo'
         right = inventory.InventoryLink('123', 'hello.c', ROOT_ID)
-        right.text_sha1 = 321
         right.symlink_target='foo'
         self.assertEqual((False, False), left.detect_changes(right))
         self.assertEqual((False, False), right.detect_changes(left))

=== modified file 'bzrlib/tests/test_inventory_delta.py'
--- bzrlib/tests/test_inventory_delta.py	2009-08-13 00:20:29 +0000
+++ bzrlib/tests/test_inventory_delta.py	2010-08-03 13:31:06 +0000
@@ -387,9 +387,10 @@
         root = new_inv.make_entry('directory', '', None, 'my-rich-root-id')
         root.revision = 'changed'
         new_inv.add(root)
-        non_root = new_inv.make_entry('directory', 'foo', root.file_id, 'id')
+        class StrangeInventoryEntry(inventory.InventoryEntry):
+            kind = 'strange'
+        non_root = StrangeInventoryEntry('id', 'foo', root.file_id)
         non_root.revision = 'changed'
-        non_root.kind = 'strangelove'
         new_inv.add(non_root)
         delta = new_inv._make_delta(old_inv)
         serializer = inventory_delta.InventoryDeltaSerializer(
@@ -398,7 +399,7 @@
         # This test aims to prove that it errors more than how it errors.
         err = self.assertRaises(KeyError,
             serializer.delta_to_lines, NULL_REVISION, 'entry-version', delta)
-        self.assertEqual(('strangelove',), err.args)
+        self.assertEqual(('strange',), err.args)
 
     def test_tree_reference_disabled(self):
         old_inv = Inventory(None)

=== modified file 'bzrlib/tests/test_lru_cache.py'
--- bzrlib/tests/test_lru_cache.py	2009-07-08 14:28:04 +0000
+++ bzrlib/tests/test_lru_cache.py	2010-07-15 13:05:40 +0000
@@ -282,13 +282,6 @@
         cache[6] = 7
         self.assertEqual([2, 3, 4, 5, 6], sorted(cache.keys()))
 
-    def test_after_cleanup_size_deprecated(self):
-        obj = self.callDeprecated([
-            'LRUCache.__init__(after_cleanup_size) was deprecated in 1.11.'
-            ' Use after_cleanup_count instead.'],
-            lru_cache.LRUCache, 50, after_cleanup_size=25)
-        self.assertEqual(obj._after_cleanup_count, 25)
-
     def test_resize_smaller(self):
         cache = lru_cache.LRUCache(max_cache=5, after_cleanup_count=4)
         cache[1] = 2

=== modified file 'bzrlib/tests/test_merge.py'
--- bzrlib/tests/test_merge.py	2010-02-23 07:43:11 +0000
+++ bzrlib/tests/test_merge.py	2010-07-29 04:07:27 +0000
@@ -18,13 +18,16 @@
 from StringIO import StringIO
 
 from bzrlib import (
+    branch as _mod_branch,
+    cleanup,
     conflicts,
     errors,
+    inventory,
     knit,
     memorytree,
     merge as _mod_merge,
     option,
-    progress,
+    revision as _mod_revision,
     tests,
     transform,
     versionedfile,
@@ -32,7 +35,7 @@
 from bzrlib.conflicts import ConflictList, TextConflict
 from bzrlib.errors import UnrelatedBranches, NoCommits
 from bzrlib.merge import transform_tree, merge_inner, _PlanMerge
-from bzrlib.osutils import pathjoin, file_kind
+from bzrlib.osutils import basename, pathjoin, file_kind
 from bzrlib.tests import (
     TestCaseWithMemoryTransport,
     TestCaseWithTransport,
@@ -2917,3 +2920,240 @@
         conflicts = builder.merge()
         # The hook should not call the merge_text() method
         self.assertEqual([], self.calls)
+
+
+class TestMergeIntoBase(tests.TestCaseWithTransport):
+
+    def setup_simple_branch(self, relpath, shape=None, root_id=None):
+        """One commit, containing tree specified by optional shape.
+        
+        Default is empty tree (just root entry).
+        """
+        if root_id is None:
+            root_id = '%s-root-id' % (relpath,)
+        wt = self.make_branch_and_tree(relpath)
+        wt.set_root_id(root_id)
+        if shape is not None:
+            adjusted_shape = [relpath + '/' + elem for elem in shape]
+            self.build_tree(adjusted_shape)
+            ids = ['%s-%s-id' % (relpath, basename(elem.rstrip('/')))
+                   for elem in shape]
+            wt.add(shape, ids=ids)
+        rev_id = 'r1-%s' % (relpath,)
+        wt.commit("Initial commit of %s" % (relpath,), rev_id=rev_id)
+        self.assertEqual(root_id, wt.path2id(''))
+        return wt
+
+    def setup_two_branches(self, custom_root_ids=True):
+        """Setup 2 branches, one will be a library, the other a project."""
+        if custom_root_ids:
+            root_id = None
+        else:
+            root_id = inventory.ROOT_ID
+        project_wt = self.setup_simple_branch(
+            'project', ['README', 'dir/', 'dir/file.c'],
+            root_id)
+        lib_wt = self.setup_simple_branch(
+            'lib1', ['README', 'Makefile', 'foo.c'], root_id)
+
+        return project_wt, lib_wt
+
+    def do_merge_into(self, location, merge_as):
+        """Helper for using MergeIntoMerger.
+        
+        :param location: location of directory to merge from, either the
+            location of a branch or of a path inside a branch.
+        :param merge_as: the path in a tree to add the new directory as.
+        :returns: the conflicts from 'do_merge'.
+        """
+        operation = cleanup.OperationWithCleanups(self._merge_into)
+        return operation.run(location, merge_as)
+
+    def _merge_into(self, op, location, merge_as):
+        # Open and lock the various tree and branch objects
+        wt, subdir_relpath = WorkingTree.open_containing(merge_as)
+        op.add_cleanup(wt.lock_write().unlock)
+        branch_to_merge, subdir_to_merge = _mod_branch.Branch.open_containing(
+            location)
+        op.add_cleanup(branch_to_merge.lock_read().unlock)
+        other_tree = branch_to_merge.basis_tree()
+        op.add_cleanup(other_tree.lock_read().unlock)
+        # Perform the merge
+        merger = _mod_merge.MergeIntoMerger(this_tree=wt, other_tree=other_tree,
+            other_branch=branch_to_merge, target_subdir=subdir_relpath,
+            source_subpath=subdir_to_merge)
+        merger.set_base_revision(_mod_revision.NULL_REVISION, branch_to_merge)
+        conflicts = merger.do_merge()
+        merger.set_pending()
+        return conflicts
+
+    def assertTreeEntriesEqual(self, expected_entries, tree):
+        """Assert that 'tree' contains the expected inventory entries.
+
+        :param expected_entries: sequence of (path, file-id) pairs.
+        """
+        files = [(path, ie.file_id) for path, ie in tree.iter_entries_by_dir()]
+        self.assertEqual(expected_entries, files)
+
+
+class TestMergeInto(TestMergeIntoBase):
+
+    def test_newdir_with_unique_roots(self):
+        """Merge a branch with a unique root into a new directory."""
+        project_wt, lib_wt = self.setup_two_branches()
+        self.do_merge_into('lib1', 'project/lib1')
+        project_wt.lock_read()
+        self.addCleanup(project_wt.unlock)
+        # The r1-lib1 revision should be merged into this one
+        self.assertEqual(['r1-project', 'r1-lib1'], project_wt.get_parent_ids())
+        self.assertTreeEntriesEqual(
+            [('', 'project-root-id'),
+             ('README', 'project-README-id'),
+             ('dir', 'project-dir-id'),
+             ('lib1', 'lib1-root-id'),
+             ('dir/file.c', 'project-file.c-id'),
+             ('lib1/Makefile', 'lib1-Makefile-id'),
+             ('lib1/README', 'lib1-README-id'),
+             ('lib1/foo.c', 'lib1-foo.c-id'),
+            ], project_wt)
+
+    def test_subdir(self):
+        """Merge a branch into a subdirectory of an existing directory."""
+        project_wt, lib_wt = self.setup_two_branches()
+        self.do_merge_into('lib1', 'project/dir/lib1')
+        project_wt.lock_read()
+        self.addCleanup(project_wt.unlock)
+        # The r1-lib1 revision should be merged into this one
+        self.assertEqual(['r1-project', 'r1-lib1'], project_wt.get_parent_ids())
+        self.assertTreeEntriesEqual(
+            [('', 'project-root-id'),
+             ('README', 'project-README-id'),
+             ('dir', 'project-dir-id'),
+             ('dir/file.c', 'project-file.c-id'),
+             ('dir/lib1', 'lib1-root-id'),
+             ('dir/lib1/Makefile', 'lib1-Makefile-id'),
+             ('dir/lib1/README', 'lib1-README-id'),
+             ('dir/lib1/foo.c', 'lib1-foo.c-id'),
+            ], project_wt)
+
+    def test_newdir_with_repeat_roots(self):
+        """If the file-id of the dir to be merged already exists a new ID will
+        be allocated to let the merge happen.
+        """
+        project_wt, lib_wt = self.setup_two_branches(custom_root_ids=False)
+        root_id = project_wt.path2id('')
+        self.do_merge_into('lib1', 'project/lib1')
+        project_wt.lock_read()
+        self.addCleanup(project_wt.unlock)
+        # The r1-lib1 revision should be merged into this one
+        self.assertEqual(['r1-project', 'r1-lib1'], project_wt.get_parent_ids())
+        new_lib1_id = project_wt.path2id('lib1')
+        self.assertNotEqual(None, new_lib1_id)
+        self.assertTreeEntriesEqual(
+            [('', root_id),
+             ('README', 'project-README-id'),
+             ('dir', 'project-dir-id'),
+             ('lib1', new_lib1_id),
+             ('dir/file.c', 'project-file.c-id'),
+             ('lib1/Makefile', 'lib1-Makefile-id'),
+             ('lib1/README', 'lib1-README-id'),
+             ('lib1/foo.c', 'lib1-foo.c-id'),
+            ], project_wt)
+
+    def test_name_conflict(self):
+        """When the target directory name already exists a conflict is
+        generated and the original directory is renamed to foo.moved.
+        """
+        dest_wt = self.setup_simple_branch('dest', ['dir/', 'dir/file.txt'])
+        src_wt = self.setup_simple_branch('src', ['README'])
+        conflicts = self.do_merge_into('src', 'dest/dir')
+        self.assertEqual(1, conflicts)
+        dest_wt.lock_read()
+        self.addCleanup(dest_wt.unlock)
+        # The r1-lib1 revision should be merged into this one
+        self.assertEqual(['r1-dest', 'r1-src'], dest_wt.get_parent_ids())
+        self.assertTreeEntriesEqual(
+            [('', 'dest-root-id'),
+             ('dir', 'src-root-id'),
+             ('dir.moved', 'dest-dir-id'),
+             ('dir/README', 'src-README-id'),
+             ('dir.moved/file.txt', 'dest-file.txt-id'),
+            ], dest_wt)
+
+    def test_file_id_conflict(self):
+        """A conflict is generated if the merge-into adds a file (or other
+        inventory entry) with a file-id that already exists in the target tree.
+        """
+        dest_wt = self.setup_simple_branch('dest', ['file.txt'])
+        # Make a second tree with a file-id that will clash with file.txt in
+        # dest.
+        src_wt = self.make_branch_and_tree('src')
+        self.build_tree(['src/README'])
+        src_wt.add(['README'], ids=['dest-file.txt-id'])
+        src_wt.commit("Rev 1 of src.", rev_id='r1-src')
+        conflicts = self.do_merge_into('src', 'dest/dir')
+        # This is an edge case that shouldn't happen to users very often.  So
+        # we don't care really about the exact presentation of the conflict,
+        # just that there is one.
+        self.assertEqual(1, conflicts)
+
+    def test_only_subdir(self):
+        """When the location points to just part of a tree, merge just that
+        subtree.
+        """
+        dest_wt = self.setup_simple_branch('dest')
+        src_wt = self.setup_simple_branch(
+            'src', ['hello.txt', 'dir/', 'dir/foo.c'])
+        conflicts = self.do_merge_into('src/dir', 'dest/dir')
+        dest_wt.lock_read()
+        self.addCleanup(dest_wt.unlock)
+        # The r1-lib1 revision should NOT be merged into this one (this is a
+        # partial merge).
+        self.assertEqual(['r1-dest'], dest_wt.get_parent_ids())
+        self.assertTreeEntriesEqual(
+            [('', 'dest-root-id'),
+             ('dir', 'src-dir-id'),
+             ('dir/foo.c', 'src-foo.c-id'),
+            ], dest_wt)
+
+    def test_only_file(self):
+        """An edge case: merge just one file, not a whole dir."""
+        dest_wt = self.setup_simple_branch('dest')
+        two_file_wt = self.setup_simple_branch(
+            'two-file', ['file1.txt', 'file2.txt'])
+        conflicts = self.do_merge_into('two-file/file1.txt', 'dest/file1.txt')
+        dest_wt.lock_read()
+        self.addCleanup(dest_wt.unlock)
+        # The r1-lib1 revision should NOT be merged into this one
+        self.assertEqual(['r1-dest'], dest_wt.get_parent_ids())
+        self.assertTreeEntriesEqual(
+            [('', 'dest-root-id'), ('file1.txt', 'two-file-file1.txt-id')],
+            dest_wt)
+
+    def test_no_such_source_path(self):
+        """PathNotInTree is raised if the specified path in the source tree
+        does not exist.
+        """
+        dest_wt = self.setup_simple_branch('dest')
+        two_file_wt = self.setup_simple_branch('src', ['dir/'])
+        self.assertRaises(_mod_merge.PathNotInTree, self.do_merge_into,
+            'src/no-such-dir', 'dest/foo')
+        dest_wt.lock_read()
+        self.addCleanup(dest_wt.unlock)
+        # The dest tree is unmodified.
+        self.assertEqual(['r1-dest'], dest_wt.get_parent_ids())
+        self.assertTreeEntriesEqual([('', 'dest-root-id')], dest_wt)
+
+    def test_no_such_target_path(self):
+        """PathNotInTree is also raised if the specified path in the target
+        tree does not exist.
+        """
+        dest_wt = self.setup_simple_branch('dest')
+        two_file_wt = self.setup_simple_branch('src', ['file.txt'])
+        self.assertRaises(_mod_merge.PathNotInTree, self.do_merge_into,
+            'src', 'dest/no-such-dir/foo')
+        dest_wt.lock_read()
+        self.addCleanup(dest_wt.unlock)
+        # The dest tree is unmodified.
+        self.assertEqual(['r1-dest'], dest_wt.get_parent_ids())
+        self.assertTreeEntriesEqual([('', 'dest-root-id')], dest_wt)

=== modified file 'bzrlib/tests/test_progress.py'
--- bzrlib/tests/test_progress.py	2010-02-17 17:11:16 +0000
+++ bzrlib/tests/test_progress.py	2010-08-05 08:18:06 +0000
@@ -58,7 +58,7 @@
     def make_view(self):
         out = StringIO()
         view = TextProgressView(out)
-        view._width = 80
+        view._avail_width = lambda: 79
         return out, view
     
     def make_task(self, parent_task, view, msg, curr, total):
@@ -70,6 +70,21 @@
         task.total_cnt = total
         return task
 
+    def test_clear(self):
+        # <https://bugs.launchpad.net/bzr/+bug/611127> clear must actually
+        # send spaces to clear the line
+        out, view = self.make_view()
+        task = self.make_task(None, view, 'reticulating splines', 5, 20)
+        view.show_progress(task)
+        self.assertEqual(
+'\r/ reticulating splines 5/20                                                    \r'
+            , out.getvalue())
+        view.clear()
+        self.assertEqual(
+'\r/ reticulating splines 5/20                                                    \r'
+            + '\r' + 79 * ' ' + '\r',
+            out.getvalue())
+
     def test_render_progress_no_bar(self):
         """The default view now has a spinner but no bar."""
         out, view = self.make_view()
@@ -100,13 +115,13 @@
         # so we're in the first half of the main task, and half way through
         # that
         self.assertEqual(
-r'[####-               ] reticulating splines:stage2 1/2'
+'[####-               ] reticulating splines:stage2 1/2                         '
             , view._render_line())
         # if the nested task is complete, then we're all the way through the
         # first half of the overall work
         task2.update('stage2', 2, 2)
         self.assertEqual(
-r'[#########\          ] reticulating splines:stage2 2/2'
+'[#########\          ] reticulating splines:stage2 2/2                         '
             , view._render_line())
 
     def test_render_progress_sub_nested(self):
@@ -123,5 +138,38 @@
         # progress indication, just a label; and the bottom one is half done,
         # so the overall fraction is 1/4
         self.assertEqual(
-            r'[####|               ] a:b:c 1/2'
+'[####|               ] a:b:c 1/2                                               '
             , view._render_line())
+
+    def test_render_truncated(self):
+        # when the bar is too long for the terminal, we prefer not to truncate
+        # the counters because they might be interesting, and because
+        # truncating the numbers might be misleading
+        out, view = self.make_view()
+        task_a = ProgressTask(None, progress_view=view)
+        task_a.update('start_' + 'a' * 200 + '_end', 2000, 5000)
+        line = view._render_line()
+        self.assertEqual(
+'- start_aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa.. 2000/5000',
+           line) 
+        self.assertEqual(len(line), 79)
+
+
+    def test_render_with_activity(self):
+        # if the progress view has activity, it's shown before the spinner
+        out, view = self.make_view()
+        task_a = ProgressTask(None, progress_view=view)
+        view._last_transport_msg = '   123kB   100kB/s '
+        line = view._render_line()
+        self.assertEqual(
+'   123kB   100kB/s /                                                           ',
+           line) 
+        self.assertEqual(len(line), 79)
+
+        task_a.update('start_' + 'a' * 200 + '_end', 2000, 5000)
+        view._last_transport_msg = '   123kB   100kB/s '
+        line = view._render_line()
+        self.assertEqual(
+'   123kB   100kB/s \\ start_aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa.. 2000/5000',
+           line) 
+        self.assertEqual(len(line), 79)

=== modified file 'bzrlib/tests/test_read_bundle.py'
--- bzrlib/tests/test_read_bundle.py	2009-07-10 07:14:02 +0000
+++ bzrlib/tests/test_read_bundle.py	2010-07-15 12:53:44 +0000
@@ -35,7 +35,8 @@
 def load_tests(standard_tests, module, loader):
     """Multiply tests for tranport implementations."""
     transport_tests, remaining_tests = tests.split_suite_by_condition(
-        standard_tests, tests.condition_isinstance(TestReadBundleFromURL))
+        standard_tests,
+        tests.condition_isinstance(TestReadMergeableBundleFromURL))
     return tests.multiply_tests(transport_tests, transport_test_permutations(),
         remaining_tests)
 
@@ -60,32 +61,11 @@
     return out, wt
 
 
-class TestDeprecations(tests.TestCaseInTempDir):
-
-    def create_test_bundle(self):
-        out, wt = create_bundle_file(self)
-        f = open('test_bundle', 'wb')
-        try:
-            f.write(out.getvalue())
-        finally:
-            f.close()
-        return wt
-
-    def test_read_bundle_from_url_deprecated(self):
-        wt = self.create_test_bundle()
-        t = bzrlib.transport.get_transport(self.test_dir)
-        url = t.abspath('test_bundle')
-        self.callDeprecated([deprecated_in((1, 12, 0))
-                             % 'bzrlib.bundle.read_bundle_from_url'],
-                            bzrlib.bundle.read_bundle_from_url,
-                            url)
-
-
-class TestReadBundleFromURL(TestTransportImplementation):
+class TestReadMergeableBundleFromURL(TestTransportImplementation):
     """Test that read_bundle works properly across multiple transports"""
 
     def setUp(self):
-        super(TestReadBundleFromURL, self).setUp()
+        super(TestReadMergeableBundleFromURL, self).setUp()
         self.bundle_name = 'test_bundle'
         # read_mergeable_from_url will invoke get_transport which may *not*
         # respect self._transport (i.e. returns a transport that is different

=== modified file 'bzrlib/tests/test_remote.py'
--- bzrlib/tests/test_remote.py	2010-06-20 11:18:38 +0000
+++ bzrlib/tests/test_remote.py	2010-07-13 19:02:12 +0000
@@ -89,10 +89,7 @@
         self.transport = self.get_transport()
         # make a branch that can be opened over the smart transport
         self.local_wt = BzrDir.create_standalone_workingtree('.')
-
-    def tearDown(self):
-        self.transport.disconnect()
-        tests.TestCaseWithTransport.tearDown(self)
+        self.addCleanup(self.transport.disconnect)
 
     def test_create_remote_bzrdir(self):
         b = remote.RemoteBzrDir(self.transport, remote.RemoteBzrDirFormat())

=== modified file 'bzrlib/tests/test_revision.py'
--- bzrlib/tests/test_revision.py	2009-06-03 10:24:28 +0000
+++ bzrlib/tests/test_revision.py	2010-07-15 12:37:32 +0000
@@ -211,31 +211,6 @@
         r.message = None
         self.assertEqual('', r.get_summary())
 
-    def test_get_apparent_author(self):
-        r = revision.Revision('1')
-        r.committer = 'A'
-        author = self.applyDeprecated(
-                symbol_versioning.deprecated_in((1, 13, 0)),
-                r.get_apparent_author)
-        self.assertEqual('A', author)
-        r.properties['author'] = 'B'
-        author = self.applyDeprecated(
-                symbol_versioning.deprecated_in((1, 13, 0)),
-                r.get_apparent_author)
-        self.assertEqual('B', author)
-        r.properties['authors'] = 'C\nD'
-        author = self.applyDeprecated(
-                symbol_versioning.deprecated_in((1, 13, 0)),
-                r.get_apparent_author)
-        self.assertEqual('C', author)
-
-    def test_get_apparent_author_none(self):
-        r = revision.Revision('1')
-        author = self.applyDeprecated(
-                symbol_versioning.deprecated_in((1, 13, 0)),
-                r.get_apparent_author)
-        self.assertEqual(None, author)
-
     def test_get_apparent_authors(self):
         r = revision.Revision('1')
         r.committer = 'A'

=== modified file 'bzrlib/tests/test_selftest.py'
--- bzrlib/tests/test_selftest.py	2010-06-20 11:18:38 +0000
+++ bzrlib/tests/test_selftest.py	2010-08-07 16:42:09 +0000
@@ -801,7 +801,7 @@
         self.requireFeature(test_lsprof.LSProfFeature)
         result_stream = StringIO()
         result = bzrlib.tests.VerboseTestResult(
-            unittest._WritelnDecorator(result_stream),
+            result_stream,
             descriptions=0,
             verbosity=2,
             )
@@ -862,7 +862,7 @@
         # verbose test output formatting
         result_stream = StringIO()
         result = bzrlib.tests.VerboseTestResult(
-            unittest._WritelnDecorator(result_stream),
+            result_stream,
             descriptions=0,
             verbosity=2,
             )
@@ -878,6 +878,9 @@
         output = result_stream.getvalue()[prefix:]
         lines = output.splitlines()
         self.assertContainsRe(lines[0], r'XFAIL *\d+ms$')
+        if sys.version_info > (2, 7):
+            self.expectFailure("_ExpectedFailure on 2.7 loses the message",
+                self.assertNotEqual, lines[1], '    ')
         self.assertEqual(lines[1], '    foo')
         self.assertEqual(2, len(lines))
 
@@ -917,7 +920,7 @@
         # verbose test output formatting
         result_stream = StringIO()
         result = bzrlib.tests.VerboseTestResult(
-            unittest._WritelnDecorator(result_stream),
+            result_stream,
             descriptions=0,
             verbosity=2,
             )
@@ -1419,7 +1422,7 @@
         sample_test = TestTestCase("method_that_times_a_bit_twice")
         output_stream = StringIO()
         result = bzrlib.tests.VerboseTestResult(
-            unittest._WritelnDecorator(output_stream),
+            output_stream,
             descriptions=0,
             verbosity=2)
         sample_test.run(result)
@@ -2337,6 +2340,11 @@
             os.chdir = orig_chdir
         self.assertEqual(['foo', 'current'], chdirs)
 
+    def test_get_bzr_path_with_cwd_bzrlib(self):
+        self.get_source_path = lambda: ""
+        self.overrideAttr(os.path, "isfile", lambda path: True)
+        self.assertEqual(self.get_bzr_path(), "bzr")
+
 
 class TestActuallyStartBzrSubprocess(tests.TestCaseWithTransport):
     """Tests that really need to do things with an external bzr."""

=== modified file 'bzrlib/tests/test_smart_request.py'
--- bzrlib/tests/test_smart_request.py	2010-06-20 11:18:38 +0000
+++ bzrlib/tests/test_smart_request.py	2010-07-13 19:02:12 +0000
@@ -187,9 +187,11 @@
 
 class TestJailHook(TestCaseWithMemoryTransport):
 
-    def tearDown(self):
-        request.jail_info.transports = None
-        TestCaseWithMemoryTransport.tearDown(self)
+    def setUp(self):
+        super(TestJailHook, self).setUp()
+        def clear_jail_info():
+            request.jail_info.transports = None
+        self.addCleanup(clear_jail_info)
 
     def test_jail_hook(self):
         request.jail_info.transports = None

=== modified file 'bzrlib/tests/test_source.py'
--- bzrlib/tests/test_source.py	2010-02-17 17:11:16 +0000
+++ bzrlib/tests/test_source.py	2010-07-05 16:01:33 +0000
@@ -40,11 +40,17 @@
 
 # Files which are listed here will be skipped when testing for Copyright (or
 # GPL) statements.
-COPYRIGHT_EXCEPTIONS = ['bzrlib/lsprof.py', 'bzrlib/_bencode_py.py',
-    'bzrlib/doc_generate/sphinx_conf.py']
+COPYRIGHT_EXCEPTIONS = [
+    'bzrlib/_bencode_py.py',
+    'bzrlib/doc_generate/conf.py',
+    'bzrlib/lsprof.py',
+    ]
 
-LICENSE_EXCEPTIONS = ['bzrlib/lsprof.py', 'bzrlib/_bencode_py.py',
-    'bzrlib/doc_generate/sphinx_conf.py']
+LICENSE_EXCEPTIONS = [
+    'bzrlib/_bencode_py.py',
+    'bzrlib/doc_generate/conf.py',
+    'bzrlib/lsprof.py',
+    ]
 # Technically, 'bzrlib/lsprof.py' should be 'bzrlib/util/lsprof.py',
 # (we do not check bzrlib/util/, since that is code bundled from elsewhere)
 # but for compatibility with previous releases, we don't want to move it.

=== modified file 'bzrlib/tests/test_transform.py'
--- bzrlib/tests/test_transform.py	2010-05-13 17:32:55 +0000
+++ bzrlib/tests/test_transform.py	2010-07-21 10:38:31 +0000
@@ -859,10 +859,14 @@
         myfile = create.new_file('myfile', root_id, 'myfile-text',
                                  'myfile-id')
         create.apply()
-        # make the file and directory readonly in the hope this will prevent
-        # renames
-        osutils.make_readonly(self.wt.abspath('first-dir'))
-        osutils.make_readonly(self.wt.abspath('myfile'))
+        if os.name == "posix" and sys.platform != "cygwin":
+            # posix filesystems fail on renaming if the readonly bit is set
+            osutils.make_readonly(self.wt.abspath('first-dir'))
+        elif os.name == "nt":
+            # windows filesystems fail on renaming open files
+            self.addCleanup(file(self.wt.abspath('myfile')).close)
+        else:
+            self.skip("Don't know how to force a permissions error on rename")
         # now transform to rename
         rename_transform, root_id = self.get_transform()
         file_trans_id = rename_transform.trans_id_file_id('myfile-id')
@@ -870,13 +874,15 @@
         rename_transform.adjust_path('newname', dir_id, file_trans_id)
         e = self.assertRaises(errors.TransformRenameFailed,
             rename_transform.apply)
-        # Looks like: 
+        # On nix looks like: 
         # "Failed to rename .../work/.bzr/checkout/limbo/new-1
         # to .../first-dir/newname: [Errno 13] Permission denied"
-        # so the first filename is not visible in it; we expect a strerror but
-        # it may vary per OS and language so it's not checked here
+        # On windows looks like:
+        # "Failed to rename .../work/myfile to 
+        # .../work/.bzr/checkout/limbo/new-1: [Errno 13] Permission denied"
+        # The strerror will vary per OS and language so it's not checked here
         self.assertContainsRe(str(e),
-            "Failed to rename .*first-dir.newname:")
+            "Failed to rename .*(first-dir.newname:|myfile)")
 
     def test_set_executability_order(self):
         """Ensure that executability behaves the same, no matter what order.

=== added file 'bzrlib/tests/test_treeshape.py'
--- bzrlib/tests/test_treeshape.py	1970-01-01 00:00:00 +0000
+++ bzrlib/tests/test_treeshape.py	2010-07-15 13:55:46 +0000
@@ -0,0 +1,41 @@
+# Copyright (C) 2010 Canonical Ltd
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
+
+
+import os
+
+
+from bzrlib import tests
+
+
+class TestTreeShape(tests.TestCaseWithTransport):
+
+    def test_build_tree(self):
+        """Test tree-building test helper"""
+        self.build_tree_contents([
+            ('foo', 'new contents'),
+            ('.bzr/',),
+            ('.bzr/README', 'hello'),
+            ])
+        self.failUnlessExists('foo')
+        self.failUnlessExists('.bzr/README')
+        self.assertFileEqual('hello', '.bzr/README')
+
+    def test_build_tree_symlink(self):
+        self.requireFeature(tests.SymlinkFeature)
+        self.build_tree_contents([('link@', 'target')])
+        self.assertEqual('target',
+            os.readlink('link'))

=== modified file 'bzrlib/tests/test_ui.py'
--- bzrlib/tests/test_ui.py	2010-06-21 22:29:38 +0000
+++ bzrlib/tests/test_ui.py	2010-07-17 16:46:44 +0000
@@ -100,51 +100,6 @@
         finally:
             pb.finished()
 
-    def test_progress_note(self):
-        stderr = tests.StringIOWrapper()
-        stdout = tests.StringIOWrapper()
-        ui_factory = _mod_ui_text.TextUIFactory(stdin=tests.StringIOWrapper(''),
-                                                stderr=stderr,
-                                                stdout=stdout)
-        pb = ui_factory.nested_progress_bar()
-        try:
-            result = self.applyDeprecated(deprecated_in((2, 1, 0)),
-                pb.note,
-                't')
-            self.assertEqual(None, result)
-            self.assertEqual("t\n", stdout.getvalue())
-            # Since there was no update() call, there should be no clear() call
-            self.failIf(re.search(r'^\r {10,}\r$',
-                                  stderr.getvalue()) is not None,
-                        'We cleared the stderr without anything to put there')
-        finally:
-            pb.finished()
-
-    def test_progress_note_clears(self):
-        stderr = test_progress._TTYStringIO()
-        stdout = test_progress._TTYStringIO()
-        # so that we get a TextProgressBar
-        os.environ['TERM'] = 'xterm'
-        ui_factory = _mod_ui_text.TextUIFactory(
-            stdin=tests.StringIOWrapper(''),
-            stdout=stdout, stderr=stderr)
-        self.assertIsInstance(ui_factory._progress_view,
-                              _mod_ui_text.TextProgressView)
-        pb = ui_factory.nested_progress_bar()
-        try:
-            # Create a progress update that isn't throttled
-            pb.update('x', 1, 1)
-            result = self.applyDeprecated(deprecated_in((2, 1, 0)),
-                pb.note, 't')
-            self.assertEqual(None, result)
-            self.assertEqual("t\n", stdout.getvalue())
-            # the exact contents will depend on the terminal width and we don't
-            # care about that right now - but you're probably running it on at
-            # least a 10-character wide terminal :)
-            self.assertContainsRe(stderr.getvalue(), r'\r {10,}\r$')
-        finally:
-            pb.finished()
-
     def test_text_ui_get_boolean(self):
         stdin = tests.StringIOWrapper("y\n" # True
                                       "n\n" # False
@@ -193,6 +148,7 @@
         factory = _mod_ui_text.TextUIFactory(
             stdin=tests.StringIOWrapper("yada\ny\n"),
             stdout=out, stderr=out)
+        factory._avail_width = lambda: 79
         pb = factory.nested_progress_bar()
         pb.show_bar = False
         pb.show_spinner = False
@@ -204,9 +160,9 @@
                                                factory.get_boolean,
                                                "what do you want"))
         output = out.getvalue()
-        self.assertContainsRe(factory.stdout.getvalue(),
-            "foo *\r\r  *\r*")
-        self.assertContainsRe(factory.stdout.getvalue(),
+        self.assertContainsRe(output,
+            "| foo *\r\r  *\r*")
+        self.assertContainsRe(output,
             r"what do you want\? \[y/n\]: what do you want\? \[y/n\]: ")
         # stdin should have been totally consumed
         self.assertEqual('', factory.stdin.readline())

=== modified file 'bzrlib/tests/test_upgrade.py'
--- bzrlib/tests/test_upgrade.py	2010-06-20 11:18:38 +0000
+++ bzrlib/tests/test_upgrade.py	2010-07-29 11:17:57 +0000
@@ -43,12 +43,6 @@
 
 class TestUpgrade(TestCaseWithTransport):
 
-    def test_build_tree(self):
-        """Test tree-building test helper"""
-        self.build_tree_contents(_upgrade1_template)
-        self.failUnlessExists('foo')
-        self.failUnlessExists('.bzr/README')
-
     def test_upgrade_simple(self):
         """Upgrade simple v0.0.4 format to latest format"""
         eq = self.assertEquals

=== added file 'bzrlib/tests/test_versionedfile.py'
--- bzrlib/tests/test_versionedfile.py	1970-01-01 00:00:00 +0000
+++ bzrlib/tests/test_versionedfile.py	2010-08-10 20:03:44 +0000
@@ -0,0 +1,139 @@
+# Copyright (C) 2010 Canonical Ltd
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
+
+"""Tests for VersionedFile classes"""
+
+from bzrlib import (
+    errors,
+    groupcompress,
+    multiparent,
+    tests,
+    versionedfile,
+    )
+
+
+class Test_MPDiffGenerator(tests.TestCaseWithMemoryTransport):
+    # Should this be a per vf test?
+
+    def make_vf(self):
+        t = self.get_transport('')
+        factory = groupcompress.make_pack_factory(True, True, 1)
+        return factory(t)
+
+    def make_three_vf(self):
+        vf = self.make_vf()
+        vf.add_lines(('one',), (), ['first\n'])
+        vf.add_lines(('two',), [('one',)], ['first\n', 'second\n'])
+        vf.add_lines(('three',), [('one',), ('two',)],
+                    ['first\n', 'second\n', 'third\n'])
+        return vf
+
+    def test_finds_parents(self):
+        vf = self.make_three_vf()
+        gen = versionedfile._MPDiffGenerator(vf, [('three',)])
+        needed_keys, refcount = gen._find_needed_keys()
+        self.assertEqual(sorted([('one',), ('two',), ('three',)]),
+                         sorted(needed_keys))
+        self.assertEqual({('one',): 1, ('two',): 1}, refcount)
+
+    def test_ignores_ghost_parents(self):
+        # If a parent is a ghost, it is just ignored
+        vf = self.make_vf()
+        vf.add_lines(('two',), [('one',)], ['first\n', 'second\n'])
+        gen = versionedfile._MPDiffGenerator(vf, [('two',)])
+        needed_keys, refcount = gen._find_needed_keys()
+        self.assertEqual(sorted([('two',)]), sorted(needed_keys))
+        # It is returned, but we don't really care as we won't extract it
+        self.assertEqual({('one',): 1}, refcount)
+        self.assertEqual([('one',)], sorted(gen.ghost_parents))
+        self.assertEqual([], sorted(gen.present_parents))
+
+    def test_raises_on_ghost_keys(self):
+        # If the requested key is a ghost, then we have a problem
+        vf = self.make_vf()
+        gen = versionedfile._MPDiffGenerator(vf, [('one',)])
+        self.assertRaises(errors.RevisionNotPresent,
+                          gen._find_needed_keys)
+
+    def test_refcount_multiple_children(self):
+        vf = self.make_three_vf()
+        gen = versionedfile._MPDiffGenerator(vf, [('two',), ('three',)])
+        needed_keys, refcount = gen._find_needed_keys()
+        self.assertEqual(sorted([('one',), ('two',), ('three',)]),
+                         sorted(needed_keys))
+        self.assertEqual({('one',): 2, ('two',): 1}, refcount)
+        self.assertEqual([('one',)], sorted(gen.present_parents))
+
+    def test_process_contents(self):
+        vf = self.make_three_vf()
+        gen = versionedfile._MPDiffGenerator(vf, [('two',), ('three',)])
+        gen._find_needed_keys()
+        self.assertEqual({('two',): (('one',),),
+                          ('three',): (('one',), ('two',))},
+                         gen.parent_map)
+        self.assertEqual({('one',): 2, ('two',): 1}, gen.refcounts)
+        self.assertEqual(sorted([('one',), ('two',), ('three',)]),
+                         sorted(gen.needed_keys))
+        stream = vf.get_record_stream(gen.needed_keys, 'topological', True)
+        record = stream.next()
+        self.assertEqual(('one',), record.key)
+        # one is not needed in the output, but it is needed by children. As
+        # such, it should end up in the various caches
+        gen._process_one_record(record.key, record.get_bytes_as('chunked'))
+        # The chunks should be cached, the refcount untouched
+        self.assertEqual([('one',)], gen.chunks.keys())
+        self.assertEqual({('one',): 2, ('two',): 1}, gen.refcounts)
+        self.assertEqual([], gen.diffs.keys())
+        # Next we get 'two', which is something we output, but also needed for
+        # three
+        record = stream.next()
+        self.assertEqual(('two',), record.key)
+        gen._process_one_record(record.key, record.get_bytes_as('chunked'))
+        # Both are now cached, and the diff for two has been extracted, and
+        # one's refcount has been updated. two has been removed from the
+        # parent_map
+        self.assertEqual(sorted([('one',), ('two',)]),
+                         sorted(gen.chunks.keys()))
+        self.assertEqual({('one',): 1, ('two',): 1}, gen.refcounts)
+        self.assertEqual([('two',)], gen.diffs.keys())
+        self.assertEqual({('three',): (('one',), ('two',))},
+                         gen.parent_map)
+        # Finally 'three', which allows us to remove all parents from the
+        # caches
+        record = stream.next()
+        self.assertEqual(('three',), record.key)
+        gen._process_one_record(record.key, record.get_bytes_as('chunked'))
+        # Both are now cached, and the diff for two has been extracted, and
+        # one's refcount has been updated
+        self.assertEqual([], gen.chunks.keys())
+        self.assertEqual({}, gen.refcounts)
+        self.assertEqual(sorted([('two',), ('three',)]),
+                         sorted(gen.diffs.keys()))
+
+    def test_compute_diffs(self):
+        vf = self.make_three_vf()
+        # The content is in the order requested, even if it isn't topological
+        gen = versionedfile._MPDiffGenerator(vf, [('two',), ('three',),
+                                                  ('one',)])
+        diffs = gen.compute_diffs()
+        expected_diffs = [
+            multiparent.MultiParent([multiparent.ParentText(0, 0, 0, 1),
+                                     multiparent.NewText(['second\n'])]),
+            multiparent.MultiParent([multiparent.ParentText(1, 0, 0, 2),
+                                     multiparent.NewText(['third\n'])]),
+            multiparent.MultiParent([multiparent.NewText(['first\n'])]),
+            ]
+        self.assertEqual(expected_diffs, diffs)

=== modified file 'bzrlib/tests/test_workingtree_4.py'
--- bzrlib/tests/test_workingtree_4.py	2010-02-04 16:06:36 +0000
+++ bzrlib/tests/test_workingtree_4.py	2010-07-21 09:58:42 +0000
@@ -757,3 +757,23 @@
             ('', [(('', 'dir', 'dir-id'), ['d', 'd'])]),
             ('dir', [(('dir', 'file', 'file-id'), ['a', 'f'])]),
         ],  self.get_simple_dirblocks(state))
+
+
+class TestInventoryCoherency(TestCaseWithTransport):
+
+    def test_inventory_is_synced_when_unversioning_a_dir(self):
+        """Unversioning the root of a subtree unversions the entire subtree."""
+        tree = self.make_branch_and_tree('.')
+        self.build_tree(['a/', 'a/b', 'c/'])
+        tree.add(['a', 'a/b', 'c'], ['a-id', 'b-id', 'c-id'])
+        # within a lock unversion should take effect
+        tree.lock_write()
+        self.addCleanup(tree.unlock)
+        # Force access to the in memory inventory to trigger bug #494221: try
+        # maintaining the in-memory inventory
+        inv = tree.inventory
+        self.assertTrue(inv.has_id('a-id'))
+        self.assertTrue(inv.has_id('b-id'))
+        tree.unversion(['a-id', 'b-id'])
+        self.assertFalse(inv.has_id('a-id'))
+        self.assertFalse(inv.has_id('b-id'))

=== modified file 'bzrlib/tests/treeshape.py'
--- bzrlib/tests/treeshape.py	2010-05-05 00:05:29 +0000
+++ bzrlib/tests/treeshape.py	2010-07-29 11:17:57 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005 Canonical Ltd
+# Copyright (C) 2005, 2010 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -51,7 +51,7 @@
         if name[-1] == '/':
             os.mkdir(name)
         elif name[-1] == '@':
-            raise NotImplementedError('symlinks not handled yet')
+            os.symlink(tt[1], tt[0][:-1])
         else:
             f = file(name, 'wb')
             try:

=== modified file 'bzrlib/transform.py'
--- bzrlib/transform.py	2010-05-29 15:40:14 +0000
+++ bzrlib/transform.py	2010-08-06 19:54:45 +0000
@@ -1182,7 +1182,7 @@
             if trans_id not in self._new_contents:
                 continue
             new_path = self._limbo_name(trans_id)
-            osutils.rename(old_path, new_path)
+            os.rename(old_path, new_path)
             for descendant in self._limbo_descendants(trans_id):
                 desc_path = self._limbo_files[descendant]
                 desc_path = new_path + desc_path[len(old_path):]
@@ -2529,22 +2529,6 @@
         raise errors.BadFileKindError(name, kind)
 
 
-@deprecated_function(deprecated_in((1, 9, 0)))
-def create_by_entry(tt, entry, tree, trans_id, lines=None, mode_id=None):
-    """Create new file contents according to an inventory entry.
-
-    DEPRECATED.  Use create_from_tree instead.
-    """
-    if entry.kind == "file":
-        if lines is None:
-            lines = tree.get_file(entry.file_id).readlines()
-        tt.create_file(lines, trans_id, mode_id=mode_id)
-    elif entry.kind == "symlink":
-        tt.create_symlink(tree.get_symlink_target(entry.file_id), trans_id)
-    elif entry.kind == "directory":
-        tt.create_directory(trans_id)
-
-
 def create_from_tree(tt, trans_id, tree, file_id, bytes=None,
     filter_tree_path=None):
     """Create new file contents according to tree contents.
@@ -2935,8 +2919,8 @@
     def rename(self, from_, to):
         """Rename a file from one path to another."""
         try:
-            osutils.rename(from_, to)
-        except (IOError, OSError), e:
+            os.rename(from_, to)
+        except OSError, e:
             if e.errno in (errno.EEXIST, errno.ENOTEMPTY):
                 raise errors.FileExists(to, str(e))
             # normal OSError doesn't include filenames so it's hard to see where
@@ -2958,8 +2942,8 @@
         """Reverse all renames that have been performed"""
         for from_, to in reversed(self.past_renames):
             try:
-                osutils.rename(to, from_)
-            except (OSError, IOError), e:
+                os.rename(to, from_)
+            except OSError, e:
                 raise errors.TransformRenameFailed(to, from_, str(e), e.errno)                
         # after rollback, don't reuse _FileMover
         past_renames = None

=== modified file 'bzrlib/transport/local.py'
--- bzrlib/transport/local.py	2010-04-30 09:10:00 +0000
+++ bzrlib/transport/local.py	2010-07-19 20:09:53 +0000
@@ -99,7 +99,10 @@
          - relative_reference is url escaped.
         """
         if relative_reference in ('.', ''):
-            return self._local_base
+            # _local_base normally has a trailing slash; strip it so that stat
+            # on a transport pointing to a symlink reads the link not the
+            # referent but be careful of / and c:\
+            return osutils.split(self._local_base)[0]
         return self._local_base + urlutils.unescape(relative_reference)
 
     def abspath(self, relpath):

=== modified file 'bzrlib/transport/sftp.py'
--- bzrlib/transport/sftp.py	2010-03-04 02:43:41 +0000
+++ bzrlib/transport/sftp.py	2010-07-19 10:55:15 +0000
@@ -715,6 +715,8 @@
             if (e.args[0].startswith('Directory not empty: ')
                 or getattr(e, 'errno', None) == errno.ENOTEMPTY):
                 raise errors.DirectoryNotEmpty(path, str(e))
+            if e.args == ('Operation unsupported',):
+                raise errors.TransportNotPossible()
             mutter('Raising exception with args %s', e.args)
         if getattr(e, 'errno', None) is not None:
             mutter('Raising exception with errno %s', e.errno)

=== modified file 'bzrlib/ui/text.py'
--- bzrlib/ui/text.py	2010-06-21 01:30:45 +0000
+++ bzrlib/ui/text.py	2010-08-05 08:18:06 +0000
@@ -300,12 +300,18 @@
         # correspond reliably to overall command progress
         self.enable_bar = False
 
+    def _avail_width(self):
+        # we need one extra space for terminals that wrap on last char
+        w = osutils.terminal_width() 
+        if w is None:
+            return None
+        else:
+            return w - 1
+
     def _show_line(self, s):
         # sys.stderr.write("progress %r\n" % s)
-        width = osutils.terminal_width()
+        width = self._avail_width()
         if width is not None:
-            # we need one extra space for terminals that wrap on last char
-            width = width - 1
             s = '%-*.*s' % (width, width, s)
         self._term_file.write('\r' + s + '\r')
 
@@ -348,6 +354,10 @@
             return ''
 
     def _format_task(self, task):
+        """Format task-specific parts of progress bar.
+
+        :returns: (text_part, counter_part) both unicode strings.
+        """
         if not task.show_count:
             s = ''
         elif task.current_cnt is not None and task.total_cnt is not None:
@@ -363,21 +373,39 @@
             t = t._parent_task
             if t.msg:
                 m = t.msg + ':' + m
-        return m + s
+        return m, s
 
     def _render_line(self):
         bar_string = self._render_bar()
         if self._last_task:
-            task_msg = self._format_task(self._last_task)
+            task_part, counter_part = self._format_task(self._last_task)
         else:
-            task_msg = ''
+            task_part = counter_part = ''
         if self._last_task and not self._last_task.show_transport_activity:
             trans = ''
         else:
             trans = self._last_transport_msg
-            if trans:
-                trans += ' | '
-        return (bar_string + trans + task_msg)
+        # the bar separates the transport activity from the message, so even
+        # if there's no bar or spinner, we must show something if both those
+        # fields are present
+        if (task_part or trans) and not bar_string:
+            bar_string = '| '
+        # preferentially truncate the task message if we don't have enough
+        # space
+        avail_width = self._avail_width()
+        if avail_width is not None:
+            # if terminal avail_width is unknown, don't truncate
+            current_len = len(bar_string) + len(trans) + len(task_part) + len(counter_part)
+            gap = current_len - avail_width
+            if gap > 0:
+                task_part = task_part[:-gap-2] + '..'
+        s = trans + bar_string + task_part + counter_part
+        if avail_width is not None:
+            if len(s) < avail_width:
+                s = s.ljust(avail_width)
+            elif len(s) > avail_width:
+                s = s[:avail_width]
+        return s
 
     def _repaint(self):
         s = self._render_line()
@@ -439,7 +467,7 @@
             rate = (self._bytes_since_update
                     / (now - self._transport_update_time))
             # using base-10 units (see HACKING.txt).
-            msg = ("%6dkB %5dkB/s" %
+            msg = ("%6dkB %5dkB/s " %
                     (self._total_byte_count / 1000, int(rate) / 1000,))
             self._transport_update_time = now
             self._last_repaint = now

=== modified file 'bzrlib/version_info_formats/__init__.py'
--- bzrlib/version_info_formats/__init__.py	2009-03-24 01:53:42 +0000
+++ bzrlib/version_info_formats/__init__.py	2010-07-15 13:41:31 +0000
@@ -20,9 +20,6 @@
 
 from bzrlib.osutils import local_time_offset, format_date
 from bzrlib import registry
-from bzrlib.symbol_versioning import (
-    deprecated_function,
-    )
 
 
 def create_date_str(timestamp=None, offset=None):

=== modified file 'bzrlib/versionedfile.py'
--- bzrlib/versionedfile.py	2010-05-14 12:55:13 +0000
+++ bzrlib/versionedfile.py	2010-08-11 01:27:46 +0000
@@ -206,6 +206,138 @@
             yield record
 
 
+class _MPDiffGenerator(object):
+    """Pull out the functionality for generating mp_diffs."""
+
+    def __init__(self, vf, keys):
+        self.vf = vf
+        # This is the order the keys were requested in
+        self.ordered_keys = tuple(keys)
+        # keys + their parents, what we need to compute the diffs
+        self.needed_keys = ()
+        # Map from key: mp_diff
+        self.diffs = {}
+        # Map from key: parents_needed (may have ghosts)
+        self.parent_map = {}
+        # Parents that aren't present
+        self.ghost_parents = ()
+        # Map from parent_key => number of children for this text
+        self.refcounts = {}
+        # Content chunks that are cached while we still need them
+        self.chunks = {}
+
+    def _find_needed_keys(self):
+        """Find the set of keys we need to request.
+
+        This includes all the original keys passed in, and the non-ghost
+        parents of those keys.
+
+        :return: (needed_keys, refcounts)
+            needed_keys is the set of all texts we need to extract
+            refcounts is a dict of {key: num_children} letting us know when we
+                no longer need to cache a given parent text
+        """
+        # All the keys and their parents
+        needed_keys = set(self.ordered_keys)
+        parent_map = self.vf.get_parent_map(needed_keys)
+        self.parent_map = parent_map
+        # TODO: Should we be using a different construct here? I think this
+        #       uses difference_update internally, and we expect the result to
+        #       be tiny
+        missing_keys = needed_keys.difference(parent_map)
+        if missing_keys:
+            raise errors.RevisionNotPresent(list(missing_keys)[0], self.vf)
+        # Parents that might be missing. They are allowed to be ghosts, but we
+        # should check for them
+        refcounts = {}
+        setdefault = refcounts.setdefault
+        just_parents = set()
+        for child_key, parent_keys in parent_map.iteritems():
+            if not parent_keys:
+                # parent_keys may be None if a given VersionedFile claims to
+                # not support graph operations.
+                continue
+            just_parents.update(parent_keys)
+            needed_keys.update(parent_keys)
+            for p in parent_keys:
+                refcounts[p] = setdefault(p, 0) + 1
+        just_parents.difference_update(parent_map)
+        # Remove any parents that are actually ghosts from the needed set
+        self.present_parents = set(self.vf.get_parent_map(just_parents))
+        self.ghost_parents = just_parents.difference(self.present_parents)
+        needed_keys.difference_update(self.ghost_parents)
+        self.needed_keys = needed_keys
+        self.refcounts = refcounts
+        return needed_keys, refcounts
+
+    def _compute_diff(self, key, parent_lines, lines):
+        """Compute a single mp_diff, and store it in self._diffs"""
+        if len(parent_lines) > 0:
+            # XXX: _extract_blocks is not usefully defined anywhere...
+            #      It was meant to extract the left-parent diff without
+            #      having to recompute it for Knit content (pack-0.92,
+            #      etc). That seems to have regressed somewhere
+            left_parent_blocks = self.vf._extract_blocks(key,
+                parent_lines[0], lines)
+        else:
+            left_parent_blocks = None
+        diff = multiparent.MultiParent.from_lines(lines,
+                    parent_lines, left_parent_blocks)
+        self.diffs[key] = diff
+
+    def _process_one_record(self, key, this_chunks):
+        parent_keys = None
+        if key in self.parent_map:
+            # This record should be ready to diff, since we requested
+            # content in 'topological' order
+            parent_keys = self.parent_map.pop(key)
+            # If a VersionedFile claims 'no-graph' support, then it may return
+            # None for any parent request, so we replace it with an empty tuple
+            if parent_keys is None:
+                parent_keys = ()
+            parent_lines = []
+            for p in parent_keys:
+                # Alternatively we could check p not in self.needed_keys, but
+                # ghost_parents should be tiny versus huge
+                if p in self.ghost_parents:
+                    continue
+                refcount = self.refcounts[p]
+                if refcount == 1: # Last child reference
+                    self.refcounts.pop(p)
+                    parent_chunks = self.chunks.pop(p)
+                else:
+                    self.refcounts[p] = refcount - 1
+                    parent_chunks = self.chunks[p]
+                p_lines = osutils.chunks_to_lines(parent_chunks)
+                # TODO: Should we cache the line form? We did the
+                #       computation to get it, but storing it this way will
+                #       be less memory efficient...
+                parent_lines.append(p_lines)
+                del p_lines
+            lines = osutils.chunks_to_lines(this_chunks)
+            # Since we needed the lines, we'll go ahead and cache them this way
+            this_chunks = lines
+            self._compute_diff(key, parent_lines, lines)
+            del lines
+        # Is this content required for any more children?
+        if key in self.refcounts:
+            self.chunks[key] = this_chunks
+
+    def _extract_diffs(self):
+        needed_keys, refcounts = self._find_needed_keys()
+        for record in self.vf.get_record_stream(needed_keys,
+                                                'topological', True):
+            if record.storage_kind == 'absent':
+                raise errors.RevisionNotPresent(record.key, self.vf)
+            self._process_one_record(record.key,
+                                     record.get_bytes_as('chunked'))
+        
+    def compute_diffs(self):
+        self._extract_diffs()
+        dpop = self.diffs.pop
+        return [dpop(k) for k in self.ordered_keys]
+
+
 class VersionedFile(object):
     """Versioned text file storage.
 
@@ -348,6 +480,10 @@
 
     def make_mpdiffs(self, version_ids):
         """Create multiparent diffs for specified versions."""
+        # XXX: Can't use _MPDiffGenerator just yet. This is because version_ids
+        #      is a list of strings, not keys. And while self.get_record_stream
+        #      is supported, it takes *keys*, while self.get_parent_map() takes
+        #      strings... *sigh*
         knit_versions = set()
         knit_versions.update(version_ids)
         parent_map = self.get_parent_map(version_ids)
@@ -1047,43 +1183,11 @@
 
     def make_mpdiffs(self, keys):
         """Create multiparent diffs for specified keys."""
-        keys_order = tuple(keys)
-        keys = frozenset(keys)
-        knit_keys = set(keys)
-        parent_map = self.get_parent_map(keys)
-        for parent_keys in parent_map.itervalues():
-            if parent_keys:
-                knit_keys.update(parent_keys)
-        missing_keys = keys - set(parent_map)
-        if missing_keys:
-            raise errors.RevisionNotPresent(list(missing_keys)[0], self)
-        # We need to filter out ghosts, because we can't diff against them.
-        maybe_ghosts = knit_keys - keys
-        ghosts = maybe_ghosts - set(self.get_parent_map(maybe_ghosts))
-        knit_keys.difference_update(ghosts)
-        lines = {}
-        chunks_to_lines = osutils.chunks_to_lines
-        for record in self.get_record_stream(knit_keys, 'topological', True):
-            lines[record.key] = chunks_to_lines(record.get_bytes_as('chunked'))
-            # line_block_dict = {}
-            # for parent, blocks in record.extract_line_blocks():
-            #   line_blocks[parent] = blocks
-            # line_blocks[record.key] = line_block_dict
-        diffs = []
-        for key in keys_order:
-            target = lines[key]
-            parents = parent_map[key] or []
-            # Note that filtering knit_keys can lead to a parent difference
-            # between the creation and the application of the mpdiff.
-            parent_lines = [lines[p] for p in parents if p in knit_keys]
-            if len(parent_lines) > 0:
-                left_parent_blocks = self._extract_blocks(key, parent_lines[0],
-                    target)
-            else:
-                left_parent_blocks = None
-            diffs.append(multiparent.MultiParent.from_lines(target,
-                parent_lines, left_parent_blocks))
-        return diffs
+        generator = _MPDiffGenerator(self, keys)
+        return generator.compute_diffs()
+
+    def get_annotator(self):
+        return annotate.Annotator(self)
 
     missing_keys = index._missing_keys_from_parent_map
 
@@ -1159,9 +1263,6 @@
             result.append((prefix + (origin,), line))
         return result
 
-    def get_annotator(self):
-        return annotate.Annotator(self)
-
     def check(self, progress_bar=None, keys=None):
         """See VersionedFiles.check()."""
         # XXX: This is over-enthusiastic but as we only thunk for Weaves today

=== modified file 'bzrlib/workingtree.py'
--- bzrlib/workingtree.py	2010-07-10 21:03:02 +0000
+++ bzrlib/workingtree.py	2010-08-15 04:52:51 +0000
@@ -349,10 +349,67 @@
         if path is None:
             path = osutils.getcwd()
         control, relpath = bzrdir.BzrDir.open_containing(path)
-
         return control.open_workingtree(), relpath
 
     @staticmethod
+    def open_containing_paths(file_list, default_directory='.',
+        canonicalize=True, apply_view=True):
+        """Open the WorkingTree that contains a set of paths.
+
+        Fail if the paths given are not all in a single tree.
+
+        This is used for the many command-line interfaces that take a list of
+        any number of files and that require they all be in the same tree.
+        """
+        # recommended replacement for builtins.internal_tree_files
+        if file_list is None or len(file_list) == 0:
+            tree = WorkingTree.open_containing(default_directory)[0]
+            # XXX: doesn't really belong here, and seems to have the strange
+            # side effect of making it return a bunch of files, not the whole
+            # tree -- mbp 20100716
+            if tree.supports_views() and apply_view:
+                view_files = tree.views.lookup_view()
+                if view_files:
+                    file_list = view_files
+                    view_str = views.view_display_str(view_files)
+                    note("Ignoring files outside view. View is %s" % view_str)
+            return tree, file_list
+        tree = WorkingTree.open_containing(file_list[0])[0]
+        return tree, tree.safe_relpath_files(file_list, canonicalize,
+            apply_view=apply_view)
+
+    def safe_relpath_files(self, file_list, canonicalize=True, apply_view=True):
+        """Convert file_list into a list of relpaths in tree.
+
+        :param self: A tree to operate on.
+        :param file_list: A list of user provided paths or None.
+        :param apply_view: if True and a view is set, apply it or check that
+            specified files are within it
+        :return: A list of relative paths.
+        :raises errors.PathNotChild: When a provided path is in a different self
+            than self.
+        """
+        if file_list is None:
+            return None
+        if self.supports_views() and apply_view:
+            view_files = self.views.lookup_view()
+        else:
+            view_files = []
+        new_list = []
+        # self.relpath exists as a "thunk" to osutils, but canonical_relpath
+        # doesn't - fix that up here before we enter the loop.
+        if canonicalize:
+            fixer = lambda p: osutils.canonical_relpath(self.basedir, p)
+        else:
+            fixer = self.relpath
+        for filename in file_list:
+            relpath = fixer(osutils.dereference_path(filename))
+            if view_files and not osutils.is_inside_any(view_files, relpath):
+                raise errors.FileOutsideView(filename, view_files)
+            new_list.append(relpath)
+        return new_list
+
+    @staticmethod
     def open_downlevel(path=None):
         """Open an unsupported working tree.
 
@@ -1264,7 +1321,7 @@
                 stack.pop()
 
     @needs_tree_write_lock
-    def move(self, from_paths, to_dir=None, after=False, **kwargs):
+    def move(self, from_paths, to_dir=None, after=False):
         """Rename files.
 
         to_dir must exist in the inventory.
@@ -1304,14 +1361,7 @@
 
         # check for deprecated use of signature
         if to_dir is None:
-            to_dir = kwargs.get('to_name', None)
-            if to_dir is None:
-                raise TypeError('You must supply a target directory')
-            else:
-                symbol_versioning.warn('The parameter to_name was deprecated'
-                                       ' in version 0.13. Use to_dir instead',
-                                       DeprecationWarning)
-
+            raise TypeError('You must supply a target directory')
         # check destination directory
         if isinstance(from_paths, basestring):
             raise ValueError()

=== modified file 'bzrlib/workingtree_4.py'
--- bzrlib/workingtree_4.py	2010-05-20 18:23:17 +0000
+++ bzrlib/workingtree_4.py	2010-08-03 13:31:06 +0000
@@ -1247,7 +1247,8 @@
         # have to change the legacy inventory too.
         if self._inventory is not None:
             for file_id in file_ids:
-                self._inventory.remove_recursive_id(file_id)
+                if self._inventory.has_id(file_id):
+                    self._inventory.remove_recursive_id(file_id)
 
     @needs_tree_write_lock
     def rename_one(self, from_rel, to_rel, after=False):
@@ -1737,8 +1738,6 @@
                 elif kind == 'directory':
                     parent_ies[(dirname + '/' + name).strip('/')] = inv_entry
                 elif kind == 'symlink':
-                    inv_entry.executable = False
-                    inv_entry.text_size = None
                     inv_entry.symlink_target = utf8_decode(fingerprint)[0]
                 elif kind == 'tree-reference':
                     inv_entry.reference_revision = fingerprint or None

=== modified file 'doc/developers/conf.py'
--- doc/developers/conf.py	2009-09-09 15:51:18 +0000
+++ doc/developers/conf.py	2010-07-07 15:03:14 +0000
@@ -13,7 +13,7 @@
 sys.path = [os.path.abspath('../..')] + sys.path
 
 # Most of the configuration for Bazaar docs is defined here ...
-from bzrlib.doc_generate.sphinx_conf import *
+from bzrlib.doc_generate.conf import *
 
 
 ## Configuration specific to this site ##

=== modified file 'doc/developers/index-plain.txt'
--- doc/developers/index-plain.txt	2010-05-15 10:57:30 +0000
+++ doc/developers/index-plain.txt	2010-07-16 20:52:54 +0000
@@ -54,6 +54,12 @@
 * `Tracking Bugs in Bazaar <bug-handling.html>`_ |--| How we use the bug
   tracker.
 
+Architecture overviews
+======================
+
+* `Transports <transports.html>`_ |--| Transport virtual filesystem
+  abstraction.
+
 Plans
 =====
 

=== modified file 'doc/developers/index.txt'
--- doc/developers/index.txt	2010-05-15 10:57:30 +0000
+++ doc/developers/index.txt	2010-07-16 20:52:54 +0000
@@ -29,6 +29,14 @@
 * `Contributing to Bazaar Documentation <http://wiki.bazaar.canonical.com/ContributingToTheDocs>`_ (wiki)
 
 
+Architecture overviews
+======================
+
+.. toctree::
+   :maxdepth: 1
+
+   transports
+
 Releasing and Packaging
 =======================
 

=== modified file 'doc/developers/overview.txt'
--- doc/developers/overview.txt	2010-06-21 03:55:08 +0000
+++ doc/developers/overview.txt	2010-08-03 09:35:18 +0000
@@ -147,6 +147,7 @@
 revision data that can be pointed to by various branches:
 
  * Maintains storage of various history data at a URL:
+
    * Revisions (Must have a matching inventory)
    * Digital Signatures
    * Inventories for each Revision. (Must have all the file texts available).

=== modified file 'doc/developers/ppa.txt'
--- doc/developers/ppa.txt	2010-06-30 04:11:36 +0000
+++ doc/developers/ppa.txt	2010-07-13 17:14:43 +0000
@@ -47,6 +47,10 @@
 <lp:~bzr/bzr/packaging-hardy>.  These branches are intended to be used
 with the ``bzr-builddeb`` plugin.
 
+**You should almost always upload to the beta ppa first** and then either 
+upload again or copy the packages into the release ppa.  That reduces the 
+risk of breaking the main archive from which people get bzr updates.
+
 Preconditions
 -------------
 
@@ -55,26 +59,15 @@
 
 * You must have a GPG key registered to your Launchpad account.
 
-* Configure ``dput`` to upload to our PPA with this section in your
-  ``~/.dput.cf``::
-
-    [bzr-beta-ppa]
-    fqdn = ppa.launchpad.net
-    method = ftp
-    incoming = ~bzr-beta-ppa/ubuntu
-    login = anonymous
-    allow_unsigned_uploads = 0
-
-    [bzr-ppa]
-    fqdn = ppa.launchpad.net
-    method = ftp
-    incoming = ~bzr/ubuntu
-    login = anonymous
-    allow_unsigned_uploads = 0
-
-  You may also want to add these lines to prevent inadvertently attempting
-  to upload into Ubuntu or Debian, which will give a somewhat unclear
-  error::
+On reasonably recent versions of Ubuntu you no longer need special dput
+configuration, because you can just say ::
+
+  dput ppa:bzr/2.1-proposed <source.changes
+  
+
+However, you may still want to add these lines to ``~/.dput.cf`` prevent 
+inadvertently attempting to upload into Ubuntu or Debian, which will
+give a somewhat unclear error::
 
     [DEFAULT]
     default_host_main = notspecified
@@ -103,6 +96,31 @@
 Packaging Bazaar
 ----------------
 
+Overview of packaging with builddeb
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+* First update the oldest supported branch, using ``bzr merge-upstream``.
+
+* Run ``bzr builddeb -S -- -sa`` to build a source package, then put 
+  that into the ppa.  
+  
+  (``-S`` says to make a source-only upload, which is
+  required for Launchpad's builders.  ``--sa`` says to include the
+  ``.orig.tgz`` even if this doesn't seem to be the first upload for an
+  upstream release: this is often needed when rebuilding something that's
+  previously been uploaded to Debian or Ubuntu or into a different PPA.)
+
+* Now merge across that change into each supported branch with a 
+  simple ``bzr merge``.
+  
+Locally testing builds
+~~~~~~~~~~~~~~~~~~~~~~
+
+It may be useful to locally test builds inside pbuilder.  You may want to 
+use the script from <http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=255165> 
+to wrap it.
+
+
 Short form
 ~~~~~~~~~~
 
@@ -285,6 +303,16 @@
 summary of current package versions with::
 
   apt-cache madison bzr
+  
+  
+  
+Packaging dependencies
+----------------------
+
+Some of our updates to bzr in previous releases require backports of our
+dependencies.  Specific branches holding these backports:
+
+ * ``lp:~bzr/ubuntu/dapper/configobj/dapper-backport``
 
 
 ..

=== modified file 'doc/developers/releasing.txt'
--- doc/developers/releasing.txt	2010-05-27 19:54:56 +0000
+++ doc/developers/releasing.txt	2010-08-06 20:11:05 +0000
@@ -3,10 +3,9 @@
 
 This document describes the processes for making and announcing a Bazaar
 release, and managing the release process.  This is just one phase of the
-`overall development cycle <http://doc.bazaar-vcs.org/developers/cycle.html>`_,
-but it's the most complex part.
-This document gives a checklist you can follow from start to end in one
-go.
+`overall development cycle <http://doc.bazaar.canonical.com/developers/cycle.html>`_,
+but it's the most complex part.  This document gives a checklist you can
+follow from start to end in one go.
 
 If you're helping the Release Manager (RM) for one reason or another, you
 may notice that he didn't follow that document scrupulously. He may have
@@ -73,7 +72,7 @@
 	submit_to = bazaar@lists.canonical.com
 	smtp_server = mail.example.com:25
 
-    Please see <http://doc.bazaar-vcs.org/developers/HACKING.html#an-overview-of-pqm>
+    Please see <http://doc.bazaar.canonical.com/developers/HACKING.html#an-overview-of-pqm>
     for more details on PQM
 
 #. Update the version number in the ``bzr`` script, and the
@@ -263,17 +262,12 @@
 
 #. Go to the release web page at <https://launchpad.net/bzr/x.y/x.y.z>
 
-#. Link from http://bazaar-vcs.org/SourceDownloads to the tarball and
-   signature.
-
-#. Announce on the `Bazaar website <http://bazaar-vcs.org/>`_.
+#. Announce on the `Bazaar website <http://bazaar.canonical.com/>`_.
    This page is edited via the lp:bzr-website branch. (Changes
    pushed to this branch are refreshed by a cron job on escudero.)
 
-#. Announce on the `Bazaar wiki <http://bazaar-vcs.org/Welcome>`_.
-
 #. Check that the documentation for this release is available in
-   <http://doc.bazaar-vcs.org>.  It should be automatically build when the
+   <http://doc.bazaar.canonical.com>.  It should be automatically build when the
    branch is created, by a cron script ``update-bzr-docs`` on
    ``escudero``. As of today (2009-08-27) ``igc`` manually updates the
    pretty version of it.
@@ -312,7 +306,7 @@
       feedback.
 
       Bazaar is now available for download from
-      http://bazaar-vcs.org/Download as a source tarball; packages
+      https://launchpad.net/bzr/2.x/2.x/ as a source tarball; packages
       for various systems will be available soon.
 
       <<NEWS section from this release back to the last major release>>

=== modified file 'doc/developers/testing.txt'
--- doc/developers/testing.txt	2010-06-11 06:19:48 +0000
+++ doc/developers/testing.txt	2010-07-16 20:52:54 +0000
@@ -193,6 +193,41 @@
 <http://babune.ladeuil.net:24842/>.  (Babune = Bazaar Buildbot Network.)
 
 
+Running tests in parallel
+-------------------------
+
+Bazaar can use subunit to spawn multiple test processes.  There is
+slightly more chance you will hit ordering or timing-dependent bugs but
+it's much faster::
+
+  $ ./bzr selftest --parallel=fork
+
+Note that you will need the Subunit library
+<https://launchpad.net/subunit/> to use this, which is in
+``python-subunit`` on Ubuntu.
+
+
+Running tests from a ramdisk
+----------------------------
+
+The tests create and delete a lot of temporary files.  In some cases you
+can make the test suite run much faster by running it on a ramdisk.  For
+example::
+
+  $ sudo mkdir /ram
+  $ sudo mount -t tmpfs none /ram
+  $ TMPDIR=/ram ./bzr selftest ...
+
+You could also change ``/tmp`` in ``/etc/fstab`` to have type ``tmpfs``,
+if you don't mind possibly losing other files in there when the machine
+restarts.  Add this line (if there is none for ``/tmp`` already)::
+
+  none           /tmp            tmpfs  defaults        0       0
+
+With a 6-core machine and ``--parallel=fork`` using a tmpfs doubles the
+test execution speed.
+
+
 Writing Tests
 =============
 
@@ -870,6 +905,63 @@
 Please see bzrlib.treebuilder for more details.
 
 
+Temporarily changing state
+~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+If your test needs to temporarily mutate some global state, and you need
+it restored at the end, you can say for example::
+
+    self.overrideAttr(osutils, '_cached_user_encoding', 'latin-1')
+
+Cleaning up
+~~~~~~~~~~~
+
+Our base ``TestCase`` class provides an ``addCleanup`` method, which
+should be used instead of ``tearDown``.  All the cleanups are run when the
+test finishes, regardless of whether it passes or fails.  If one cleanup
+fails, later cleanups are still run.
+
+(The same facility is available outside of tests through
+``bzrlib.cleanup``.)
+
+
+Manual testing
+==============
+
+Generally we prefer automated testing but sometimes a manual test is the
+right thing, especially for performance tests that want to measure elapsed
+time rather than effort.
+
+Simulating slow networks
+------------------------
+
+To get realistically slow network performance for manually measuring
+performance, we can simulate 500ms latency (thus 1000ms round trips)::
+
+  $ sudo tc qdisc add dev lo root netem delay 500ms
+
+Normal system behaviour is restored with ::
+
+  $ sudo tc qdisc del dev lo root
+
+A more precise version that only filters traffic to port 4155 is::
+
+    tc qdisc add dev lo root handle 1: prio
+    tc qdisc add dev lo parent 1:3 handle 30: netem delay 500ms 
+    tc qdisc add dev lo parent 30:1 handle 40: prio
+    tc filter add dev lo protocol ip parent 1:0 prio 3 u32 match ip dport 4155 0xffff flowid 1:3 handle 800::800
+    tc filter add dev lo protocol ip parent 1:0 prio 3 u32 match ip sport 4155 0xffff flowid 1:3 handle 800::801
+
+and to remove this::
+
+    tc filter del dev lo protocol ip parent 1: pref 3 u32
+    tc qdisc del dev lo root handle 1:
+
+You can use similar code to add additional delay to a real network
+interface, perhaps only when talking to a particular server or pointing at
+a VM.  For more information see <http://lartc.org/>.
+
+
 .. |--| unicode:: U+2014
 
 ..

=== added file 'doc/developers/transports.txt'
--- doc/developers/transports.txt	1970-01-01 00:00:00 +0000
+++ doc/developers/transports.txt	2010-07-16 12:40:07 +0000
@@ -0,0 +1,108 @@
+####################################
+Developer guide to bzrlib transports
+####################################
+
+This guide describes the `Transport` classes that Bazaar uses for most
+local and remote file access.  (Working tree files are the major
+exception (`bug 606249 <https://bugs.launchpad.net/bzr/+bug/606249>`).
+
+
+Handling symlinks
+#################
+
+A symlink creates an alias where files or directories can be accessed by a
+different name.  Symlinks are useful but raise a few annoying cases for
+bzr.
+
+It's important to have tests for symlinks but these tests can't run on
+Windows, so you need eg ::
+
+    _test_needs_features = [tests.SymlinkFeature]
+
+or ::
+
+    self.requireFeature(tests.SymlinkFeature)
+
+Bazaar versions symlinks as objects in their own right, whose content is
+the path they point to.  bzr doesn't care whether a versioned
+symlink is absolute or relative; or whether it points inside or outside
+the working tree; or whether its referent exists or not.  In Unix the
+target of a symlink is a byte string; bzr treats this as a Unicode string
+in the filesystem encoding (`osutils._fs_enc`).
+
+So when we say ``bzr add symlink``, this should always add the symlink to
+its containing working tree, and never dereference the symlink.
+
+However, ``bzr add symlink/file`` shouldn't add ``file`` as a child of
+``symlink``.  (Symlinks don't have files underneath them: they may point to
+a directory which contains children, but if the symlink was pointed
+somewhere else those children would be unaffected.)  This could either add
+the file in its containing working tree, or fail outright.
+
+One interesting case for this is ::
+
+    bzr add ~/dev/bug123/a.c
+
+where ``~/dev`` is actually a symlink to ``/srv/dev/joe/``.  In this case
+clearly the user does want us to follow the symlink to open the tree.
+
+As of bzr2.2, when we open a `WorkingTree`, we typically immediately
+compute its real path and store that as ``.basedir``, but `BzrDir` stores
+its apparent path.  (This may not be the best thing.)
+
+
+Useful functions
+----------------
+
+`bzrlib.osutils.dereference_path` does the commonly useful operation of
+resolving the directory part of a path, but leaving the filename
+untouched.  In other words ::
+
+  ln -s x a
+  ln -s y x/b
+  dereference_path('a/b') => 'x/b'
+
+
+Relative paths beyond symlinks
+------------------------------
+
+Another interesting case is when a control directory contains a relative
+path, perhaps from a branch to its master or from a working tree to its
+branch.  If it contains ``../`` parts as it typically will, these may have
+different effects depending on whether they're looked up relative to the
+real path or the apparent path given by the user.  It may be that some
+users expect different behaviours at different times.  
+
+Resolving the path relative to the real directory makes it somewhat more
+consistent with what you would see by in a shell entering that directory
+and then opening the given name.  It may also make things more consistent
+when there are multiple links to the same bzrdir.  However it may cause
+problems when using a transport that hides symlinks.
+
+We could possibly handle this by doing less path arithmetic and asking the
+OS or server to open the path including ``..`` and other relative
+elements, but that might cause other problems.  HTTP servers may do their
+own path arithmetic before passing it to the OS.
+
+
+Transports that hide symlinks
+-----------------------------
+
+On local, sftp and bzr+ssh transports, we can directly see symlinks as
+symlinks.  Over http (and ftp?) they're expanded by the server and we
+cannot detect them.  This can cause problems when bzr follows relative
+paths because typically we will join the paths, and we may do this
+inconsistently with how the server, which can see the symlinks, would do.
+
+
+Symlinks and ChrootTransports
+-----------------------------
+
+bzr has an internal concept of a `ChrootTransport` that locks access into
+a particular directory.  Symlinks should not break out of a chroot jail
+which implies they should be expanded and checked within bzrlib.
+(At least as long as the transport lets us see the symlink; otherwise it
+may not be possible.) 
+
+
+ .. vim: ft=rst sw=4

=== modified file 'doc/en/Makefile'
--- doc/en/Makefile	2010-03-25 10:09:32 +0000
+++ doc/en/Makefile	2010-07-05 12:40:28 +0000
@@ -112,3 +112,7 @@
 	$(SPHINXBUILD) -b doctest $(ALLSPHINXOPTS) _build/doctest
 	@echo "Testing of doctests in the sources finished, look at the " \
 	      "results in _build/doctest/output.txt."
+
+texinfo:
+	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) _build/texinfo
+

=== modified file 'doc/en/conf.py'
--- doc/en/conf.py	2010-05-26 04:26:59 +0000
+++ doc/en/conf.py	2010-07-05 12:40:28 +0000
@@ -13,8 +13,7 @@
 sys.path = [os.path.abspath('../..')] + sys.path
 
 # Most of the configuration for Bazaar docs is defined here ...
-from bzrlib.doc_generate.sphinx_conf import *
-
+from bzrlib.doc_generate.conf import *
 
 ## Configuration specific to this site ##
 

=== modified file 'doc/en/mini-tutorial/index.txt'
--- doc/en/mini-tutorial/index.txt	2009-12-03 00:44:16 +0000
+++ doc/en/mini-tutorial/index.txt	2010-07-05 15:50:19 +0000
@@ -64,7 +64,7 @@
  $ mkdir subdirectory
  $ touch test1.txt test2.txt test3.txt subdirectory/test4.txt
 
-**Note for Windows users:** use Windows Explorer to create your
+**Note for Windows users**: use Windows Explorer to create your
 directories, then right-click in those directories and select
 ``New file`` to create your files.
 
@@ -164,7 +164,7 @@
 
  $ bzr branch http://www.example.com/myproject
 
-**Note:** to use sftp, you may need to install ``paramiko`` and
+**Note**: to use sftp, you may need to install ``paramiko`` and
 ``pyCrypto``. See http://bazaar-vcs.org/InstallationFaq for details.
 
 
@@ -186,7 +186,7 @@
 
 .. [#] Use of the ``lp:`` URL scheme requires bzr 0.92 or later.
 
-**Note:** ``+junk`` means that this branch isn't associated with any particular
+**Note**: ``+junk`` means that this branch isn't associated with any particular
 project in Launchpad.
 
 Now, anyone can create their own copy of your branch by typing::

=== modified file 'doc/es/conf.py'
--- doc/es/conf.py	2009-09-09 15:51:18 +0000
+++ doc/es/conf.py	2010-07-07 15:03:14 +0000
@@ -13,7 +13,7 @@
 sys.path = [os.path.abspath('../..')] + sys.path
 
 # Most of the configuration for Bazaar docs is defined here ...
-from bzrlib.doc_generate.sphinx_conf import *
+from bzrlib.doc_generate.conf import *
 
 
 ## Configuration specific to this site ##

=== modified file 'doc/ja/conf.py'
--- doc/ja/conf.py	2009-11-18 06:18:14 +0000
+++ doc/ja/conf.py	2010-07-07 15:03:14 +0000
@@ -13,7 +13,7 @@
 sys.path = [os.path.abspath('../..')] + sys.path
 
 # Most of the configuration for Bazaar docs is defined here ...
-from bzrlib.doc_generate.sphinx_conf import *
+from bzrlib.doc_generate.conf import *
 
 
 ## Configuration specific to this site ##

=== modified file 'doc/ru/conf.py'
--- doc/ru/conf.py	2009-09-09 15:51:18 +0000
+++ doc/ru/conf.py	2010-07-07 15:03:14 +0000
@@ -13,7 +13,7 @@
 sys.path = [os.path.abspath('../..')] + sys.path
 
 # Most of the configuration for Bazaar docs is defined here ...
-from bzrlib.doc_generate.sphinx_conf import *
+from bzrlib.doc_generate.conf import *
 
 
 ## Configuration specific to this site ##

=== modified file 'setup.py'
--- setup.py	2010-07-05 14:16:45 +0000
+++ setup.py	2010-08-02 19:56:52 +0000
@@ -9,6 +9,7 @@
 import os
 import os.path
 import sys
+import copy
 
 if sys.version_info < (2, 4):
     sys.stderr.write("[ERROR] Not a supported Python version. Need 2.4+\n")
@@ -557,6 +558,8 @@
                                      company_name = "Canonical Ltd.",
                                      comments = META_INFO['description'],
                                     )
+    gui_target = copy.copy(target)
+    gui_target.dest_base = "bzrw"
 
     packages = BZRLIB['packages']
     packages.remove('bzrlib')
@@ -647,7 +650,7 @@
     console_targets = [target,
                        'tools/win32/bzr_postinstall.py',
                        ]
-    gui_targets = []
+    gui_targets = [gui_target]
     data_files = topics_files + plugins_files
 
     if 'qbzr' in plugins:
@@ -692,15 +695,28 @@
                                "dll_excludes": dll_excludes,
                                "dist_dir": "win32_bzr.exe",
                                "optimize": 2,
+                               "custom_boot_script":
+                                        "tools/win32/py2exe_boot_common.py",
                               },
                    }
+
+    # We want the libaray.zip to have optimize = 2, but the exe to have
+    # optimize = 1, so that .py files that get compilied at run time
+    # (e.g. user installed plugins) dont have their doc strings removed.
+    class py2exe_no_oo_exe(py2exe.build_exe.py2exe):
+        def build_executable(self, *args, **kwargs):
+            self.optimize = 1
+            py2exe.build_exe.py2exe.build_executable(self, *args, **kwargs)
+            self.optimize = 2
+
     if __name__ == '__main__':
         setup(options=options_list,
               console=console_targets,
               windows=gui_targets,
               zipfile='lib/library.zip',
               data_files=data_files,
-              cmdclass={'install_data': install_data_with_bytecompile},
+              cmdclass={'install_data': install_data_with_bytecompile,
+                        'py2exe': py2exe_no_oo_exe},
               )
 
 else:

=== modified file 'tools/generate_release_notes.py'
--- tools/generate_release_notes.py	2009-09-03 05:09:22 +0000
+++ tools/generate_release_notes.py	2010-05-05 17:04:30 +0000
@@ -20,8 +20,6 @@
 import sys
 from optparse import OptionParser
 
-sys.path.insert(0, os.path.dirname(os.path.dirname(__file__)))
-
 
 def split_into_topics(lines, out_file, out_dir):
     """Split a large NEWS file into topics, one per release.
@@ -32,7 +30,7 @@
     """
     topic_file = None
     for index, line in enumerate(lines):
-        maybe_new_topic = line[:4] in ['bzr ', 'bzr-0',]
+        maybe_new_topic = line[:4] in ('bzr ', 'bzr-',)
         if maybe_new_topic and lines[index + 1].startswith('####'):
             release = line.strip()
             if topic_file is None:
@@ -45,13 +43,22 @@
         elif topic_file:
             topic_file.write(line)
         else:
+            # FIXME: the 'content' directive is used for rst2html (and
+            # conflicts with the 'toctree' we insert), we should get rid of
+            # that once we fully switch to sphinx -- vila 20100505
+            if (line.startswith('.. contents::')
+                or line.startswith('   :depth:')):
+                    continue
             # Still in the header - dump content straight to output
             out_file.write(line)
+    if topic_file is not None:
+        # Close the last topic_file opened
+        topic_file.close()
 
 
 def open_topic_file(out_file, out_dir, release):
     topic_name = release.replace(' ', '-')
-    out_file.write("   %s\n" % (topic_name,))
+    out_file.write("   %s <%s>\n" % (release, topic_name,))
     topic_path = os.path.join(out_dir, "%s.txt" % (topic_name,))
     result = open(topic_path, 'w')
     result.write("%s\n" % (release,))

=== added file 'tools/win32/py2exe_boot_common.py'
--- tools/win32/py2exe_boot_common.py	1970-01-01 00:00:00 +0000
+++ tools/win32/py2exe_boot_common.py	2010-08-02 16:12:01 +0000
@@ -0,0 +1,35 @@
+# Common py2exe boot script - executed for all target types.
+
+# In the standard py2exe boot script, it setup stderr so that anything written
+# to it will be written to exe.log, and a message dialog is shown.
+# For Bazaar, we log most things to .bzr.log, and there are many things that
+# write to stderr, that are not errors, and so we don't want the py2exe dialog
+# message, So also blackhole stderr.
+
+import sys
+if sys.frozen == "windows_exe":
+
+    class Blackhole(object):
+        softspace = 0
+        def write(self, text):
+            pass
+        def flush(self):
+            pass
+    sys.stdout = Blackhole()
+    sys.stderr = Blackhole()
+    del Blackhole
+del sys
+
+# Disable linecache.getline() which is called by
+# traceback.extract_stack() when an exception occurs to try and read
+# the filenames embedded in the packaged python code.  This is really
+# annoying on windows when the d: or e: on our build box refers to
+# someone elses removable or network drive so the getline() call
+# causes it to ask them to insert a disk in that drive.
+import linecache
+def fake_getline(filename, lineno, module_globals=None):
+    return ''
+linecache.orig_getline = linecache.getline
+linecache.getline = fake_getline
+
+del linecache, fake_getline

